#!/usr/bin/perl
use File::Basename;
use Cwd 'abs_path';
#where script and cas programs are
$bindir=dirname(abs_path(__FILE__));

$native = $ARGV[0];
$model  = $ARGV[1];
$algo   = $ARGV[2];
$output = $ARGV[3];

if($#ARGV != 3)
{
    printf "native model algorithm\n";
    exit();
}
if(-s "$native" <10)
{
    printf "$native is empty\n";
    exit();
}
if(-s "$model" <10)
{
    printf "$model is empty\n";
    exit();
}


$nativename  = $native;
$nativename  =~s/\.pdb//g;
$native      ="$nativename\.pdb";
$modelname   = $model;
$modelname   =~s/\.pdb//g;
$model       ="$modelname\.pdb";

@rsts=`$bindir/$algo $model $native`;
for(my $i=0;$i<$#rsts;$i++)
{
   if($rsts[$i]=~/\s+1\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/)
   {
      $tra[0]=$1;
      $rot[0][0]=$2;
      $rot[0][1]=$3;
      $rot[0][2]=$4;
   }
   if($rsts[$i]=~/\s+2\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/){
      $tra[1]=$1;
      $rot[1][0]=$2;
      $rot[1][1]=$3;
      $rot[1][2]=$4;
   }
   if($rsts[$i]=~/\s+3\s+(\S+)\s+(\S+)\s+(\S+)\s+(\S+)/){
      $tra[2]=$1;
      $rot[2][0]=$2;
      $rot[2][1]=$3;
      $rot[2][2]=$4;
   }
}
$k=0;
$ii =1;
open(WFL,">$output");
open(FL,"$native");
while(my $line=<FL>)
{  
    if(($line=~/^ATOM/)||($line=~/^HETATM/))
    {
	substr($line,21,1)  = sprintf "%1s",'Q';	
	printf WFL "$line";
    }
    else{printf WFL "$line";} 
}
close(FL);

open(FL,"$model");
while(my $line=<FL>)
{  
    if(($line=~/^ATOM/)||($line=~/^HETATM/))
    {
	substr($line,21,1)  = sprintf "%1s",'T';
	$n[$k]=substr($line,21,5);
	$x=substr($line,30,8) + 0.0;
	$y=substr($line,38,8) + 0.0;
	$z=substr($line,46,8) + 0.0;
	$nx=$rot[0][0]*$x+$rot[0][1]*$y+$rot[0][2]*$z+$tra[0];
	$ny=$rot[1][0]*$x+$rot[1][1]*$y+$rot[1][2]*$z+$tra[1];
	$nz=$rot[2][0]*$x+$rot[2][1]*$y+$rot[2][2]*$z+$tra[2];
	
	$nnx[$k]=$nx;
	$nny[$k]=$ny;
	$nnz[$k]=$nz;
	printf WFL "%30s%8.3f%8.3f%8.3f\n",substr($line,0,30),$nx,$ny,$nz;
	$k++;
	$ii++;
    }
    else{printf WFL "$line";} 
}
close(WFL);
close(FL);
exit();
