*******************************************************************************
*     This program is used for predicting binding sites in protein structures *
*     Please address comments/bug-reports to: ambyroy@umich.edu               *
*******************************************************************************
      program EClocal
      PARAMETER(NMAX=2500)      !number of residue      
      PARAMETER(NMAX2=20000)    !number of atoms
      PARAMETER(NMAX3=40000)    !number of atoms
      PARAMETER(NAA=23)         !type of amino acid           
      COMMON/MATRIX/B(NAA,NAA)
      COMMON/LENGTH/IQRES, ITRES, d0
      COMMON/CORD/XA(3,NMAX,6,0:4)
      COMMON/CORD1/QBB_CRD(3,NMAX,5,0:1),IQBB(NMAX),XYZ(3,NMAX,5)
      COMMON/CORD2/TBB_CRD(3,NMAX,5),ITBB(NMAX),TATMCRD(3,NMAX2)      
      COMMON/SEQN/ITBS(NMAX),IQBS(NMAX),ISEQ1(NMAX),ISEQ2(NMAX)
      COMMON/DP/SCORE(NMAX,NMAX),gap_open,invmap(NMAX),ITBN,IQBN,GAP_EXT     
      COMMON/MAPPING/IMAPT(NMAX),IMAPQ(NMAX)
      COMMON/SCORES/BScore,SID,DIS,IALN
      COMMON/CLIGAND/HATMCRD2(3,NMAX,0:2),IHATOM,CONTACT2(NMAX,NMAX)

        
      CHARACTER*100    FNAME,files(4),line,TFPATH,TLNAME,TNAME,OUTNAME
      CHARACTER*900    BSLINE
      
      double precision V1(3,NMAX2),V2(3,NMAX2),V3(3,NMAX),w(NMAX2)
      double precision U(3,3), T(3), GC1(3), GC2(3), RESDIST(NMAX,NMAX) 
      double precision SQRMSD,SPHERE_R, RMSDOLD,  RESDIST2(NMAX,NMAX)         
      double precision QSC_CRD(3,NMAX2),TSC_CRD(3,NMAX2),DIFF
      double precision FR(4,NMAX,NMAX)  
      CHARACTER seq1(NMAX),seq2(NMAX)
      INTEGER   ITBSITE(NMAX),IPBRES(NMAX,NMAX)
      REAL      SUMD, OLDDIST, ALNDIST(NMAX),PROFILE(NMAX)
      INTEGER   IALNR(NMAX),ISC(NMAX),IATOM,NSTR,IBSITE,IRES
      INTEGER   NVEC1,NVEC2,NVEC,N,L
      INTEGER   ITFRAG(NMAX3,3),IQFRAG(NMAX3,3),IQPBRES(NMAX)
      DIMENSION QATMCRD(3,NMAX2,0:1)
      DATA W/NMAX2*1.0/

      CHARACTER*4 ANAME,RNAME,RNAME_OLD,QATMNAM(NMAX2),TATMNAM(NMAX2)
      CHARACTER*4 QRESNAM(NMAX2),TRESNAM(NMAX2),STRING,BSNAME
      CHARACTER*4 QBB_NAM(NMAX,5),TBB_NAM(NMAX,5)
      CHARACTER*6 DUMMY
      INTEGER     IQATOM,ITATOM,IQRES,ITRES,QIRES(NMAX2),TIRES(NMAX2)
      CHARACTER*3 AA(0:23),LNAME  

      double precision HATMCRD(3,NMAX),CONTACT(NMAX,NMAX),XYZF(3,NMAX)
      CHARACTER*30     HATMREC(NMAX,2),QATMREC(NMAX)

      DATA AA/ 'BCK','ALA','ARG','ASN','ASP','CYS',
     &         'GLN','GLU','GLY','HIS','ILE','LEU',
     &         'LYS','MET','PHE','PRO','SER','THR',
     &         'TRP','TYR','VAL','UNK','ASX','GLX'/      
      CHARACTER*1 SLC(0:23)
      DATA SLC/'X','A','R','N','D','C',
     &         'Q','E','G','H','I','L',
     &         'K','M','F','P','S','T',
     &         'W','Y','V','X','B','Z'/      
      CHARACTER SEQW(23)
      DATA SEQW/'A','R','N','D','C',
     &          'Q','E','G','H','I',
     &          'L','K','M','F','P',
     &          'S','T','W','Y','V',
     &          'X','B','Z'/          
      CALL BLOSSUM 
      d0      = 3.0
      GAP_OPEN=-1.0
      GAP_EXT =-1.0
      l_out   = 0
      
c     Read File names (1) Profile (2) Query (3) Template
      narg=iargc()
      
      CALL getarg(1,FNAME)      !query profile  filename
      files(1) =FNAME
      CALL getarg(2,FNAME)      !query PDBfilename
      files(2) =FNAME
      call getarg(3,TFPATH)     
      
      IF(narg.gt.3)then
         DO iarg=1,narg
            call getarg(iarg,FNAME)
            IF((FNAME.eq.'-c').or.(FNAME.eq.'-C'))THEN
               l_out=1  
            END IF  
         END DO
      end if

c      CALL getarg(3,FNAME)     !template PDBfilename
c      files(3) =FNAME
     
      OPEN(unit=10,file=files(1),status='old')
      DO WHILE (.true.)
         read(10,1012,end=1011)i,PROFILE(i)
      END DO
 1011 CONTINUE
      CLOSE(10)
 1012 FORMAT(I4,2X,F5.2)

c     Start reading query protein
      IQATOM   = 0
      IQRES    = 0
      IRES_OLD = 0
      RNAME_OLD=''
      IBB      = 0
      ISCN     = 0              
      OPEN(unit=20,file=files(2),status='old')
      DO WHILE (.TRUE.)
         read(20,2000,end=2011)line
         if(line(1:3).eq.'TER')goto 2011
         if(line(1:4).eq."ATOM")then
            READ (LINE,2001) DUMMY, IATOM, ANAME, RNAME, IRES, X, Y, Z
            ANAME   = ADJUSTL (ANAME)
            RNAME   = ADJUSTL (RNAME)          
            IQATOM  = IQATOM + 1         
            QATMNAM(IQATOM)  = ANAME
            QRESNAM(IQATOM)  = RNAME
            QATMREC(IQATOM)    =line(1:30)
            QATMCRD(1,IQATOM,0)= X
            QATMCRD(2,IQATOM,0)= Y
            QATMCRD(3,IQATOM,0)= Z
            IF (( RNAME /= RNAME_OLD ) .OR. ( IRES /= IRES_OLD ) ) THEN
               IRES_OLD    = IRES
               RNAME_OLD   = RNAME
               IQRES       = IQRES + 1
               ISEQ1(IQRES)= 0
               DO I=1,NAA
                  if(AA(I).eq.RNAME)ISEQ1(IQRES)= I             
               END DO       
               IBB        = 0
               ISCN       = 0
               ISC(ITRES) = 0
            END IF
            QIRES(IQATOM)  = IQRES
            IF((ANAME.eq.'CA').or.(ANAME.eq.'N').or.(ANAME.eq.'C').
     &           or.(ANAME.eq.'O'))THEN
c     Backbone atoms
               IBB = IBB + 1
               QBB_CRD(1,IQRES,IBB,0) = X
               QBB_CRD(2,IQRES,IBB,0) = Y
               QBB_CRD(3,IQRES,IBB,0) = Z
               QBB_NAM(IQRES,IBB)     = ANAME
               IQBB(IQRES)            = IBB             
           ELSE
c     Sidechain atoms
               ISCN             = ISCN + 1
               QSC_CRD(1,IQRES) = QSC_CRD(1,IQRES) +  X
               QSC_CRD(2,IQRES) = QSC_CRD(2,IQRES) +  Y
               QSC_CRD(3,IQRES) = QSC_CRD(3,IQRES) +  Z
               ISC(IQRES)       = ISCN
            END IF
         END IF
      END DO
 2011 CONTINUE 
      CLOSE(20)
 2000 FORMAT(A100)                              !Line(length=100)   
 2001 FORMAT(A6,I5,1X,A4,1X,A3,2X,I4,4X,3F8.3)  !PDB  format
 2002 FORMAT('Template=',A6,1X,A3,1X,A4,', BS=',f6.4,', LTM=',f6.4,
     &  ', SID=',f6.4', COV=',f6.4', ERR=',f7.4', IDALI1=',f6.4
     &  ', IDALI2=',f6.4)
 2003 FORMAT(I4,2X,A3,4X,I4,2X,A3,3X,F5.2,2X,F5.2)
 2004 FORMAT(I4,2X,A3,4X,I4,2X,A3,3X,F5.2,2X,F5.2,' *')
 2005 FORMAT(A30,3F8.3,A25)
 2010 FORMAT(A3)   !PDB  format
 4000 FORMAT(A5,2X,A3,1X,A4,1X,I4,1X,A900)
  204 FORMAT(I2,f18.10,f15.10,f15.10,f15.10)

c     Get CABS structure for Query
      DO I=1,IQRES
         IF(ISC(I).GT.0)THEN        
            DO J =1,3             
               K               = IQBB(I)+1
               QSC_CRD(J,I)    = real(QSC_CRD(J,I)/ISC(I)) !Side chain Cen.of.Mass            
               QBB_CRD(J,I,K,0)= QSC_CRD(J,I)      
            END DO
         ELSE
            DO J =1,3
               K               = IQBB(I)+1
               QSC_CRD(J,I)    = QBB_CRD(J,I,1,0)
               QBB_CRD(J,I,K,0)= QBB_CRD(J,I,1,0)
               ISC(I)          = 1
            END DO
         END IF
         IQBB(I) = K 
         QBB_NAM(I,K) = 'SG'
      END DO
      IATOM=0
      DO I=1,IQRES
         DO J=I+1,IQRES
            DISTMIN=100
            DO K=1,ISC(I)
               DO L=1,ISC(J)                 
                  DIST=sqrt((QBB_CRD(1,I,1,0)- QBB_CRD(1,J,1,0))**2
     &                 +    (QBB_CRD(2,I,1,0)- QBB_CRD(2,J,1,0))**2            
     &                 +    (QBB_CRD(3,I,1,0)- QBB_CRD(3,J,1,0))**2)
                  IF(DIST.LE.DISTMIN)THEN
                     DISTMIN=DIST 
                  END IF
               END DO
            END DO            
            RESDIST(J,I)= DISTMIN
            RESDIST(I,J)= DISTMIN                  
         END DO
      END DO

c     Start reading template proteins
      call getarg(3,TFPATH)
      DUMMY  ='list'
      TLNAME=TRIM(TFPATH)//'/'//TRIM(DUMMY)
c      TLNAME='list'
      OPEN(UNIT=40,FILE=TLNAME,STATUS='OLD')     
      READ(40,4000,end=4011)TNAME,LNAME,BSNAME,IBSITE,BSLINE 
      IBSR = 0
      ILEN=LEN(TRIM(BSLINE))
      DO J=1,ILEN,5
         STRING       = BSLINE(J:J+3)
         IBSR         = IBSR + 1
         READ(STRING,'(I4)'),IRES        
         ITBSITE(IBSR)= IRES
      END DO     
      RNAME_OLD    = ''
      IRES_OLD     = 0
      ITATOM       = 0
      ITRES        = 0
      IBB          = 0
      ISCN         = 0
      BScore_MAX   = 0
      DIS_MAX      = 0
      SID_MAX      = 0
      BScore_new   = 0
      DIS_new      = 0
      SID_new      = 0 
      GC1(1)       = 0
      GC1(2)       = 0
      GC1(3)       = 0
      GC2(1)       = 0
      GC2(2)       = 0
      GC2(3)       = 0
      IHATOM       = 0
c     TLNAME=TRIM(TFPATH)//'/'//TRIM(TNAME)//'.pdb' 
      TLNAME=TRIM(TFPATH)//'/'//TRIM(TNAME)//'.pdb'
      OPEN(unit=30,file=TRIM(TLNAME),status='old')
      DO WHILE (.TRUE.)
         read(30,2000,end=3011)line          
         if(line(1:3).eq.'TER')goto 3011        
         IF(line(1:4).eq."ATOM")then            
            READ (LINE,2001) DUMMY, IATOM, ANAME, RNAME,IRES, X, Y, Z
            ANAME   = ADJUSTL(ANAME)
            RNAME   = ADJUSTL(RNAME)            
            ITATOM  = ITATOM + 1 
            TATMNAM(ITATOM)  = ANAME
            TRESNAM(ITATOM)  = RNAME
            TATMCRD(1,ITATOM)= X
            TATMCRD(2,ITATOM)= Y
            TATMCRD(3,ITATOM)= Z
            IF (( RNAME /= RNAME_OLD ) .OR. ( IRES /= IRES_OLD ) ) THEN
               IRES_OLD    = IRES
               RNAME_OLD   = RNAME
               ITRES       = ITRES + 1
               ISEQ2(ITRES)= 0
               DO I=1,NAA
                  if(AA(I).eq.RNAME)ISEQ2(ITRES)= I             
               END DO       
               IBB        = 0
               ISCN       = 0
               ISC(ITRES)= 0
               ITBB(ITRES)= 0
               TSC_CRD(1,ITRES) = 0.0
               TSC_CRD(2,ITRES) = 0.0
               TSC_CRD(3,ITRES) = 0.0
            END IF
            TIRES(ITATOM)  = ITRES
            IF((ANAME.eq.'CA').or.(ANAME.eq.'N').or.(ANAME.eq.'C').
     &           or.(ANAME.eq.'O'))THEN
c     Backbone atoms
               IBB                  = IBB + 1
               TBB_CRD(1,ITRES,IBB) = X
               TBB_CRD(2,ITRES,IBB) = Y
               TBB_CRD(3,ITRES,IBB) = Z
               TBB_NAM(ITRES,IBB)   = ANAME
               ITBB(ITRES)          = IBB             
            ELSE
c     Sidechain atoms
               ISCN                 = ISCN + 1
               TSC_CRD(1,ITRES)     = TSC_CRD(1,ITRES) +  X
               TSC_CRD(2,ITRES)     = TSC_CRD(2,ITRES) +  Y
               TSC_CRD(3,ITRES)     = TSC_CRD(3,ITRES) +  Z
               ISC(ITRES)           = ISCN
            END IF
         END IF
      END DO
 3011 CONTINUE 
      CLOSE(30)

  
c     Get CABS structure for Template
      DO I=1,ITRES
         IF(ISC(I).GT.0)THEN           
            DO J =1,3
               K               = ITBB(I)+1
               TSC_CRD(J,I)    = real(TSC_CRD(J,I)/ISC(I)) ! Side chain Cen.Mass      
               TBB_CRD(J,I,K)  = TSC_CRD(J,I) 
            END DO
         ELSE
            DO J =1,3
               K                  = ITBB(I)+1
               TSC_CRD(J,I)       = TBB_CRD(J,I,1)
               TBB_CRD(J,I,K)     = TBB_CRD(J,I,1)
               ISC(I)             = 1              
            END DO
         END IF
         ITBB(I) = K
         TBB_NAM(I,K) = 'SG'
      END DO
      DO I=1,ITRES
         DO J=I+1,ITRES
            DISTMAX=0
            DO K=1,ITBB(I)
               DO L=1,ITBB(J)                  
                  DIST=sqrt((TBB_CRD(1,I,K)- TBB_CRD(1,J,L))**2
     &                 +    (TBB_CRD(2,I,K)- TBB_CRD(2,J,L))**2            
     &                 +    (TBB_CRD(3,I,K)- TBB_CRD(3,J,L))**2)
                  IF(DIST.GE.DISTMAX)THEN
                     DISTMAX=DIST 
                  END IF
               END DO
            END DO
            RESDIST2(J,I) = DISTMAX
            RESDIST2(I,J) = DISTMAX           
         END DO
      END DO

      IF(l_out.gt.0)THEN
         TLNAME=TRIM(TFPATH)//'/ligand/'//TRIM(TNAME)//'_'//
     &          TRIM(BSNAME)//'.pdb' 
         OUTNAME='BSITE_'//TRIM(TNAME)//'_'//TRIM(BSNAME)//'.pdb' 
         OPEN(unit=50,file=TRIM(TLNAME),status='old')
         DO WHILE (.TRUE.)
            READ(50,2000,end=5011)line          
            IF(line(1:3).eq.'TER')goto 5011                 
            READ (LINE,2001) DUMMY, IATOM, ANAME, RNAME,IRES, X, Y, Z     
            IHATOM           = IHATOM + 1 
            HATMREC(IHATOM,1)  = line(1:30)
            HATMCRD(1,IHATOM)= X
            HATMCRD(2,IHATOM)= Y
            HATMCRD(3,IHATOM)= Z
            HATMREC(IHATOM,2)  = line(55:80)
         END DO
 5011    CONTINUE
         DO I=1,IHATOM
            DO J=1,ITRES
               CONTACT(I,J)=0
            END DO
         END DO
         DO I=1,IHATOM
            DO J=1,ITRES
               DO IB=1,IBSR
                  IF(ITBSITE(IB).EQ.J) THEN
                     DO K=1,ITBB(J)
                        DIST=sqrt((TBB_CRD(1,J,K)- HATMCRD(1,I))**2
     &                       +    (TBB_CRD(2,J,K)- HATMCRD(2,I))**2            
     &                       +    (TBB_CRD(3,J,K)- HATMCRD(3,I))**2)
                        IF(DIST.LE.6)THEN
                           IF(CONTACT(I,J).EQ.0)THEN
                              CONTACT(I,J)=DIST
                           ELSEIF(DIST.LE.CONTACT(I,J))THEN
                              CONTACT(I,J)=DIST
                           END IF
                        END IF
                     END DO
                  END IF
               END DO
            ENDDO
         END DO
      END IF
      

c     #.1 If number of binding site residue in Template is 1
      IF (IBSR.EQ.1) THEN     
         SPHERE_R = 10.00       ! Defined sphere of radius=10 Ang
c     Process template (only once)
 5001    ITBN=0
         I=ITBSITE(1)           ! Template binding site residue
         DO JT=1,ITRES              
            ITBS(JT)=0            
            DO N=1,ITBB(JT)
               DIST=sqrt((TBB_CRD(1,I,N) - TBB_CRD(1,JT,N))**2
     &                 + (TBB_CRD(2,I,N) - TBB_CRD(2,JT,N))**2
     &                 + (TBB_CRD(3,I,N) - TBB_CRD(3,JT,N))**2)
               IF((DIST.LE.SPHERE_R).AND.(ITBS(JT).eq.0))THEN
                  ITBN        = ITBN + 1
                  ITBS(JT)    = ITBN
                  IMAPT(ITBN) = JT 
               END IF                   
            END DO
         END DO
c     Increase the sphere radius if less residues
         IF((ITBN.LT.15).AND.(ITBN.LT.ITRES))then
            SPHERE_R  = SPHERE_R + 0.5
            goto 5001
         END IF                           
c     Vector for Template binding site                 
         NVEC1 = 0          
         IF((I.GT.1).AND.(I.LT.(ITRES-1)))THEN
            DO K=-1,1
               L = I+K
               DO N=1,ITBB(L)                                 
                  NVEC1= NVEC1 + 1                
                  V1(1,NVEC1) = TBB_CRD(1,L,N)
                  V1(2,NVEC1) = TBB_CRD(2,L,N)
                  V1(3,NVEC1) = TBB_CRD(3,L,N)              
               END DO               
            END DO
         ELSE
               DO N=1,ITBB(I)                 
                  NVEC1= NVEC1 + 1
                  V1(1,NVEC1) = TBB_CRD(1,I,N)
                  V1(2,NVEC1) = TBB_CRD(2,I,N)
                  V1(3,NVEC1) = TBB_CRD(3,I,N)                   
               END DO
         END IF
c     Process Query
         DO I=1,IQRES
            IF((PROFILE(I).ge.0).or.
     &      (B(ISEQ1(I),ISEQ2(ITBSITE(1))).ge.0.5))then              
               IPBRES(1,I)= 1
            ELSE
               IPBRES(1,I)= 0
            END IF
            IALNR(I) = 0
         END DO
         BScore_MAX  = 0
         DIS_MAX     = 0
         SID_MAX     = 0
         DO I=1,IQRES
            IF(IPBRES(1,I).GT.0)THEN
c     Build vector for each selected residue
               NVEC2=0
               IF((I.GT.1).AND.(I.LT.(IQRES-1)))THEN
                  DO K=-1,1
                     L = I + K
                     DO N=1,IQBB(L)                      
                        NVEC2= NVEC2 + 1                
                        V2(1,NVEC2) = QBB_CRD(1,L,N,0)
                        V2(2,NVEC2) = QBB_CRD(2,L,N,0)
                        V2(3,NVEC2) = QBB_CRD(3,L,N,0)  
                     END DO
                  END DO
               ELSE
                     DO N=1,IQBB(I)        
                        NVEC2= NVEC2 + 1
                        V2(1,NVEC2) = QBB_CRD(1,I,N,0)
                        V2(2,NVEC2) = QBB_CRD(2,I,N,0)
                        V2(3,NVEC2) = QBB_CRD(3,I,N,0)  
                     END DO
               END IF
               NVEC=min(NVEC1,NVEC2)
               CALL u3b(W,V2,V1,NVEC,1,SQRMSD,U,T,ier) ! RMSD calculation

c     Superpose query on template based on the initial alignment
               DO II=1,IQRES
                  DO N=1,IQBB(II) 
                     QBB_CRD(1,II,N,1)=T(1) + U(1,1) * QBB_CRD(1,II,N,0)
     &                                      + U(1,2) * QBB_CRD(2,II,N,0)
     &                                      + U(1,3) * QBB_CRD(3,II,N,0)
                     QBB_CRD(2,II,N,1)=T(2) + U(2,1) * QBB_CRD(1,II,N,0)
     &                                      + U(2,2) * QBB_CRD(2,II,N,0)
     &                                      + U(2,3) * QBB_CRD(3,II,N,0)
                     QBB_CRD(3,II,N,1)=T(3) + U(3,1) * QBB_CRD(1,II,N,0)
     &                                      + U(3,2) * QBB_CRD(2,II,N,0)
     &                                      + U(3,3) * QBB_CRD(3,II,N,0)
                  END DO
               END DO  
c     Mark probable binding site residues in query i.e. within SPHERE_R
               IQBN = 0
               DO JQ=1,IQRES
                  IQBS(JQ)=0
                  DO N=1,IQBB(JQ) 
                    DIST=sqrt((QBB_CRD(1,I,N,1) - QBB_CRD(1,JQ,N,1))**2
     &                      + (QBB_CRD(2,I,N,1) - QBB_CRD(2,JQ,N,1))**2
     &                      + (QBB_CRD(3,I,N,1) - QBB_CRD(3,JQ,N,1))**2)
                    IF((DIST.LE.SPHERE_R).AND.(IQBS(JQ).eq.0))THEN
                       IQBN        = IQBN + 1
                       IQBS(JQ)    = IQBN
                       IMAPQ(IQBN) = JQ            
                    END IF                   
                  END DO
               END DO                                       
               BScore_old = 0.0        
               DO ITER=1,10    ! Iterate                  
                  CALL FILLMATRIX
                  CALL DYPG
                  CALL GETSCORE                  
                  IF(BScore.GT.BScore_new)THEN
                     DO JQ=1,IQRES
                        IALNR(JQ)= 0            
                     END DO
                     BScore_new = BScore
                     DIS_new    = DIS
                     SID_new    = SID
                     DO IQ=1,IQBN     
                        IF(INVMAP(IQ).gt.0)then  
                           IAQ = IMAPQ(IQ)                          
                           IAT = IMAPT(INVMAP(IQ))
                           IALNR(IAQ) = IAT
                           DIST= SQRT(
     &                           (XYZ(1,IAQ,1) - TBB_CRD(1,IAT,1))**2
     &                          +(XYZ(2,IAQ,1) - TBB_CRD(2,IAT,1))**2
     &                          +(XYZ(3,IAQ,1) - TBB_CRD(3,IAT,1))**2)
                           XYZF(1,IAQ)=XYZ(1,IAQ,1)
                           XYZF(2,IAQ)=XYZ(2,IAQ,1)
                           XYZF(3,IAQ)=XYZ(3,IAQ,1)
                           ALNDIST(IAQ)=DIST            
                        END IF
                     END DO
                  END IF                
                  IF(ITER.GT.1)THEN
                     DIFF = abs(BScore - BScore_old)                     
                     IF(DIFF.LT.0.0001) THEN                      
                        GOTO 5002
                     END IF
                  END IF
                  BScore_old = BScore   
               END DO
 5002          CONTINUE
               IF(BScore_old.GT.BScore_MAX) THEN
                  BScore_MAX = BScore_new
                  DIS_MAX    = DIS_new
                  SID_MAX    = SID_new                  
               END IF                           
            END IF
         END DO
         GOTO 8001

c   #.2 If number of binding site residue in Template is 2
      ELSE IF (IBSR.EQ.2) THEN           
         I1=ITBSITE(1)          ! Template binding site residue
         I2=ITBSITE(2)          ! Template binding site residue      
         DIST=sqrt((TBB_CRD(1,I1,1) - TBB_CRD(1,I2,1))**2
     &        +    (TBB_CRD(2,I1,1) - TBB_CRD(2,I2,1))**2
     &        +    (TBB_CRD(3,I1,1) - TBB_CRD(3,I2,1))**2)
         GC1(1)  = (TBB_CRD(1,I1,1) + TBB_CRD(1,I2,1))/2
         GC1(2)  = (TBB_CRD(2,I1,1) + TBB_CRD(2,I2,1))/2
         GC1(3)  = (TBB_CRD(3,I1,1) + TBB_CRD(3,I2,1))/2         
         SPHERE_R = (DIST/2)  +  2
         DIST_MAX =  DIST     +  3
 5003    ITBN=0
         DO JT=1,ITRES              
            ITBS(JT)=0         
            DO N=1,ITBB(JT)
               DIST=sqrt((GC1(1) - TBB_CRD(1,JT,N))**2
     &              +    (GC1(2) - TBB_CRD(2,JT,N))**2
     &              +    (GC1(3) - TBB_CRD(3,JT,N))**2)
               IF((DIST.LE.SPHERE_R).AND.(ITBS(JT).eq.0))THEN
                  ITBN        = ITBN + 1
                  ITBS(JT)    = ITBN
                  IMAPT(ITBN) = JT 
               END IF                   
            END DO
         END DO 
         IF((ITBN.LT.15).AND.(ITBN.LT.ITRES))then
            SPHERE_R  = SPHERE_R + 0.5
            goto 5003
         END IF          
c     Vectors for Template binding site                 
         NVEC1 = 0
         DO I=1,ITRES
            IF(ITBS(I).GT.0) THEN     
               IF((I.GT.1).AND.(I.LT.(ITRES-1)))THEN
                  DO K=-1,1
                     L = I + K
                     DO N=1,ITBB(L)                                        
                        NVEC1= NVEC1 + 1                
                        V1(1,NVEC1) = TBB_CRD(1,L,N)
                        V1(2,NVEC1) = TBB_CRD(2,L,N)
                        V1(3,NVEC1) = TBB_CRD(3,L,N)              
                     END DO               
                  END DO
               ELSE
                  DO N=1,ITBB(I)                 
                     NVEC1= NVEC1 + 1
                     V1(1,NVEC1) = TBB_CRD(1,I,N)
                     V1(2,NVEC1) = TBB_CRD(2,I,N)
                     V1(3,NVEC1) = TBB_CRD(3,I,N)                   
                  END DO
               END IF
            END IF
         END DO
         NVEC3 = 0
         DO I=1,ITRES
            DO J=1,IBSR
               IF(ITBSITE(J).EQ.I)THEN     
                  IF((I.GT.1).AND.(I.LT.(ITRES-1)))THEN
                     DO K=-1,1
                        L = I + K
                        DO N=1,ITBB(L)                                         
                           NVEC3= NVEC3 + 1                
                           V3(1,NVEC3) = TBB_CRD(1,L,N)
                           V3(2,NVEC3) = TBB_CRD(2,L,N)
                           V3(3,NVEC3) = TBB_CRD(3,L,N)              
                        END DO               
                     END DO
                  ELSE
                     DO N=1,ITBB(I)                 
                        NVEC3= NVEC3 + 1
                        V3(1,NVEC3) = TBB_CRD(1,I,N)
                        V3(2,NVEC3) = TBB_CRD(2,I,N)
                        V3(3,NVEC3) = TBB_CRD(3,I,N)                   
                     END DO
                  END IF
               END IF
            END DO
         END DO  
c        Process Query
         DO J=1,IBSR    
            DO I=1,IQRES
               IF((PROFILE(I).ge.0).or.
     &              (B(ISEQ1(I),ISEQ2(ITBSITE(J))).ge.0.5))then    
c               IF(PROFILE(I).ge.0)then              
                  IPBRES(J,I)= 1
               ELSE
                  IPBRES(J,I)= 0
               END IF
               IALNR(I) = 0
            END DO
         END DO
         BScore_MAX  = 0
         DIS_MAX     = 0
         SID_MAX     = 0
         DO J=1,IBSR    
            DO I=1,IQRES
               IF(IPBRES(J,I).GT.0)THEN
                  DO JJ = J + 1, IBSR
                     DO II=I+1, IQRES
                        if(RESDIST(I,II).GT.DIST_MAX)goto 5004  
                        IF(IPBRES(JJ,II).GT.0)THEN
                           NVEC2=0
                           IF((I.GT.1).AND.(I.LT.(IQRES-1)))THEN
                              DO K=-1,1
                                 DO N=1,IQBB(I+K)
                                    L = I + K
                                    NVEC2= NVEC2 + 1                
                                    V2(1,NVEC2) = QBB_CRD(1,L,N,0)
                                    V2(2,NVEC2) = QBB_CRD(2,L,N,0)
                                    V2(3,NVEC2) = QBB_CRD(3,L,N,0)  
                                 END DO
                              END DO
                           ELSE
                              DO N=1,IQBB(I)        
                                 NVEC2= NVEC2 + 1
                                 V2(1,NVEC2) = QBB_CRD(1,I,N,0)
                                 V2(2,NVEC2) = QBB_CRD(2,I,N,0)
                                 V2(3,NVEC2) = QBB_CRD(3,I,N,0)  
                              END DO
                           END IF
                           IF((II.GT.1).AND.(II.LT.(IQRES-1)))THEN
                              DO K=-1,1
                                 DO N=1,IQBB(II+K)
                                    L = II + K
                                    NVEC2= NVEC2 + 1                
                                    V2(1,NVEC2) = QBB_CRD(1,L,N,0)
                                    V2(2,NVEC2) = QBB_CRD(2,L,N,0)
                                    V2(3,NVEC2) = QBB_CRD(3,L,N,0)  
                                 END DO
                              END DO
                           ELSE
                              DO N=1,IQBB(II)        
                                 NVEC2= NVEC2 + 1
                                 V2(1,NVEC2) = QBB_CRD(1,II,N,0)
                                 V2(2,NVEC2) = QBB_CRD(2,II,N,0)
                                 V2(3,NVEC2) = QBB_CRD(3,II,N,0)  
                              END DO
                           END IF                                                                                 
                           NVEC=min(NVEC2,NVEC3)
                           CALL u3b(W,V2,V3,NVEC,1,SQRMSD,U,T,ier)
c                          Superpose query on template based on the initial alignment
                           DO INQ=1,IQRES
                              DO N=1,IQBB(INQ) 
                                 QBB_CRD(1,INQ,N,1)= T(1)  
     &                                +     U(1,1) * QBB_CRD(1,INQ,N,0)
     &                                +     U(1,2) * QBB_CRD(2,INQ,N,0)
     &                                +     U(1,3) * QBB_CRD(3,INQ,N,0)
                                 QBB_CRD(2,INQ,N,1)=T(2) 
     &                                +     U(2,1) * QBB_CRD(1,INQ,N,0)
     &                                +     U(2,2) * QBB_CRD(2,INQ,N,0)
     &                                +     U(2,3) * QBB_CRD(3,INQ,N,0)
                                 QBB_CRD(3,INQ,N,1)=T(3) 
     &                                +     U(3,1) * QBB_CRD(1,INQ,N,0)
     &                                +     U(3,2) * QBB_CRD(2,INQ,N,0)
     &                                +     U(3,3) * QBB_CRD(3,INQ,N,0)
                              END DO
                           END DO

                           GC2(1)=(QBB_CRD(1,I,1,1)+QBB_CRD(1,II,1,1))/2
                           GC2(2)=(QBB_CRD(2,I,1,1)+QBB_CRD(2,II,1,1))/2
                           GC2(3)=(QBB_CRD(3,I,1,1)+QBB_CRD(3,II,1,1))/2       
c                          Mark probable binding site residues in query i.e. within SPHERE_R
                           IQBN = 0
                           DO JQ=1,IQRES
                              IQBS(JQ)=0
                              DO N=1,IQBB(JQ) 
                              DIST=sqrt(
     &                        (GC2(1)-QBB_CRD(1,JQ,N,1))**2
     &                      + (GC2(2)-QBB_CRD(2,JQ,N,1))**2
     &                      + (GC2(3)-QBB_CRD(3,JQ,N,1))**2)
                              IF((DIST.LE.SPHERE_R).AND.
     &                             (IQBS(JQ).eq.0))THEN
                                 IQBN        = IQBN + 1
                                 IQBS(JQ)    = IQBN
                                 IMAPQ(IQBN) = JQ            
                              END IF                   
                              END DO
                           END DO                           
                           BScore_old = 0.0        
                           DO ITER=1,10 ! Iterate                  
                              CALL FILLMATRIX
                              CALL DYPG
                              CALL GETSCORE                              
                              IF(BScore.GT.BScore_new)THEN
                                 DO JQ=1,IQRES
                                    IALNR(JQ)= 0            
                                 END DO
                                 BScore_new = BScore
                                 DIS_new    = DIS
                                 SID_new    = SID
                                 DO IQ=1,IQBN     
                                    IF(INVMAP(IQ).gt.0)then  
                                       IAQ = IMAPQ(IQ)                          
                                       IAT = IMAPT(INVMAP(IQ))
                                       IALNR(IAQ) = IAT                                 
                                       DIST= SQRT(
     &                             (XYZ(1,IAQ,1) - TBB_CRD(1,IAT,1))**2
     &                            +(XYZ(2,IAQ,1) - TBB_CRD(2,IAT,1))**2
     &                            +(XYZ(3,IAQ,1) - TBB_CRD(3,IAT,1))**2)
                                       XYZF(1,IAQ)=XYZ(1,IAQ,1)
                                       XYZF(2,IAQ)=XYZ(2,IAQ,1)
                                       XYZF(3,IAQ)=XYZ(3,IAQ,1)
                                       ALNDIST(IAQ)=DIST
                                    END IF
                                 END DO
                              END IF                
                              IF(ITER.GT.1)THEN
                                 DIFF = abs(BScore - BScore_old)                     
                                 IF(DIFF.LT.0.0001) THEN                                     
                                    GOTO 5004
                                 END IF
                              END IF
                              BScore_old = BScore   
                           END DO
                        END IF
 5004                   CONTINUE
                     END DO
                     IF(BScore_new.GT.BScore_MAX) THEN
                        BScore_MAX = BScore_new
                        DIS_MAX    = DIS_new
                        SID_MAX    = SID_new
                     END IF            
                  END DO
               END IF
            END DO         
         END DO
         GOTO 8001
      ELSE
         ITBN=0
         DIST_MAX = 0
         cut1     = 0.2
         jump1    = 1
         jump2    = 2
         diff     = 1
         ITERN    = 5         
         IF(IQRES.GE.400)THEN
            jump1=2
            jump2=2
            cut1 =0.3
            ITERN= 3
         END IF
         IF(IBSR.GT.8)THEN
            jump1=2
            jump2=2
            diff =2
            cut1 =0.3
            ITERN= 3
         END IF
         
         
         DO I=1,IBSR
            I1=ITBSITE(I)       ! Template binding site residue
            DO J=I+1,IBSR               
               I2=ITBSITE(J)    ! Template binding site residue           
               DO N=1,ITBB(I1)
                  DO M =1,ITBB(I2)
                     DIST=sqrt((TBB_CRD(1,I1,1) - TBB_CRD(1,I2,1))**2
     &                    +    (TBB_CRD(2,I1,1) - TBB_CRD(2,I2,1))**2
     &                    +    (TBB_CRD(3,I1,1) - TBB_CRD(3,I2,1))**2)
                     IF(DIST.GE.DIST_MAX)DIST_MAX=DIST
                  END DO
               END DO
            END DO
           GC1(1)  = GC1(1) + TBB_CRD(1,I1,1)
           GC1(2)  = GC1(2) + TBB_CRD(2,I1,1)
           GC1(3)  = GC1(3) + TBB_CRD(3,I1,1)
         END DO       

         SPHERE_R =  DIST_MAX/2
         DIST_MAX =  DIST_MAX 
         GC1(1)  = GC1(1)/IBSR
         GC1(2)  = GC1(2)/IBSR
         GC1(3)  = GC1(3)/IBSR
         DO JT=1,ITRES              
            ITBS(JT)=0         
            DO N=1,ITBB(JT)
               DIST=sqrt((GC1(1) - TBB_CRD(1,JT,N))**2
     &              +    (GC1(2) - TBB_CRD(2,JT,N))**2
     &              +    (GC1(3) - TBB_CRD(3,JT,N))**2)
               IF((DIST.LE.SPHERE_R).AND.(ITBS(JT).eq.0))THEN
                  ITBN        = ITBN + 1
                  ITBS(JT)    = ITBN
                  IMAPT(ITBN) = JT 
               END IF                   
            END DO
         END DO

c        Process Query  
         DO I=1,IQRES          
            IALNR(I) = 0
         END DO
         ITFRAGN=0     
         DO J=1,IBSR
            JR=ITBSITE(J) 
            DO JJ=J+1,IBSR
               JJR=ITBSITE(JJ)
               DIST12=JJR-JR
               DO JJJ=JJ+1,IBSR
                  JJJR=ITBSITE(JJJ)
                  DIST23=JJJR-JJR                 
                  IF((DIST12.GT.1).AND.(DIST23.GT.1))THEN
                     ITFRAGN = ITFRAGN + 1                     
                     ITFRAG(ITFRAGN,1)=JR
                     ITFRAG(ITFRAGN,2)=JJR
                     ITFRAG(ITFRAGN,3)=JJJR
                  END IF
               END DO
            END DO
         END DO

         cut1 = 0.1
 7000    IQMAX=0
         DO I=1,IQRES          
            IALNR(I) = 0
            IF(PROFILE(I).GT.cut1)THEN
               IQMAX         = IQMAX + 1
               IQPBRES(IQMAX)= I
            END IF
         END DO

         IQFRAGN=0
        
         DO J=1,IQMAX
            JR=IQPBRES(J) 
            DO JJ=J+1,IQMAX
               JJR=IQPBRES(JJ)
               DIST12=JJR-JR
               DIST121=RESDIST(JR,JJR)
               ILRES  = -2
               DO JJJ=JJ+1,IQMAX
                  JJJR=IQPBRES(JJJ)
                  DIST23=JJJR-JJR
                  DIST231=RESDIST(JJR,JJJR)
                  DIST232=JJJR-ILRES
                  
                  IF((DIST12.GT.diff).AND.(DIST121.LE.DIST_MAX).AND.
     &               (DIST23.GT.diff).AND.(DIST231.LE.DIST_MAX).AND.
     &               (DIST232.GT.1))THEN
                     IQFRAGN = IQFRAGN + 1    
                     IF((IQFRAGN.GE.NMAX3).AND.(cut1.LT.0.7))THEN
                        cut1 = cut1 + 0.1
                        GOTO 7000
                     ELSEIF(IQFRAGN.GE.NMAX3)THEN
		        GOTO 7002
                     END IF
                     IQFRAG(IQFRAGN,1)=JR
                     IQFRAG(IQFRAGN,2)=JJR
                     IQFRAG(IQFRAGN,3)=JJJR
                     ILRES = JJJR                  
                  END IF
               END DO
            END DO
         END DO
     

 7002    DO J=1,ITFRAGN,jump1
            NVEC1 = 0
            DO M=1,3
               JR=ITFRAG(J,M)                           
               IF((JR.GT.1).AND.(JR.LT.(ITRES-1)))THEN
                  DO K=-1,1
                     L      = JR + K
                     DO N=1,ITBB(L)
                        NVEC1 = NVEC1 + 1                
                        V1(1,NVEC1) = TBB_CRD(1,L,N)
                        V1(2,NVEC1) = TBB_CRD(2,L,N)
                        V1(3,NVEC1) = TBB_CRD(3,L,N)                
                     END DO
                  END DO
               ELSE
                  DO N=1,ITBB(JR)        
                     NVEC1= NVEC1 + 1
                     V1(1,NVEC1) = TBB_CRD(1,JR,N)
                     V1(2,NVEC1) = TBB_CRD(2,JR,N)
                     V1(3,NVEC1) = TBB_CRD(3,JR,N)  
                  END DO
               END IF               
            END DO
            DO M=1,3
               JR=ITFRAG(J,M)
               DO N=M+1,3
                  JJR=ITFRAG(J,N)               
                  FR(1,M,N)=RESDIST2(JR,JJR)
                  FR(1,N,M)=RESDIST2(JR,JJR)
                  FR(3,M,N)=abs(JR-JJR)
                  FR(3,N,M)=abs(JR-JJR)
               END DO
            END DO         
            DO I=1,IQFRAGN,jump2
               NVEC2 = 0
               DO M=1,3
                  JR=IQFRAG(I,M)                 
                  IF((JR.GT.1).AND.(JR.LT.(IQRES-1)))THEN
                     DO K=-1,1
                        L      = JR + K
                        DO N=1,IQBB(L)
                           NVEC2 = NVEC2 + 1                
                           V2(1,NVEC2) = QBB_CRD(1,L,N,0)
                           V2(2,NVEC2) = QBB_CRD(2,L,N,0)
                           V2(3,NVEC2) = QBB_CRD(3,L,N,0)
                        END DO
                     END DO
                  ELSE
                     DO N=1,IQBB(JR)        
                        NVEC2= NVEC2 + 1
                        V2(1,NVEC2) = QBB_CRD(1,JR,N,0)
                        V2(2,NVEC2) = QBB_CRD(2,JR,N,0)
                        V2(3,NVEC2) = QBB_CRD(3,JR,N,0)
                     END DO
                  END IF
               END DO
               DO M=1,3
                  JR=IQFRAG(I,M)
                  DO N=M+1,3
                     JJR=IQFRAG(I,N)               
                     FR(2,M,N)=RESDIST(JR,JJR)
                     FR(2,N,M)=RESDIST(JR,JJR)
                     FR(4,M,N)=abs(JR-JJR)
                     FR(4,N,M)=abs(JR-JJR)                    
                  END DO
               END DO              
               DO M=1,3                
                  DO N=M+1,3
                     IF(abs(FR(1,M,N)-FR(2,M,N)).GT.4)GOTO 7003
                     IF(abs(FR(3,M,N)-FR(4,M,N)).GT.35)GOTO 7003                    
                  END DO
               END DO
               NVEC=min(NVEC2,NVEC1)
               CALL u3b(W,V2,V1,NVEC,1,SQRMSD,U,T,ier)                
c               DIST=SQRT(SQRMSD)
c               print *,I,J,NVEC1,NVEC2,DIST
               DO INQ=1,IQRES
                  DO N=1,IQBB(INQ) 
                     QBB_CRD(1,INQ,N,1)= T(1)  
     &                    +U(1,1) * QBB_CRD(1,INQ,N,0)
     &                    +U(1,2) * QBB_CRD(2,INQ,N,0)
     &                    +U(1,3) * QBB_CRD(3,INQ,N,0)
                     QBB_CRD(2,INQ,N,1)=T(2) 
     &                    +U(2,1) * QBB_CRD(1,INQ,N,0)
     &                    +U(2,2) * QBB_CRD(2,INQ,N,0)
     &                    +U(2,3) * QBB_CRD(3,INQ,N,0)
                     QBB_CRD(3,INQ,N,1)=T(3) 
     &                    +U(3,1) * QBB_CRD(1,INQ,N,0)
     &                    +U(3,2) * QBB_CRD(2,INQ,N,0)
     &                    +U(3,3) * QBB_CRD(3,INQ,N,0)
                  END DO
               END DO
               GC2(1)=0.0
               GC2(2)=0.0
               GC2(3)=0.0
               NVEC=0
              
               DO M=1,3
                  JR=IQFRAG(I,M)                  
                  DO N=1,IQBB(JR)                     
                     GC2(1)= GC2(1) + QBB_CRD(1,JR,N,1)
                     GC2(2)= GC2(2) + QBB_CRD(2,JR,N,1)
                     GC2(3)= GC2(3) + QBB_CRD(3,JR,N,1)
                     NVEC = NVEC + 1
                  END DO
               END DO
               GC2(1)  = GC2(1)/NVEC
               GC2(2)  = GC2(2)/NVEC
               GC2(3)  = GC2(3)/NVEC
               
c     Mark probable binding site residues in query i.e. SPHERE_R
               IQBN = 0        
               DO JQ=1,IQRES
                  IQBS(JQ)=0
                  DO N=1,IQBB(JQ) 
                     DIST=sqrt(
     &                    (  GC2(1)-QBB_CRD(1,JQ,N,1))**2
     &                    +( GC2(2)-QBB_CRD(2,JQ,N,1))**2
     &                    +( GC2(3)-QBB_CRD(3,JQ,N,1))**2)                                 
                     IF((DIST.LE.SPHERE_R).AND.(IQBS(JQ).eq.0))THEN
                        IQBN        = IQBN + 1
                        IQBS(JQ)    = IQBN
                        IMAPQ(IQBN) = JQ            
                     END IF                   
                  END DO
               END DO
               BScore_old = 0.0
c     print *,I,II,III,BScore,BScore_new,IQBN 
               DO ITER=1,ITERN      ! Iterate                  
                  CALL FILLMATRIX
                  CALL DYPG
                  CALL GETSCORE                  
                  IF(BScore.GT.BScore_new)THEN
                     DO JQ=1,IQRES
                        IALNR(JQ)= 0            
                     END DO                               
                     BScore_new = BScore
                     DIS_new    = DIS
                     SID_new    = SID                           
                     DO IQ=1,IQBN
                        IF(INVMAP(IQ).gt.0)then  
                           IAQ = IMAPQ(IQ)                          
                           IAT = IMAPT(INVMAP(IQ))
                           IALNR(IAQ) = IAT
                           DIST= SQRT(
     &                          (  XYZ(1,IAQ,1) - TBB_CRD(1,IAT,1))**2
     &                          + (XYZ(2,IAQ,1) - TBB_CRD(2,IAT,1))**2
     &                          + (XYZ(3,IAQ,1) - TBB_CRD(3,IAT,1))**2)
                           XYZF(1,IAQ)=XYZ(1,IAQ,1)
                           XYZF(2,IAQ)=XYZ(2,IAQ,1)
                           XYZF(3,IAQ)=XYZ(3,IAQ,1)
                           ALNDIST(IAQ)=DIST
                        END IF
                     END DO
                  END IF                               
                  IF(ITER.GT.1)THEN
                     DIFF = abs(BScore - BScore_old)                     
                     IF(DIFF.LT.0.0001) THEN                      
                        GOTO 7003
                     END IF
                  END IF
                  BScore_old = BScore   
               END DO           ! Iteration                                            
 7003          CONTINUE
               IF(BScore_new.GT.BScore_MAX) THEN
                  BScore_MAX = BScore_new
                  DIS_MAX    = DIS_new
                  SID_MAX    = SID_new                  
               END IF         
            END DO
         END DO    !DO J=1,IBSR
         GOTO 8001         
      END IF

 8001 IALA   = 0
      EDIST  = 0
      EMACH1 = 0
      EMACH2 = 0
      NVEC   = 0
      DO IQ=1,IQRES
         IF(IALNR(IQ).GT.0)then            
            IT=IALNR(IQ)
            DO J=1,IBSR
               IF(ITBSITE(J).EQ.IT)THEN
                  IALA  = IALA  + 1
                  EDIST = EDIST + ALNDIST(IQ)
                  EMACH1 = EMACH1 +  B(ISEQ2(IT),ISEQ1(IQ))
                  IF(B(ISEQ2(IT),ISEQ1(IQ)).GT.0.5)THEN
                     EMACH2 = EMACH2 +  B(ISEQ2(IT),ISEQ1(IQ))
                  END IF
               END IF
            END DO
         END IF
      END DO
      COV   = real(IALA)/real(IBSR)
      AERR  = EDIST/real(IBSR)
      SALI1 = EMACH1/real(IBSR)
      SALI2 = EMACH2/real(IBSR)
      WRITE(*,2002),TRIM(TNAME),LNAME,BSNAME,BScore_MAX,DIS_MAX,SID_MAX,
     &              COV, AERR, SALI1,SALI2 
      NVEC2=0
      NVEC1=0
      DO IQ=1,IQRES
         IF(IALNR(IQ).GT.0)then            
            IT=IALNR(IQ)
            DO J=1,IBSR
               IF(ITBSITE(J).EQ.IT)THEN
                  WRITE(*,2004)IT,AA(ISEQ2(IT)),IQ,AA(ISEQ1(IQ)),
     &                 ALNDIST(IQ), B(ISEQ2(IT),ISEQ1(IQ))
                  DO N=1,IHATOM                 
                     IF(CONTACT(N,IT).GT.0)CONTACT2(N,IQ)=CONTACT(N,IT)
                  END DO
                  DO N=1,IQBB(IQ)                            
                     NVEC2= NVEC2 + 1                
                     V2(1,NVEC2) = QBB_CRD(1,IQ,N,0)
                     V2(2,NVEC2) = QBB_CRD(2,IQ,N,0)
                     V2(3,NVEC2) = QBB_CRD(3,IQ,N,0)                                
                  END DO
                  DO N=1,ITBB(IT)
                     NVEC1 = NVEC1 + 1                
                     V1(1,NVEC1) = TBB_CRD(1,IT,N)
                     V1(2,NVEC1) = TBB_CRD(2,IT,N)
                     V1(3,NVEC1) = TBB_CRD(3,IT,N)                
                  END DO            
                  GOTO 8002
               END IF
            END DO
            WRITE(*,2003)IT,AA(ISEQ2(IT)),IQ,AA(ISEQ1(IQ)),
     &           ALNDIST(IQ), B(ISEQ2(IT),ISEQ1(IQ))
 8002       CONTINUE
         END IF
      END DO     
      IF(l_out.gt.0)THEN 
         NVEC=min(NVEC2,NVEC1)
      
         CALL u3b(W,V1,V2,NVEC,1,SQRMSD,U,T,ier)
c         write(*,*)'-------- rotation matrix to rotate Chain-1 to ',
c     &        'Chain-2 ------'
c         write(*,*)'i          T(i)         U(i,1)         U(i,2) ',
c     &        '        U(i,3)'
c         do i=1,3
c            write(*,204)i,T(i),U(i,1),U(i,2),U(i,3)
c         enddo

         DO N=1,IHATOM
            
            HATMCRD2(1,N,0)= T(1) + U(1,1) * HATMCRD(1,N)
     &                            + U(1,2) * HATMCRD(2,N)
     &                            + U(1,3) * HATMCRD(3,N)
            HATMCRD2(1,N,1)= HATMCRD2(1,N,0)
            HATMCRD2(2,N,0)= T(2) + U(2,1) * HATMCRD(1,N)
     &                            + U(2,2) * HATMCRD(2,N)
     &                            + U(2,3) * HATMCRD(3,N)
            HATMCRD2(2,N,1)=HATMCRD2(2,N,0)
            HATMCRD2(3,N,0)= T(3) + U(3,1) * HATMCRD(1,N)
     &                            + U(3,2) * HATMCRD(2,N)
     &                            + U(3,3) * HATMCRD(3,N)
            HATMCRD2(3,N,1)=HATMCRD2(3,N,0)
          
         END DO                   
         CALL IMPROVE
         OPEN(UNIT=7,file=OUTNAME,status='unknown') !pdb1.aln + pdb2.aln
         DO N=1,IHATOM
           WRITE(7,2005)HATMREC(N,1),HATMCRD2(1,N,0),HATMCRD2(2,N,0),
     &           HATMCRD2(3,N,0),HATMREC(N,2)

         END DO
         WRITE(7,2010)'TER'
         CLOSE(7)
      END IF
      
 4011 CONTINUE      
      END PROGRAM

      SUBROUTINE IMPROVE
      PARAMETER(NMAX=2500)
      PARAMETER(NMAX2=20000)      
      COMMON/CLIGAND/HATMCRD2(3,NMAX,0:2),IHATOM,CONTACT2(NMAX,NMAX)
      COMMON/CORD1/QBB_CRD(3,NMAX,5,0:1),IQBB(NMAX),XYZ(3,NMAX,5)
      COMMON/LENGTH/IQRES, ITRES, d0      
      COMMON/NCLASH/ACLASH,ACONTACT


c      
      double precision V1(3,NMAX),V2(3,NMAX),W(NMAX)
      double precision U(3,3),T(3),RMS
      data W /nmax*1.0/
      nozy=1234
      if(nozy.gt.0)nozy=-nozy
      firstrandom=aranzy(nozy)
      call CLASH            !
           
      E_old       = ACLASH - ACONTACT
      E_min       = E_old
c      write(*,*)'Number of Clash with receptor  =',ACLASH  
c      write(*,*)'Number of binding site contacts=',ACONTACT
c      write(*,*)'Energy old=',E_old
      ax=0
      ay=0
      az=0
   
      DO N=1,IHATOM
         ax = ax + HATMCRD2(1,N,1)
         ay = ay + HATMCRD2(2,N,1)
         az = az + HATMCRD2(3,N,1)
         HATMCRD2(1,N,2)=HATMCRD2(1,N,1)
         HATMCRD2(2,N,2)=HATMCRD2(2,N,1)
         HATMCRD2(3,N,2)=HATMCRD2(3,N,1) 
         V1(1,N) = HATMCRD2(1,N,1)
         V1(2,N) = HATMCRD2(2,N,1)
         V1(3,N) = HATMCRD2(3,N,1)
         
      END DO
      CALL u3b(W,V1,V1,IHATOM,1,SQRMSD,U,T,ier)
   
      ax=ax/real(IHATOM)
      ay=ay/real(IHATOM)
      az=az/real(IHATOM)
      n_acc=0
      do 1111 i_ev=1,40000
c     rotation axis (awx,awy,awz):
         acos_theta=1-2.*aranzy(nozy)
         asin_theta=sqrt(1.0-acos_theta*acos_theta)
         aphi=2.*3.1415926*aranzy(nozy) ![0,2*pai]
         awx=asin_theta*cos(aphi)
         awy=asin_theta*sin(aphi)
         awz=acos_theta
c     rotation angle           !in arc-angle, 1=57o, rotation angle.
         angle00=1
         ang=(aranzy(nozy)*2-1)*angle00 ![-angle00,angle00]
c     translation:
         ax0=(2*aranzy(nozy)-1)*0.1
         ay0=(2*aranzy(nozy)-1)*0.1
         az0=(2*aranzy(nozy)-1)*0.1
***   rotation matrix:
         acos=cos(ang)
         asin=sin(ang)
         a11=awx*awx*(1-acos)+acos
         a12=awx*awy*(1-acos)-awz*asin
         a13=awx*awz*(1-acos)+awy*asin
         a21=awx*awy*(1-acos)+awz*asin
         a22=awy*awy*(1-acos)+acos
         a23=awy*awz*(1-acos)-awx*asin
         a31=awx*awz*(1-acos)-awy*asin
         a32=awy*awz*(1-acos)+awx*asin
         a33=awz*awz*(1-acos)+acos
         SQRMSD=0
         DIST  =0
         
         do I=1,IHATOM
            HATMCRD2(1,I,1)=ax0 + ax + 
     &           (HATMCRD2(1,I,0)-ax)*a11 +
     &           (HATMCRD2(2,I,0)-ay)*a12 +
     &           (HATMCRD2(3,I,0)-az)*a13
            HATMCRD2(2,I,1)=ay0 + ay + 
     &           (HATMCRD2(1,I,0)-ax)*a21 +
     &           (HATMCRD2(2,I,0)-ay)*a22 +
     &           (HATMCRD2(3,I,0)-az)*a23
            HATMCRD2(3,I,1)=az0 + az + 
     &           (HATMCRD2(1,I,0)-ax)*a31 +
     &           (HATMCRD2(2,I,0)-ay)*a32 +
     &           (HATMCRD2(3,I,0)-az)*a33
            V2(1,I) = HATMCRD2(1,I,1)
            V2(2,I) = HATMCRD2(2,I,1)
            V2(3,I) = HATMCRD2(3,I,1)
            DIST = sqrt((V1(1,I) - V2(1,I))**2
     &           +     (V1(2,I) - V2(2,I))**2
     &           +     (V1(3,I) - V2(3,I))**2)                        
         enddo
         
         call CLASH
         SQRMSD=DIST/IHATOM
       
         E= SQRMSD + ACLASH - ACONTACT  
      
      
         dE=E-E_old
        
ccc   metropolis ---------------->
         atemp=1
         id = 1
         arand=aranzy(nozy)
         if(arand.lt.exp(-dE/atemp))then
            id=3            
         endif
      
c         if(dE.lt.0)id=1
ccc   accept -------->
         IF(id.eq.3)then            
            n_acc=n_acc+1   
            DO I=1,IHATOM
               HATMCRD2(1,I,0)=HATMCRD2(1,I,1)
               HATMCRD2(2,I,0)=HATMCRD2(2,I,1)
               HATMCRD2(3,I,0)=HATMCRD2(3,I,1)             
            END DO         
            E_old=E     
            IF(E_old.LT.E_min)THEN
               E_min=E_old            
               DO I=1,IHATOM
                  HATMCRD2(1,I,2)=HATMCRD2(1,I,0)
                  HATMCRD2(2,I,2)=HATMCRD2(2,I,0)
                  HATMCRD2(3,I,2)=HATMCRD2(3,I,0)             
               END DO
            END IF
         END IF
 1111 continue
      DO I=1,IHATOM
         HATMCRD2(1,I,0)=HATMCRD2(1,I,2)
         HATMCRD2(2,I,0)=HATMCRD2(2,I,2)
         HATMCRD2(3,I,0)=HATMCRD2(3,I,2)             
      END DO      
      RETURN      
      END


      SUBROUTINE CLASH
      PARAMETER(NMAX=2500)
      PARAMETER(NMAX2=20000)      
      COMMON/CLIGAND/HATMCRD2(3,NMAX,0:2),IHATOM,CONTACT2(NMAX,NMAX)
      COMMON/CORD1/QBB_CRD(3,NMAX,5,0:1),IQBB(NMAX),XYZ(3,NMAX,5)
      COMMON/LENGTH/IQRES, ITRES, d0
      common/NCLASH/ACLASH,ACONTACT

      ACLASH  = 0
      NCLASH  = 0
      ACONTACT= 0
      DO I=1,IHATOM
         DO IQ=1,IQRES
            DISTMIN=0
            IATOM=IQBB(IQ)      
c            IF(IATOM.GT.4)IATOM=4
            DO N=1,IATOM               
               DIST=sqrt((QBB_CRD(1,IQ,N,0)- HATMCRD2(1,I,1))**2
     &              +    (QBB_CRD(2,IQ,N,0)- HATMCRD2(2,I,1))**2            
     &              +    (QBB_CRD(3,IQ,N,0)- HATMCRD2(3,I,1))**2)    
               IF(N.EQ.1)DISTMIN=DIST
               IF(DIST.LE.DISTMIN)DISTMIN=DIST
            END DO           
           IF(CONTACT2(I,IQ).GT.0)THEN               
              ACONTACT = ACONTACT + 1/(abs(CONTACT2(I,IQ)-DISTMIN)+0.1)          
           END IF
           IF(DISTMIN.LT.4.75)THEN
              ACLASH   = ACLASH + 1
           END IF
        END DO
      END DO 
    
      RETURN 
      END
      
      SUBROUTINE GETSCORE
      PARAMETER(NMAX=2500)
      PARAMETER(NMAX2=20000)
      PARAMETER(NAA=23)         !number of amino acid

      COMMON/MATRIX/B(NAA,NAA)
      COMMON/DP/SCORE(NMAX,NMAX),GAP_OPEN,INVMAP(NMAX),ITBN,IQBN,GAP_EXT
      COMMON/CORD1/QBB_CRD(3,NMAX,5,0:1),IQBB(NMAX),XYZ(3,NMAX,5)
      COMMON/CORD2/TBB_CRD(3,NMAX,5),ITBB(NMAX),TATMCRD(3,NMAX2)         
      COMMON/LENGTH/IQRES, ITRES, d0 
      COMMON/SEQN/ITBS(NMAX),IQBS(NMAX),ISEQ1(NMAX),ISEQ2(NMAX)
      COMMON/MAPPING/IMAPT(NMAX),IMAPQ(NMAX)    
      COMMON/SCORES/BScore,SID,DIS,IALN     
      double precision V1(3,NMAX),V2(3,NMAX),W(NMAX)
      double precision U(3,3),T(3),RMS
      data W /nmax*1.0/

      
      BScore=0
      DIS   =0
      SID   =0      
c     Check aligned residues and superpose again
      NVEC=0
      DO IQ=1,IQBN     
         IF(INVMAP(IQ).gt.0)then         
            JQ = IMAPQ(IQ)
            JT = IMAPT(INVMAP(IQ))
            NVEC= NVEC+1
            V1(1,NVEC)= TBB_CRD(1,JT,1)
            V1(2,NVEC)= TBB_CRD(2,JT,1)
            V1(3,NVEC)= TBB_CRD(3,JT,1)
            V2(1,NVEC)= QBB_CRD(1,JQ,1,1)
            V2(2,NVEC)= QBB_CRD(2,JQ,1,1)
            V2(3,NVEC)= QBB_CRD(3,JQ,1,1)           
         END IF
      END DO
      call u3b(W,V2,V1,NVEC,1,rms,U,T,ier)
      DO I=1,IQRES
         DO N=1,IQBB(I)
            XYZ(1,I,N)= T(1) + U(1,1) * QBB_CRD(1,I,N,1)
     &                       + U(1,2) * QBB_CRD(2,I,N,1)
     &                       + U(1,3) * QBB_CRD(3,I,N,1)
            XYZ(2,I,N)= T(2) + U(2,1) * QBB_CRD(1,I,N,1)
     &                       + U(2,2) * QBB_CRD(2,I,N,1)
     &                       + U(2,3) * QBB_CRD(3,I,N,1)
            XYZ(3,I,N)= T(3) + U(3,1) * QBB_CRD(1,I,N,1)
     &                       + U(3,2) * QBB_CRD(2,I,N,1)
     &                       + U(3,3) * QBB_CRD(3,I,N,1)
         END DO
      END DO      
c     Calculate overlap between the binding site
      CALL BLOSSUM           
      K=0
      IALN = 0
      SID  = 0
      DIS  = 0
      DIST = 0
      DO IQ=1,IQBN
         IF(INVMAP(IQ).gt.0)then           
            IALN = IALN + 1
            JQ   = IMAPQ(IQ)
            JT   = IMAPT(INVMAP(IQ))
c            print *,IQ,INVMAP(IQ),IMAPQ(IQ),IMAPT(INVMAP(IQ))
            DIST =sqrt((XYZ(1,JQ,1) - TBB_CRD(1,JT,1))**2
     &           +     (XYZ(2,JQ,1) - TBB_CRD(2,JT,1))**2
     &           +     (XYZ(3,JQ,1) - TBB_CRD(3,JT,1))**2)
            DISTSCORE = real(1.01/(1+(DIST/d0)**2))
            DIS = DIS + DISTSCORE

            SID = SID + B(ISEQ1(JQ),ISEQ2(JT))

         END IF
      END DO
      DIS    = DIS/real(ITBN)                 
      SID    = SID/real(ITBN) 
      BScore = DIS  + SID
      
      RETURN 
      END            
      
c     c     Do Dynamic programming
c********************************************************************c
c*     This is a standard Needleman-Wunsch dynamic program (by Y. Zhang 2005)
c*     1. Count multiple-gap.
c*     2. The gap penality W(k)=Go+Ge*k1+Go+Ge*k2 if gap open on both sequences
c*     
c*     Input: score(i,j), gap_open, gap_extn
c*     Output: j2i(j)
c*     DIR(i,j)=1,2,3, from diagonal, horizontal, vertical
c*     val(i,j) is the cumulative score of (i,j)
c********************************************************************
      SUBROUTINE DYPG2
      PARAMETER(NMAX =2500)
      PARAMETER(NMAX2=20000) 
      COMMON/LENGTH/IQRES, ITRES, d0
      COMMON/DP/SCORE(NMAX,NMAX),GAP_OPEN,INVMAP(NMAX),ITBN,IQBN,GAP_EXT
      dimension val(0:NMAX,0:NMAX),DIR(0:NMAX,0:NMAX)
      dimension jpV(0:NMAX,0:NMAX),jpH(0:NMAX,0:NMAX)
      dimension preV(0:NMAX,0:NMAX),preH(0:NMAX,0:NMAX)
      real D,V,H
  
***   initialize the matrix:
      VAL(0,0)=0
      DO I=1,ITBN
         VAL(I,0) = GAP_EXT * I
         preV(I,0)= VAL(I,0) !not use preV at the beginning
         DIR(I,0) = 0            
         jpV(I,0) = 1             
         jpH(I,0) = I             
      END DO
      DO J=1,IQBN
         VAL(0,J) = GAP_EXT * J
         preH(0,J)= VAL(0,j)
         DIR(0,J) = 0
         jpV(0,J) = J
         jpH(0,J) = 1
         INVMAP(J)=-1
      END DO 
***   decide matrix and path:
      DO J=1,IQBN         
         DO I=1,ITBN
            D=VAL(I-1,J-1)+ SCORE(I,J)
c   H= H + gap_open ------->
            jpH(I,J)=1
            VAL1 = VAL(I-1,J)   + GAP_OPEN
            VAL2 = preH(I-1,J)  + GAP_EXT           !gap_extn from horizontal
            IF(VAL1.GT.VAL2) THEN              !last step from D or V
               H=VAL1
            ELSE                               !last step from H
               H=VAL2
               IF(I.GT.1)jpH(I,J)=jpH(I-1,J)+1 !record long-gap
            END IF

c    V= V + gap_open --------->
            jpV(I,J)=1
            VAL1 =  VAL(I,J-1) + GAP_OPEN
            VAL2 = preV(I,J-1) + GAP_EXT
            IF(VAL1.GT.VAL2) THEN
               V=VAL1
            ELSE
               V=VAL2
               IF(J.GT.1)jpV(I,J)=jpV(I,J-1)+1
            END IF
            preH(I,J)=H         !unaccepted H
            preV(I,J)=V         !unaccepted V            
            if(D.GT.H.AND.D.GT.V)then
               DIR(I,J)=1
               VAL(I,J)=D
            ELSEIF(H.GT.V)THEN
               DIR(I,J)=2
               VAL(I,J)=H
            ELSE
               DIR(I,J)=3
               VAL(I,J)=V
            END IF            
         ENDDO
      ENDDO      
c     trace back the pathway:
      I=ITBN
      J=IQBN
      DO WHILE(I.GT.0.AND.J.GT.0)
         IF(DIR(I,J).EQ.1)THEN      !from diagonal
            INVMAP(J)=I
            I=I-1
            J=J-1
         ELSE IF(DIR(I,J).EQ.2)THEN !from horizonal
            DO me=1,jpH(I,J)
               IF(i.GT.0) THEN
                  I=I-1                       
               END IF
            END DO
         ELSE
            DO me=1,jpV(I,J)
               IF(J.GT.0) then
                  J=J-1                       
               END IF
            END DO
         END IF
      END DO      
      END
     
      SUBROUTINE DYPG
      PARAMETER(NMAX =2500)
      PARAMETER(NMAX2=20000) 
      LOGICAL*1 DIR
      COMMON/LENGTH/IQRES, ITRES, d0
      COMMON/DP/SCORE(NMAX,NMAX),GAP_OPEN,INVMAP(NMAX),ITBN,IQBN,GAP_EXT
      DIMENSION DIR(0:NMAX,0:NMAX),VAL(0:NMAX,0:NMAX)
      REAL H,V          
***   initialize the matrix:
      VAL(0,0)=0
      DO I=1,ITBN
         DIR(I,0)=.false.
         VAL(I,0)= 0
      END DO
      DO J=1,IQBN
         DIR(0,J) =.false.
         VAL(0,J) = 0
         INVMAP(J)=-1
      END DO    
***   decide matrix and path:
      DO J=1,IQBN
         DO I=1,ITBN            
            D=VAL(I-1,J-1)+SCORE(I,J)
            H=VAL(I-1,J)
            IF(DIR(I-1,J))H=H+GAP_OPEN
            V=VAL(I,J-1)
            IF(DIR(I,J-1))V=V+GAP_OPEN          
            IF((D.GE.H).AND.(D.GE.V)) THEN
            DIR(I,J)=.true.
            VAL(I,J)=D
          ELSE
            DIR(I,J)=.FALSE.
            IF(V.GE.H)then
              VAL(I,J)=V
            ELSE
              VAL(I,J)=H
            END IF
          ENDIF
        ENDDO
      ENDDO
      
***   extract the alignment:
      I=ITBN
      J=IQBN
      DO WHILE((I.GT.0).AND.(J.GT.0))
         IF(DIR(I,J))THEN
            INVMAP(J)=I
            I=I-1
            J=J-1
         ELSE
            H=VAL(I-1,J)
            IF(DIR(I-1,J))H=H+GAP_OPEN
            V=VAL(I,J-1)
            IF(DIR(I,J-1))V=V+GAP_OPEN
            IF(V.GE.H) THEN
               J=J-1
            ELSE
               I=I-1
            ENDIF
         ENDIF
      ENDDO
      END     

c     Fill matrix for Dynamic programming       
      SUBROUTINE FILLMATRIX
      PARAMETER(NMAX=2500)
      PARAMETER(NMAX2=20000)
      PARAMETER(NAA=23)         !number of amino acid
      COMMON/MATRIX/B(NAA,NAA)
      COMMON/LENGTH/IQRES, ITRES, d0
      COMMON/CORD1/QBB_CRD(3,NMAX,5,0:1),IQBB(NMAX),XYZ(3,NMAX,5)
      COMMON/CORD2/TBB_CRD(3,NMAX,5),ITBB(NMAX),TATMCRD(3,NMAX2)         
      COMMON/DP/SCORE(NMAX,NMAX),gap_open,invmap(NMAX),ITBN,IQBN,GAP_EXT     
      COMMON/SEQN/ITBS(NMAX),IQBS(NMAX),ISEQ1(NMAX),ISEQ2(NMAX)
     
      CALL BLOSSUM     
      DO JT=1,ITRES
         DO JQ=1,IQRES
            SCORE(JT,JQ)=0
         END DO
      END DO

      IT = 0      
      DO JT=1,ITRES
         IF(ITBS(JT).gt.0)then
            IT = IT + 1
            IQ = 0
            DO JQ=1,IQRES
               IF(IQBS(JQ).gt.0)then
                  DIST=sqrt((QBB_CRD(1,JQ,1,1) - TBB_CRD(1,JT,1))**2
     &                 +    (QBB_CRD(2,JQ,1,1) - TBB_CRD(2,JT,1))**2
     &                 +    (QBB_CRD(3,JQ,1,1) - TBB_CRD(3,JT,1))**2) 
                  IQ = IQ + 1        
                  DISTSCORE = real(1.01/(1+(DIST/d0)**2))
                  SCORE(IT,IQ)= DISTSCORE + B(ISEQ1(JQ),ISEQ2(JT))
               END IF
            END DO           
         END IF
      END DO
      RETURN 
      END

cccccccccccccccc Calculate sum of (r_d-r_m)^2 cccccccccccccccccccccccccc
c  w    - w(m) is weight for atom pair  c m           (given)
c  x    - x(i,m) are coordinates of atom c m in set x       (given)
c  y    - y(i,m) are coordinates of atom c m in set y       (given)
c  n    - n is number of atom pairs                         (given)
c  mode  - 0:calculate rms only                             (given)
c          1:calculate rms,u,t                              (takes longer)
c  rms   - sum of w*(ux+t-y)**2 over all atom pairs         (result)
c  u    - u(i,j) is   rotation  matrix for best superposition  (result)
c  t    - t(i)   is translation vector for best superposition  (result)
c  ier  - 0: a unique optimal superposition has been determined(result)
c       -1: superposition is not unique but optimal
c       -2: no result obtained because of negative weights w
c           or all weights equal to zero.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine u3b(w, x, y, n, mode, rms, u, t, ier)
      integer ip(9), ip2312(4), i, j, k, l, m1, m, ier, n, mode
      double precision w(1), x(3, 1), y(3, 1), u(3, 3), t(3), rms, sigma
      double precision r(3, 3), xc(3), yc(3), wc, a(3, 3), b(3, 3), e0, 
     &e(3), e1, e2, e3, d, spur, det, cof, h, g, cth, sth, sqrth, p, tol
     &, rr(6), rr1, rr2, rr3, rr4, rr5, rr6, ss(6), ss1, ss2, ss3, ss4, 
     &ss5, ss6, zero, one, two, three, sqrt3 
      equivalence (rr(1), rr1), (rr(2), rr2), (rr(3), rr3), (rr(4), rr4)
     &, (rr(5), rr5), (rr(6), rr6), (ss(1), ss1), (ss(2), ss2), (ss(3), 
     &ss3), (ss(4), ss4), (ss(5), ss5), (ss(6), ss6), (e(1), e1), (e(2)
     &, e2), (e(3), e3)
      data sqrt3 / 1.73205080756888d+00 /
      data tol / 1.0d-2 /
      data zero / 0.0d+00 /
      data one / 1.0d+00 /
      data two / 2.0d+00 /
      data three / 3.0d+00 /
      data ip / 1, 2, 4, 2, 3, 5, 4, 5, 6 /
      data ip2312 / 2, 3, 1, 2 /


c 156 "rms.for"
      wc = zero
      rms = 0.0
      e0 = zero
      do 1 i = 1, 3
      xc(i) = zero
      yc(i) = zero
      t(i) = 0.0
      do 1 j = 1, 3
      d = zero 
      if (i .eq. j) d = one
      u(i,j) = d 
      a(i,j) = d
    1 r(i,j) = zero
      ier = -1
c**** DETERMINE CENTROIDS OF BOTH VECTOR SETS X AND Y
c**** DETERMINE CENTROIDS OF BOTH VECTOR SETS X AND Y
c 170 "rms.for"
      if (n .lt. 1) return
c 172 "rms.for"
      ier = -2
      do 2 m = 1, n
      if (w(m) .lt. 0.0) return
      wc = wc + w(m)
      do 2 i = 1, 3
      xc(i) = xc(i) + (w(m) * x(i,m))
    2 yc(i) = yc(i) + (w(m) * y(i,m))
      if (wc .le. zero) return
      do 3 i = 1, 3
      xc(i) = xc(i) / wc
c**** DETERMINE CORRELATION MATRIX R BETWEEN VECTOR SETS Y AND X
c 182 "rms.for"
    3 yc(i) = yc(i) / wc
c 184 "rms.for"
      do 4 m = 1, n
      do 4 i = 1, 3
      e0 = e0 + (w(m) * (((x(i,m) - xc(i)) ** 2) + ((y(i,m) - yc(i)) **
     &2)))
c 187 "rms.for"
      d = w(m) * (y(i,m) - yc(i))
      do 4 j = 1, 3
c**** CALCULATE DETERMINANT OF R(I,J)
c 189 "rms.for"
    4 r(i,j) = r(i,j) + (d * (x(j,m) - xc(j)))
c 191 "rms.for"
      det = ((r(1,1) * ((r(2,2) * r(3,3)) - (r(2,3) * r(3,2)))) - (r(1,2
     &) * ((r(2,1) * r(3,3)) - (r(2,3) * r(3,1))))) + (r(1,3) * ((r(2,1)
     & * r(3,2)) - (r(2,2) * r(3,1))))
c**** FORM UPPER TRIANGLE OF TRANSPOSED(R)*R
c 194 "rms.for"
      sigma = det
c 196 "rms.for"
      m = 0
      do 5 j = 1, 3
      do 5 i = 1, j
      m = m + 1
c***************** EIGENVALUES *****************************************
c**** FORM CHARACTERISTIC CUBIC  X**3-3*SPUR*X**2+3*COF*X-DET=0
c 200 "rms.for"
    5 rr(m) = ((r(1,i) * r(1,j)) + (r(2,i) * r(2,j))) + (r(3,i) * r(3,j)
     &)
c 203 "rms.for"
      spur = ((rr1 + rr3) + rr6) / three
      cof = ((((((rr3 * rr6) - (rr5 * rr5)) + (rr1 * rr6)) - (rr4 * rr4)
     &) + (rr1 * rr3)) - (rr2 * rr2)) / three
c 205 "rms.for"
      det = det * det
      do 6 i = 1, 3
    6 e(i) = spur
c**** REDUCE CUBIC TO STANDARD FORM Y**3-3HY+2G=0 BY PUTTING X=Y+SPUR
c 208 "rms.for"
      if (spur .le. zero) goto 40
c 210 "rms.for"
      d = spur * spur
      h = d - cof
c**** SOLVE CUBIC. ROOTS ARE E1,E2,E3 IN DECREASING ORDER
c 212 "rms.for"
      g = (((spur * cof) - det) / two) - (spur * h)
c 214 "rms.for"
      if (h .le. zero) goto 8
      sqrth = dsqrt(h)
      d = ((h * h) * h) - (g * g)
      if (d .lt. zero) d = zero
      d = datan2(dsqrt(d),- g) / three
      cth = sqrth * dcos(d)
      sth = (sqrth * sqrt3) * dsin(d)
      e1 = (spur + cth) + cth
      e2 = (spur - cth) + sth
      e3 = (spur - cth) - sth
c.....HANDLE SPECIAL CASE OF 3 IDENTICAL ROOTS
c 224 "rms.for"
      if (mode) 10, 50, 10
c**************** EIGENVECTORS *****************************************
c 226 "rms.for"
    8 if (mode) 30, 50, 30
c 228 "rms.for"
   10 do 15 l = 1, 3, 2
      d = e(l)
      ss1 = ((d - rr3) * (d - rr6)) - (rr5 * rr5)
      ss2 = ((d - rr6) * rr2) + (rr4 * rr5)
      ss3 = ((d - rr1) * (d - rr6)) - (rr4 * rr4)
      ss4 = ((d - rr3) * rr4) + (rr2 * rr5)
      ss5 = ((d - rr1) * rr5) + (rr2 * rr4)
      ss6 = ((d - rr1) * (d - rr3)) - (rr2 * rr2)
      j = 1
      if (dabs(ss1) .ge. dabs(ss3)) goto 12
      j = 2
      if (dabs(ss3) .ge. dabs(ss6)) goto 13
   11 j = 3
      goto 13
   12 if (dabs(ss1) .lt. dabs(ss6)) goto 11
   13 d = zero
      j = 3 * (j - 1)
      do 14 i = 1, 3
      k = ip(i + j)
      a(i,l) = ss(k)
   14 d = d + (ss(k) * ss(k))
      if (d .gt. zero) d = one / dsqrt(d)
      do 15 i = 1, 3
   15 a(i,l) = a(i,l) * d
      d = ((a(1,1) * a(1,3)) + (a(2,1) * a(2,3))) + (a(3,1) * a(3,3))
      m1 = 3
      m = 1
      if ((e1 - e2) .gt. (e2 - e3)) goto 16
      m1 = 1
      m = 3
   16 p = zero
      do 17 i = 1, 3
      a(i,m1) = a(i,m1) - (d * a(i,m))
   17 p = p + (a(i,m1) ** 2)
      if (p .le. tol) goto 19
      p = one / dsqrt(p)
      do 18 i = 1, 3
   18 a(i,m1) = a(i,m1) * p
      goto 21
   19 p = one
      do 20 i = 1, 3
      if (p .lt. dabs(a(i,m))) goto 20
      p = dabs(a(i,m))
      j = i
   20 continue
      k = ip2312(j)
      l = ip2312(j + 1)
      p = dsqrt((a(k,m) ** 2) + (a(l,m) ** 2))
      if (p .le. tol) goto 40
      a(j,m1) = zero
      a(k,m1) = - (a(l,m) / p)
      a(l,m1) = a(k,m) / p
   21 a(1,2) = (a(2,3) * a(3,1)) - (a(2,1) * a(3,3))
      a(2,2) = (a(3,3) * a(1,1)) - (a(3,1) * a(1,3))
c****************** ROTATION MATRIX ************************************
c 282 "rms.for"
      a(3,2) = (a(1,3) * a(2,1)) - (a(1,1) * a(2,3))
c 284 "rms.for"
   30 do 32 l = 1, 2
      d = zero
      do 31 i = 1, 3
      b(i,l) = ((r(i,1) * a(1,l)) + (r(i,2) * a(2,l))) + (r(i,3) * a(3,l
     &))
c 288 "rms.for"
   31 d = d + (b(i,l) ** 2)
      if (d .gt. zero) d = one / dsqrt(d)
      do 32 i = 1, 3
   32 b(i,l) = b(i,l) * d
      d = ((b(1,1) * b(1,2)) + (b(2,1) * b(2,2))) + (b(3,1) * b(3,2))
      p = zero
      do 33 i = 1, 3
      b(i,2) = b(i,2) - (d * b(i,1))
   33 p = p + (b(i,2) ** 2)
      if (p .le. tol) goto 35
      p = one / dsqrt(p)
      do 34 i = 1, 3
   34 b(i,2) = b(i,2) * p
      goto 37
   35 p = one
      do 36 i = 1, 3
      if (p .lt. dabs(b(i,1))) goto 36
      p = dabs(b(i,1))
      j = i
   36 continue
      k = ip2312(j)
      l = ip2312(j + 1)
      p = dsqrt((b(k,1) ** 2) + (b(l,1) ** 2))
      if (p .le. tol) goto 40
      b(j,2) = zero
      b(k,2) = - (b(l,1) / p)
      b(l,2) = b(k,1) / p
   37 b(1,3) = (b(2,1) * b(3,2)) - (b(2,2) * b(3,1))
      b(2,3) = (b(3,1) * b(1,2)) - (b(3,2) * b(1,1))
      b(3,3) = (b(1,1) * b(2,2)) - (b(1,2) * b(2,1))
      do 39 i = 1, 3
      do 39 j = 1, 3
c****************** TRANSLATION VECTOR *********************************
c 320 "rms.for"
   39 u(i,j) = ((b(i,1) * a(j,1)) + (b(i,2) * a(j,2))) + (b(i,3) * a(j,3
     &))
   40 do 41 i = 1, 3
c********************** RMS ERROR **************************************
c 323 "rms.for"
   41 t(i) = ((yc(i) - (u(i,1) * xc(1))) - (u(i,2) * xc(2))) - (u(i,3)
     & * xc(3))
   50 do 51 i = 1, 3
      if (e(i) .lt. zero) e(i) = zero
   51 e(i) = dsqrt(e(i))
      ier = 0
      if (e2 .le. (e1 * 1.0d-05)) ier = -1
      d = e3
      if (sigma .ge. 0.0) goto 52
      d = - d
      if ((e2 - e3) .le. (e1 * 1.0d-05)) ier = -1
   52 d = (d + e2) + e1
      rms = (e0 - d) - d
      if (rms .lt. 0.0) rms = 0.0

      return
c.....END U3B...........................................................
c----------------------------------------------------------
c                       THE END
c----------------------------------------------------------
c 338 "rms.for"
      end
      subroutine BLOSSUM
      PARAMETER(NAA=23)         !number of amino acid
      common/MATRIX/B(NAA,NAA)
      B(1 ,1 ) = 1.000 
      B(1 ,2 ) = 0.130 
      B(1 ,3 ) = 0.130 
      B(1 ,4 ) = 0.100 
      B(1 ,5 ) = 0.130 
      B(1 ,6 ) = 0.260 
      B(1 ,7 ) = 0.190 
      B(1 ,8 ) = 0.150 
      B(1 ,9 ) = 0.120 
      B(1 ,10) = 0.170 
      B(1 ,11) = 0.120 
      B(1 ,12) = 0.200 
      B(1 ,13) = 0.270 
      B(1 ,14) = 0.090 
      B(1 ,15) = 0.120 
      B(1 ,16) = 0.500 
      B(1 ,17) = 0.300 
      B(1 ,18) = 0.060 
      B(1 ,19) = 0.130 
      B(1 ,20) = 0.260 
      B(1 ,21) = 0.150 
      B(1 ,22) = 0.130 
      B(1 ,23) = 0.260 
      B(2 ,1 ) = 0.130 
      B(2 ,2 ) = 1.000 
      B(2 ,3 ) = 0.140 
      B(2 ,4 ) = 0.080 
      B(2 ,5 ) = 0.030 
      B(2 ,6 ) = 0.340 
      B(2 ,7 ) = 0.170 
      B(2 ,8 ) = 0.040 
      B(2 ,9 ) = 0.130 
      B(2 ,10) = 0.070 
      B(2 ,11) = 0.060 
      B(2 ,12) = 0.390 
      B(2 ,13) = 0.160 
      B(2 ,14) = 0.050 
      B(2 ,15) = 0.050 
      B(2 ,16) = 0.180 
      B(2 ,17) = 0.140 
      B(2 ,18) = 0.050 
      B(2 ,19) = 0.090 
      B(2 ,20) = 0.080 
      B(2 ,21) = 0.040 
      B(2 ,22) = 0.140 
      B(2 ,23) = 0.340 
      B(3 ,1 ) = 0.130 
      B(3 ,2 ) = 0.140 
      B(3 ,3 ) = 1.000 
      B(3 ,4 ) = 0.170 
      B(3 ,5 ) = 0.030 
      B(3 ,6 ) = 0.210 
      B(3 ,7 ) = 0.140 
      B(3 ,8 ) = 0.080 
      B(3 ,9 ) = 0.150 
      B(3 ,10) = 0.050 
      B(3 ,11) = 0.040 
      B(3 ,12) = 0.150 
      B(3 ,13) = 0.100 
      B(3 ,14) = 0.040 
      B(3 ,15) = 0.050 
      B(3 ,16) = 0.250 
      B(3 ,17) = 0.180 
      B(3 ,18) = 0.030 
      B(3 ,19) = 0.070 
      B(3 ,20) = 0.060 
      B(3 ,21) = 0.080 
      B(3 ,22) = 1.000 
      B(3 ,23) = 0.210 
      B(4 ,1 ) = 0.100 
      B(4 ,2 ) = 0.080 
      B(4 ,3 ) = 0.170 
      B(4 ,4 ) = 1.000 
      B(4 ,5 ) = 0.030 
      B(4 ,6 ) = 0.220 
      B(4 ,7 ) = 0.300 
      B(4 ,8 ) = 0.070 
      B(4 ,9 ) = 0.110 
      B(4 ,10) = 0.070 
      B(4 ,11) = 0.040 
      B(4 ,12) = 0.150 
      B(4 ,13) = 0.100 
      B(4 ,14) = 0.040 
      B(4 ,15) = 0.060 
      B(4 ,16) = 0.220 
      B(4 ,17) = 0.150 
      B(4 ,18) = 0.030 
      B(4 ,19) = 0.060 
      B(4 ,20) = 0.070 
      B(4 ,21) = 0.070 
      B(4 ,22) = 0.170 
      B(4 ,23) = 0.220 
      B(5 ,1 ) = 0.130 
      B(5 ,2 ) = 0.030 
      B(5 ,3 ) = 0.030 
      B(5 ,4 ) = 0.030 
      B(5 ,5 ) = 1.000 
      B(5 ,6 ) = 0.040 
      B(5 ,7 ) = 0.020 
      B(5 ,8 ) = 0.020 
      B(5 ,9 ) = 0.020 
      B(5 ,10) = 0.060 
      B(5 ,11) = 0.040 
      B(5 ,12) = 0.030 
      B(5 ,13) = 0.080 
      B(5 ,14) = 0.030 
      B(5 ,15) = 0.020 
      B(5 ,16) = 0.080 
      B(5 ,17) = 0.070 
      B(5 ,18) = 0.020 
      B(5 ,19) = 0.030 
      B(5 ,20) = 0.070 
      B(5 ,21) = 0.020 
      B(5 ,22) = 0.030 
      B(5 ,23) = 0.040 
      B(6 ,1 ) = 0.260 
      B(6 ,2 ) = 0.340 
      B(6 ,3 ) = 0.210 
      B(6 ,4 ) = 0.220 
      B(6 ,5 ) = 0.040 
      B(6 ,6 ) = 1.000 
      B(6 ,7 ) = 0.220 
      B(6 ,8 ) = 0.040 
      B(6 ,9 ) = 0.110 
      B(6 ,10) = 0.050 
      B(6 ,11) = 0.040 
      B(6 ,12) = 0.190 
      B(6 ,13) = 0.140 
      B(6 ,14) = 0.030 
      B(6 ,15) = 0.040 
      B(6 ,16) = 0.150 
      B(6 ,17) = 0.110 
      B(6 ,18) = 0.030 
      B(6 ,19) = 0.070 
      B(6 ,20) = 0.060 
      B(6 ,21) = 0.040 
      B(6 ,22) = 0.210 
      B(6 ,23) = 1.000 
      B(7 ,1 ) = 0.190 
      B(7 ,2 ) = 0.170 
      B(7 ,3 ) = 0.140 
      B(7 ,4 ) = 0.300 
      B(7 ,5 ) = 0.020 
      B(7 ,6 ) = 0.220 
      B(7 ,7 ) = 1.000 
      B(7 ,8 ) = 0.050 
      B(7 ,9 ) = 0.150 
      B(7 ,10) = 0.070 
      B(7 ,11) = 0.050 
      B(7 ,12) = 0.250 
      B(7 ,13) = 0.140 
      B(7 ,14) = 0.050 
      B(7 ,15) = 0.070 
      B(7 ,16) = 0.240 
      B(7 ,17) = 0.160 
      B(7 ,18) = 0.050 
      B(7 ,19) = 0.090 
      B(7 ,20) = 0.090 
      B(7 ,21) = 0.050 
      B(7 ,22) = 0.140 
      B(7 ,23) = 0.220 
      B(8 ,1 ) = 0.150 
      B(8 ,2 ) = 0.040 
      B(8 ,3 ) = 0.080 
      B(8 ,4 ) = 0.070 
      B(8 ,5 ) = 0.020 
      B(8 ,6 ) = 0.040 
      B(8 ,7 ) = 0.050 
      B(8 ,8 ) = 1.000 
      B(8 ,9 ) = 0.110 
      B(8 ,10) = 0.080 
      B(8 ,11) = 0.060 
      B(8 ,12) = 0.160 
      B(8 ,13) = 0.140 
      B(8 ,14) = 0.070 
      B(8 ,15) = 0.070 
      B(8 ,16) = 0.300 
      B(8 ,17) = 0.180 
      B(8 ,18) = 0.060 
      B(8 ,19) = 0.080 
      B(8 ,20) = 0.090 
      B(8 ,21) = 1.000 
      B(8 ,22) = 0.080 
      B(8 ,23) = 0.040 
      B(9 ,1 ) = 0.120 
      B(9 ,2 ) = 0.130 
      B(9 ,3 ) = 0.150 
      B(9 ,4 ) = 0.110 
      B(9 ,5 ) = 0.020 
      B(9 ,6 ) = 0.110 
      B(9 ,7 ) = 0.150 
      B(9 ,8 ) = 0.110 
      B(9 ,9 ) = 1.000 
      B(9 ,10) = 0.030 
      B(9 ,11) = 0.030 
      B(9 ,12) = 0.070 
      B(9 ,13) = 0.080 
      B(9 ,14) = 0.040 
      B(9 ,15) = 0.030 
      B(9 ,16) = 0.090 
      B(9 ,17) = 0.060 
      B(9 ,18) = 0.030 
      B(9 ,19) = 0.150 
      B(9 ,20) = 0.030 
      B(9 ,21) = 0.110 
      B(9 ,22) = 0.150 
      B(9 ,23) = 0.110 
      B(10,1 ) = 0.170 
      B(10,2 ) = 0.070 
      B(10,3 ) = 0.050 
      B(10,4 ) = 0.070 
      B(10,5 ) = 0.060 
      B(10,6 ) = 0.050 
      B(10,7 ) = 0.070 
      B(10,8 ) = 0.080 
      B(10,9 ) = 0.030 
      B(10,10) = 1.000 
      B(10,11) = 0.310 
      B(10,12) = 0.100 
      B(10,13) = 0.510 
      B(10,14) = 0.160 
      B(10,15) = 0.050 
      B(10,16) = 0.130 
      B(10,17) = 0.220 
      B(10,18) = 0.060 
      B(10,19) = 0.140 
      B(10,20) = 0.610 
      B(10,21) = 0.080 
      B(10,22) = 0.050 
      B(10,23) = 0.050 
      B(11,1 ) = 0.120 
      B(11,2 ) = 0.060 
      B(11,3 ) = 0.040 
      B(11,4 ) = 0.040 
      B(11,5 ) = 0.040 
      B(11,6 ) = 0.040 
      B(11,7 ) = 0.050 
      B(11,8 ) = 0.060 
      B(11,9 ) = 0.030 
      B(11,10) = 0.310 
      B(11,11) = 1.000 
      B(11,12) = 0.160 
      B(11,13) = 1.000 
      B(11,14) = 0.300 
      B(11,15) = 0.070 
      B(11,16) = 0.190 
      B(11,17) = 0.260 
      B(11,18) = 0.110 
      B(11,19) = 0.220 
      B(11,20) = 0.480 
      B(11,21) = 0.060 
      B(11,22) = 0.040 
      B(11,23) = 0.040 
      B(12,1 ) = 0.200 
      B(12,2 ) = 0.390 
      B(12,3 ) = 0.150 
      B(12,4 ) = 0.150 
      B(12,5 ) = 0.030 
      B(12,6 ) = 0.190 
      B(12,7 ) = 0.250 
      B(12,8 ) = 0.160 
      B(12,9 ) = 0.070 
      B(12,10) = 0.100 
      B(12,11) = 0.160 
      B(12,12) = 1.000 
      B(12,13) = 0.180 
      B(12,14) = 0.050 
      B(12,15) = 0.080 
      B(12,16) = 0.250 
      B(12,17) = 0.180 
      B(12,18) = 0.050 
      B(12,19) = 0.100 
      B(12,20) = 0.100 
      B(12,21) = 0.160 
      B(12,22) = 0.150 
      B(12,23) = 0.190 
      B(13,1 ) = 0.270 
      B(13,2 ) = 0.160 
      B(13,3 ) = 0.100 
      B(13,4 ) = 0.100 
      B(13,5 ) = 0.080 
      B(13,6 ) = 0.140 
      B(13,7 ) = 0.140 
      B(13,8 ) = 0.140 
      B(13,9 ) = 0.080 
      B(13,10) = 0.510 
      B(13,11) = 0.820 
      B(13,12) = 0.180 
      B(13,13) = 1.000 
      B(13,14) = 0.070 
      B(13,15) = 0.020 
      B(13,16) = 0.070 
      B(13,17) = 0.080 
      B(13,18) = 0.030 
      B(13,19) = 0.060 
      B(13,20) = 0.120 
      B(13,21) = 0.140 
      B(13,22) = 0.100 
      B(13,23) = 0.140 
      B(14,1 ) = 0.090 
      B(14,2 ) = 0.050 
      B(14,3 ) = 0.040 
      B(14,4 ) = 0.040 
      B(14,5 ) = 0.030 
      B(14,6 ) = 0.030 
      B(14,7 ) = 0.050 
      B(14,8 ) = 0.070 
      B(14,9 ) = 0.040 
      B(14,10) = 0.160 
      B(14,11) = 0.300 
      B(14,12) = 0.050 
      B(14,13) = 0.070 
      B(14,14) = 1.000 
      B(14,15) = 0.030 
      B(14,16) = 0.100 
      B(14,17) = 0.100 
      B(14,18) = 0.120 
      B(14,19) = 0.410 
      B(14,20) = 0.130 
      B(14,21) = 0.070 
      B(14,22) = 0.040 
      B(14,23) = 0.030 
      B(15,1 ) = 0.120 
      B(15,2 ) = 0.050 
      B(15,3 ) = 0.050 
      B(15,4 ) = 0.060 
      B(15,5 ) = 0.020 
      B(15,6 ) = 0.040 
      B(15,7 ) = 0.070 
      B(15,8 ) = 0.070 
      B(15,9 ) = 0.030 
      B(15,10) = 0.050 
      B(15,11) = 0.070 
      B(15,12) = 0.080 
      B(15,13) = 0.020 
      B(15,14) = 0.030 
      B(15,15) = 1.000 
      B(15,16) = 0.130 
      B(15,17) = 0.110 
      B(15,18) = 0.020 
      B(15,19) = 0.050 
      B(15,20) = 0.060 
      B(15,21) = 0.070 
      B(15,22) = 0.050 
      B(15,23) = 0.040 
      B(16,1 ) = 0.500 
      B(16,2 ) = 0.180 
      B(16,3 ) = 0.250 
      B(16,4 ) = 0.220 
      B(16,5 ) = 0.080 
      B(16,6 ) = 0.150 
      B(16,7 ) = 0.240 
      B(16,8 ) = 0.300 
      B(16,9 ) = 0.090 
      B(16,10) = 0.130 
      B(16,11) = 0.190 
      B(16,12) = 0.250 
      B(16,13) = 0.070 
      B(16,14) = 0.100 
      B(16,15) = 0.130 
      B(16,16) = 1.000 
      B(16,17) = 0.380 
      B(16,18) = 0.050 
      B(16,19) = 0.100 
      B(16,20) = 0.120 
      B(16,21) = 0.300 
      B(16,22) = 0.250 
      B(16,23) = 0.150 
      B(17,1 ) = 0.300 
      B(17,2 ) = 0.140 
      B(17,3 ) = 0.180 
      B(17,4 ) = 0.150 
      B(17,5 ) = 0.070 
      B(17,6 ) = 0.110 
      B(17,7 ) = 0.160 
      B(17,8 ) = 0.180 
      B(17,9 ) = 0.060 
      B(17,10) = 0.220 
      B(17,11) = 0.260 
      B(17,12) = 0.180 
      B(17,13) = 0.080 
      B(17,14) = 0.100 
      B(17,15) = 0.110 
      B(17,16) = 0.380 
      B(17,17) = 1.000 
      B(17,18) = 0.050 
      B(17,19) = 0.090 
      B(17,20) = 0.180 
      B(17,21) = 0.180 
      B(17,22) = 0.180 
      B(17,23) = 0.110 
      B(18,1 ) = 0.060 
      B(18,2 ) = 0.050 
      B(18,3 ) = 0.030 
      B(18,4 ) = 0.030 
      B(18,5 ) = 0.020 
      B(18,6 ) = 0.030 
      B(18,7 ) = 0.050 
      B(18,8 ) = 0.060 
      B(18,9 ) = 0.030 
      B(18,10) = 0.060 
      B(18,11) = 0.110 
      B(18,12) = 0.050 
      B(18,13) = 0.030 
      B(18,14) = 0.120 
      B(18,15) = 0.020 
      B(18,16) = 0.050 
      B(18,17) = 0.050 
      B(18,18) = 1.000 
      B(18,19) = 0.090 
      B(18,20) = 0.020 
      B(18,21) = 0.060 
      B(18,22) = 0.030 
      B(18,23) = 0.030 
      B(19,1 ) = 0.130 
      B(19,2 ) = 0.090 
      B(19,3 ) = 0.070 
      B(19,4 ) = 0.060 
      B(19,5 ) = 0.030 
      B(19,6 ) = 0.070 
      B(19,7 ) = 0.090 
      B(19,8 ) = 0.080 
      B(19,9 ) = 0.150 
      B(19,10) = 0.140 
      B(19,11) = 0.220 
      B(19,12) = 0.100 
      B(19,13) = 0.060 
      B(19,14) = 0.410 
      B(19,15) = 0.050 
      B(19,16) = 0.100 
      B(19,17) = 0.090 
      B(19,18) = 0.090 
      B(19,19) = 1.000 
      B(19,20) = 0.080 
      B(19,21) = 0.080 
      B(19,22) = 0.070 
      B(19,23) = 0.070 
      B(20,1 ) = 0.260 
      B(20,2 ) = 0.080 
      B(20,3 ) = 0.060 
      B(20,4 ) = 0.070 
      B(20,5 ) = 0.070 
      B(20,6 ) = 0.060 
      B(20,7 ) = 0.090 
      B(20,8 ) = 0.090 
      B(20,9 ) = 0.030 
      B(20,10) = 0.610 
      B(20,11) = 0.480 
      B(20,12) = 0.100 
      B(20,13) = 0.120 
      B(20,14) = 0.130 
      B(20,15) = 0.060 
      B(20,16) = 0.120 
      B(20,17) = 0.180 
      B(20,18) = 0.020 
      B(20,19) = 0.080 
      B(20,20) = 1.000 
      B(20,21) = 0.090 
      B(20,22) = 0.060 
      B(20,23) = 0.060 
      B(21,1 ) = 0.150 
      B(21,2 ) = 0.040 
      B(21,3 ) = 0.080 
      B(21,4 ) = 0.070 
      B(21,5 ) = 0.020 
      B(21,6 ) = 0.040 
      B(21,7 ) = 0.050 
      B(21,8 ) = 1.000 
      B(21,9 ) = 0.110 
      B(21,10) = 0.080 
      B(21,11) = 0.060 
      B(21,12) = 0.160 
      B(21,13) = 0.140 
      B(21,14) = 0.070 
      B(21,15) = 0.070 
      B(21,16) = 0.300 
      B(21,17) = 0.180 
      B(21,18) = 0.060 
      B(21,19) = 0.080 
      B(21,20) = 0.090 
      B(21,21) = 1.000 
      B(21,22) = 0.080 
      B(21,23) = 0.040 
      B(22,1 ) = 0.130 
      B(22,2 ) = 0.140 
      B(22,3 ) = 1.000 
      B(22,4 ) = 0.170 
      B(22,5 ) = 0.030 
      B(22,6 ) = 0.210 
      B(22,7 ) = 0.140 
      B(22,8 ) = 0.080 
      B(22,9 ) = 0.150 
      B(22,10) = 0.050 
      B(22,11) = 0.040 
      B(22,12) = 0.150 
      B(22,13) = 0.100 
      B(22,14) = 0.040 
      B(22,15) = 0.050 
      B(22,16) = 0.250 
      B(22,17) = 0.180 
      B(22,18) = 0.030 
      B(22,19) = 0.070 
      B(22,20) = 0.060 
      B(22,21) = 0.080 
      B(22,22) = 1.000 
      B(22,23) = 0.210 
      B(23,1 ) = 0.260 
      B(23,2 ) = 0.340 
      B(23,3 ) = 0.210 
      B(23,4 ) = 0.220 
      B(23,5 ) = 0.040 
      B(23,6 ) = 1.000 
      B(23,7 ) = 0.220 
      B(23,8 ) = 0.040 
      B(23,9 ) = 0.110 
      B(23,10) = 0.050 
      B(23,11) = 0.040 
      B(23,12) = 0.190 
      B(23,13) = 0.140 
      B(23,14) = 0.030 
      B(23,15) = 0.040 
      B(23,16) = 0.150 
      B(23,17) = 0.110 
      B(23,18) = 0.030 
      B(23,19) = 0.070 
      B(23,20) = 0.060 
      B(23,21) = 0.040 
      B(23,22) = 0.210 
      B(23,23) = 1.000 
      return
      end subroutine




****************************************************
c     common/ranzy/nozy                            *
*     nozy=-1 (less than 0)                        *
*     rrr=ranzy(nozy)                              *
****************************************************
      function aranzy(nozy)
c   random numbers uniformly distributed between 0 and 1.
c   (code by Y. Zhang, ITP, Acdemia Sincica, 1999.6
c   can be replaced by any other suitable generator for random numbers)
      common/asdfa/ix1,ix2,ix3,rm1,rm2,r(99)
      data ia1,ic1,m1/1279,351762,1664557/
      data ia2,ic2,m2/2011,221592,1048583/
      data ia3,ic3,m3/15551,6150,29101/
      if(nozy.ge.0) go to 2
      ix1=mod(-nozy,m1)
      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ix1,m2)
      ix1=mod(ia1*ix1+ic1,m1)
      ix3=mod(ix1,m3)
      rm1=1./float(m1)
      rm2=1./float(m2)
      do 1 j=1,99
      ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ia2*ix2+ic2,m2)
 1    r(j)=(float(ix1)+float(ix2)*rm2)*rm1
 2    ix1=mod(ia1*ix1+ic1,m1)
      ix2=mod(ia2*ix2+ic2,m2)
      ix3=mod(ia3*ix3+ic3,m3)
      j=1+(99*ix3)/m3
      aranzy=r(j)
      r(j)=(float(ix1)+float(ix2)*rm2)*rm1
      nozy=ix1
      return
      end

      
c      FUNCTION DECODE_INTEGER(STRINGN)
c      INTEGER DECODE_INTEGER,IOSTAT, LENGTH, NUMBER
c      CHARACTER*4 STRING, FMT
c     . Initialize the integer.
c      NUMBER = 0
c     . Find the length of the string.
c      LENGTH = LEN(TRIM(STRING))
c     . The string has a non-zero length.
c      IF (LENGTH > 0) THEN
c     . Write the format to the character string FMT.
c         
c         WRITE ( FMT,'(A,I2,A)', IOSTAT = IOSTAT )'(I', LENGTH,')'
c         IF (IOSTAT == 0)READ(STRING(1:LENGTH),FMT,IOSTAT= IOSTAT)NUMBER
c      END IF
c     . Assign a value to the function.
c      DECODE_INTEGER = NUMBER
c      END FUNCTION DECODE_INTEGER
      

 
