*************************************************************************
*     This program is to identify the best alignment of two protein 
*     structures based on TM-score superposition matrix and profile-profile
*     alignment
*     (For comments, please email to: ambyroy@umich.edu)
*************************************************************************
      program PRTMALIGN
      PARAMETER(nmax=5000)
      PARAMETER(nmax2=10000)
      PARAMETER(NAA=22)         !type o
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/alignrst/invmap0(nmax)
      common/length/nseq1,nseq2
      common/d0/d0,anseq
      common/d0min/d0_min
      common/d00/d00,d002
      COMMON/SEQN/ISEQ1(NMAX),ISEQ2(NMAX)
      COMMON/WEI/W1,W2
      character*100 fnam,pdb(2),outname,libstr,pdbdir
      character*3 aa(0:22),aanam,ss1(nmax),ss2(nmax)
      character*100 s,du,mtx1,mtx2
      character*200 outnameall_tmp,outnameall
      character seq1(0:nmax),seq2(0:nmax)
      character aseq1(nmax2),aseq2(nmax2),aseq3(nmax2)
      character*100 list, libdir,fMTX
      dimension xx(nmax),yy(nmax),zz(nmax)
      dimension m1(nmax),m2(nmax)
      dimension xtm1(nmax),ytm1(nmax),ztm1(nmax)
      dimension xtm2(nmax),ytm2(nmax),ztm2(nmax)
      common/init/invmap_i(nmax)
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
      common/TM/TM,TMmax
      common/n1n2/n1(nmax),n2(nmax)
      common/d8/d8
      common/initial4/mm1(nmax),mm2(nmax)
      COMMON/MATRIX/B(NAA,NAA)
      character fmyprf*100
ccc   RMSD:
      double precision r_1(3,nmax),r_2(3,nmax),r_3(3,nmax),w(nmax)
      double precision u(3,3),t(3),rms,drms !armsd is real
      data w /nmax*1.0/
ccc   
      data aa/'BCK','ALA','ASX','CYS','ASP','GLU','PHE',
     &        'GLY','HIS','ILE','LYS','LEU','MET','ASN',
     &        'PRO','GLN','ARG','SER','THR','VAL','TRP',
     &        'UNK','TYR'/
      character*1 slc(0:22)
      data slc/'-','A','B','C','D','E','F','G','H','I',
     &     'K','L','M','N','P','Q','R','S','T','V',
     &     'W','X','Y'/



      call getarg(1,fnam)
      if(fnam.eq.' '.or.fnam.eq.'?'.or.fnam.eq.'-h')then
         write(*,*)
         write(*,*)'Brief instruction for running PRTMalign program:'
         write(*,*)'1. Align ''structure.pdb'' to ''target.pdb'''
         write(*,*)'  (By default, TM-score is normalized by the ',
     &        'length of ''target.pdb'')'
         write(*,*)'  >TMalign structure.pdb target.pdb'
         write(*,*)
         write(*,*)'2. Run TM-align and output the superposition ',
     &        'to ''TM.sup'' and ''TM.sup_all'':'
         write(*,*)'  >TMalign structure.pdb target.pdb -o TM.sup'
         write(*,*)'   To view the superimposed structures of the',
     &        ' aligned regions by rasmol:'
         write(*,*)'  >rasmol -script TM.sup)'
         write(*,*)'   To view the superimposed structures of all',
     &        ' regions by rasmol:'
         write(*,*)'  >rasmol -script TM.sup_all)'
         write(*,*)
         write(*,*)'3. If you want TM-score normalized by ',
     &        'an assigned length, e.g. 100 aa:'
         write(*,*)'  >TMalign structure.pdb target.pdb -L 100'
         write(*,*)'   If you want TM-score normalized by the ',
     &        'average length of two structures:'
         write(*,*)'  >TMalign structure.pdb target.pdb -a'
         write(*,*)'   If you want TM-score normalized by the ',
     &        'shorter length of two structures:'
         write(*,*)'  >TMalign structure.pdb target.pdb -b'
         write(*,*)'   If you want TM-score normalized by the ',
     &        'longer length of two structures:'
         write(*,*)'  >TMalign structure.pdb target.pdb -c'
         write(*,*)
         write(*,*)'(All above options does not change the ',
     &         'final structure alignment result)'
         write(*,*)
         goto 9999
      endif

******* options ----------->
      m_out=-1                  !decided output
      m_fix=-1                  !fixed length-scale only for output
      m_ave=-1                  !using average length
      m_d0_min=-1               !diminum d0 for search
      m_d0=-1                   !given d0 for both search and output
      narg=iargc()
      i=0
      j=0

      call getarg(1,fnam)
      pdb(1)=fnam
      call getarg(2,fnam)
      fmtx=fnam
      call getarg(3,fnam)
      pdb(2)=fnam
      call getarg(4,fnam)
      mtx2=fnam
      CALL BLOSSUM      
      w1 = 0.1
      w2 = 0.9 
ccccccccc read data from the second CA i.e Combo:
      open(unit=10,file=pdb(2),status='old')
      i=0
      do while (.true.)
         read(10,9001,end=1011) s
         if(i.gt.0.and.s(1:3).eq.'TER')goto 1011
         if(s(1:3).eq.'ATO')then
            if(s(13:16).eq.'CA  '.or.s(13:16).eq.' CA '.or.
     &           s(13:16).eq.'  CA')then
               if(s(17:17).eq.' '.or.s(17:17).eq.'A')then
                  i=i+1
                  read(s,9000)du,aanam,du,mm2(i),du,
     &                 xa(1,i,1),xa(2,i,1),xa(3,i,1)
                  ISEQ2(i)=7    ! GLY 
                  do j=0,22
                     if(aanam.eq.aa(j))seq2(i)=slc(j)
                     if(aanam.eq.aa(j))ISEQ2(i)=j
                  enddo
                  ss2(i)=aanam
                  if(i.ge.nmax)goto 1011
               endif
            endif
         endif
      enddo
 1011 continue
      close(10)
      nseq2=i
 9000 format(A17,A3,A2,i4,A4,3F8.3)
 9001 format(A100)

******** Read MTX file of Query ******************************************

      open(unit=20,file=mtx2,status='old')
      read(20,*) nres
      if(nres.ne.nseq2) then
         write(*,*) '# residue inconsistent ! ',fnam,nres,nseq2
         STOP
      endif
      do i=1,nres
         read(20,*)l,du,m,(qprf(i,j),j=1,22) 
      enddo
      close(20)


c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
c      call getarg(3,libdir)
c      itmp= 0  
c      list = "list"
c      list=trim(libdir)//list
c      open(unit=11,file=list,status='old')
c      read(11,*)ns
      
c      do jjj=1,ns
c         read(11,fmt=*,end=1111) libstr
c         itmp=len_trim(libstr) 
c         fMTX='/library/yzhang/MTX/'//libstr(1:itmp)//'.mtx'
c         pdb(1)= libstr(1:itmp)//".pdb"
c         itmp=len_trim(libdir)
c         pdb(1)=libdir(1:itmp)//pdb(1)
ccccccccc read data from first CA file:    
         open(unit=10,file=pdb(1),status='old')         
         i=0
         do while (.true.)
            read(10,9001,end=1010) s
            if(i.gt.0.and.s(1:3).eq.'TER')goto 1010
            if(s(1:3).eq.'ATO')then
               if(s(13:16).eq.'CA  '.or.s(13:16).eq.' CA '.or
     &              .s(13:16).eq.'  CA')then
                  if(s(17:17).eq.' '.or.s(17:17).eq.'A')then
                     i=i+1
                     read(s,9000)du,aanam,du,mm1(i),du,
     &                    xa(1,i,0),xa(2,i,0),xa(3,i,0)
                     ISEQ1(i)=7 ! GLY 
                     do j=0,22
                        if(aanam.eq.aa(j))seq1(i)=slc(j)
                        if(aanam.eq.aa(j))ISEQ1(i)=j
                     enddo
                     ss1(i)=aanam
                     if(i.ge.nmax)goto 1010
                  endif
               endif
            endif
         enddo
 1010    continue
         close(10)
         nseq1=i
         call read_mtx(imy,tprf,fMTX)
c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^



*!!!  Scale of TM-score in search is based on the smaller protein --------->
      d0_min=0.5
      if(m_d0_min.eq.1)then
         d0_min=d0_min_input    !for search
      endif
      anseq_min=min(nseq1,nseq2)
      anseq=anseq_min           !length for defining TMscore in search
      d8=1.5*anseq_min**0.3+3.5 !remove pairs with dis>d8 during search & final
      if(anseq.gt.15)then
         d0=1.24*(anseq-15)**(1.0/3.0)-1.8 !scale for defining TM-score
      else
         d0=d0_min
      endif
      if(d0.lt.d0_min)d0=d0_min
      if(m_d0.eq.1)d0=d0_fix
      d00=d0                    !for quickly calculate TM-score in searching
      if(d00.gt.8)d00=8
      if(d00.lt.4.5)d00=4.5
      d002=d00**2
      nseq=max(nseq1,nseq2)
      do i=1,nseq
         n1(i)=i
         n2(i)=i
      enddo
      
***** do alignment **************************
      CALL super_align          !to find invmap(j)
      
************************************************************
***   resuperpose to find residues of dis<d8 ------------------------>
      n_al=0
      do j=1,nseq2
         if(invmap0(j).gt.0)then
            i=invmap0(j)
            n_al=n_al+1
            xtm1(n_al)=xa(1,i,0)
            ytm1(n_al)=xa(2,i,0)
            ztm1(n_al)=xa(3,i,0)
            xtm2(n_al)=xa(1,j,1)
            ytm2(n_al)=xa(2,j,1)
            ztm2(n_al)=xa(3,j,1)
            m1(n_al)=i          !for recording residue order
            m2(n_al)=j
         endif
      enddo
      d0_input=d0
      call TMscore8(d0_input,n_al,xtm1,ytm1,ztm1,n1,n_al,
     &     xtm2,ytm2,ztm2,n2,TM,Rcomm,Lcomm) !TM-score with dis<d8 only

*!!!  Output TM-score is based on the second protein------------------>
      d0_min=0.5                !for output
      anseq=nseq2               !length for defining final TMscore
      if(m_ave.eq.1)anseq=(nseq1+nseq2)/2.0 !<L>
      if(m_ave.eq.2)anseq=min(nseq1,nseq2)
      if(m_ave.eq.3)anseq=max(nseq1,nseq2)
      if(anseq.lt.anseq_min)anseq=anseq_min
      if(m_fix.eq.1)anseq=L_fix !input length
      if(anseq.gt.15)then
         d0=1.24*(anseq-15)**(1.0/3.0)-1.8 !scale for defining TM-score
      else
         d0=d0_min
      endif
      if(d0.lt.d0_min)d0=d0_min
      if(m_d0.eq.1)d0=d0_fix
      
***   remove dis>d8 in normal TM-score calculation for final report----->
      j=0
      n_eq=0
      do i=1,n_al
         dis2=sqrt((xtm1(i)-xtm2(i))**2+(ytm1(i)-ytm2(i))**2+
     &        (ztm1(i)-ztm2(i))**2)
         if(dis2.le.d8)then
            j=j+1
            xtm1(j)=xtm1(i)
            ytm1(j)=ytm1(i)
            ztm1(j)=ztm1(i)
            xtm2(j)=xtm2(i)
            ytm2(j)=ytm2(i)
            ztm2(j)=ztm2(i)
            m1(j)=m1(i)
            m2(j)=m2(i)
            if(ss1(m1(i)).eq.ss2(m2(i)))then
               n_eq=n_eq+1
            endif
         endif
      enddo
      seq_id=float(n_eq)/(n_al+0.00000001)
      n8_al=j
      d0_input=d0
      call TMscore(d0_input,n8_al,xtm1,ytm1,ztm1,n1,n8_al,
     &     xtm2,ytm2,ztm2,n2,TM8,Rcomm,Lcomm) !normal TMscore
      rmsd8_al=Rcomm
      TM9=TM8*n8_al/nseq1
      anseq=nseq2
      TM8=TM8*n8_al/anseq       !TM-score after cutoff
********* for output summary ******************************
c      write(*,*)
c      write(*,*)'*****************************************************',
c     &     '*********************'
c      write(*,*)'*                               TM-align             ',
c     &     '                    *'
c      write(*,*)'* A protein structural alignment algorithm based on T',
c     &     'M-score             *'
c      write(*,*)'* Reference: Y. Zhang and J. Skolnick, Nucl. Acids Re',
c     &     's. 2005 33, 2302-9  *'
c      write(*,*)'* Comments on the program, please email to: yzhang@ku',
c     &     '.edu                *'
c      write(*,*)'*****************************************************',
c     &     '*********************'
c      write(*,*)
c      write(*,101)pdb(1),nseq1
c 101  format('Chain 1:',A10,'  Size=',I4)
c      write(*,102)pdb(2),nseq2,int(anseq)
c 102  format('Chain 2:',A10,'  Size=',I4,
c     &     ' (TM-score is normalized by ',I4,')')
c     write(*,*)
c      open (unit = 1, file = "tmp.res")
      write(*,103)pdb(1),n8_al,rmsd8_al,TM8,seq_id,nseq2
 103  format('Target= ',A10,', Aligned length=',I4,', RMSD=',f6.2,
     &     ', TM-score=',f7.5,', ID=',f5.3' , TLEN=',I4)
c      close(1)



********* extract rotation matrix ------------>
      L=0
      do i=1,n8_al
         k=m1(i)
         L=L+1
         r_1(1,L)=xa(1,k,0)
         r_1(2,L)=xa(2,k,0)
         r_1(3,L)=xa(3,k,0)
         r_2(1,L)=xtm1(i)
         r_2(2,L)=ytm1(i)
         r_2(3,L)=ztm1(i)
       enddo
c       if(L.gt.3)then
c         call u3b(w,r_1,r_2,L,1,rms,u,t,ier) !u rotate r_1 to r_2
c         armsd=dsqrt(rms/L)
c         write(*,*)'-------- rotation matrix to rotate Chain-1 to ',
c     &        'Chain-2 ------'
c         write(*,*)'i          t(i)         u(i,1)         u(i,2) ',
c     &        '        u(i,3)'
c         do i=1,3
c            write(*,204)i,t(i),u(i,1),u(i,2),u(i,3)
c         enddo
c         do i=1,nseq1
c            ax=t(1)+u(1,1)*xa(1,i,0)+u(1,2)*xa(2,i,0)+u(1,3)*xa(3,i,0)
c            ay=t(2)+u(2,1)*xa(1,i,0)+u(2,2)*xa(2,i,0)+u(2,3)*xa(3,i,0)
c            az=t(3)+u(3,1)*xa(1,i,0)+u(3,2)*xa(2,i,0)+u(3,3)*xa(3,i,0)
c         enddo
c         write(*,*)
c      endif
c 204  format(I2,f18.10,f15.10,f15.10,f15.10)
      
********* for output superposition ******************************
      if(m_out.eq.1)then
 1237    format('ATOM  ',i5,'  CA  ',A3,I6,4X,3F8.3)
 1238    format('TER')
 1239    format('CONECT',I5,I5)
 900     format(A)
 901     format('select atomno=',I4)
 104     format('REMARK Chain 1:',A10,'  Size=',I4)
 105     format('REMARK Chain 2:',A10,'  Size=',I4,
     &        ' (TM-score is normalized by ',I4,')')
 106     format('REMARK Aligned length=',I4,', RMSD=',f6.2,
     &        ', TM-score=',f7.5,', ID=',f5.3)
         OPEN(unit=7,file=outname,status='unknown') !pdb1.aln + pdb2.aln
***   script:
         write(7,900)'load inline'
         write(7,900)'select atomno<2000'
         write(7,900)'wireframe .45'
         write(7,900)'select none'
         write(7,900)'select atomno>2000'
         write(7,900)'wireframe .20'
         write(7,900)'color white'
         do i=1,n8_al
            dis2=sqrt((xtm1(i)-xtm2(i))**2+
     &           (ytm1(i)-ytm2(i))**2+(ztm1(i)-ztm2(i))**2)
            if(dis2.le.5)then
               write(7,901)m1(i)
               write(7,900)'color red'
               write(7,901)2000+m2(i)
               write(7,900)'color red'
            endif
         enddo
         write(7,900)'select all'
         write(7,900)'exit'
         write(7,104)pdb(1),nseq1
         write(7,105)pdb(2),nseq2,int(anseq)
         write(7,106)n8_al,rmsd8_al,TM8,seq_id
***   chain1:
         do i=1,n8_al
            write(7,1237)m1(i),ss1(m1(i)),mm1(m1(i)),
     &           xtm1(i),ytm1(i),ztm1(i)
         enddo
         write(7,1238)          !TER
         do i=2,n8_al
            write(7,1239)m1(i-1),m1(i) !connect atoms
         enddo
***   chain2:
         do i=1,n8_al
            write(7,1237)2000+m2(i),ss2(m2(i)),mm2(m2(i)),
     $           xtm2(i),ytm2(i),ztm2(i)
         enddo
         write(7,1238)
         do i=2,n8_al
            write(7,1239)2000+m2(i-1),2000+m2(i)
         enddo
         close(7)
ccc   
         k=0
         outnameall_tmp=outname//'_all'
         outnameall=''
         do i=1,200
            if(outnameall_tmp(i:i).ne.' ')then
               k=k+1
               outnameall(k:k)=outnameall_tmp(i:i)
            endif
         enddo
         OPEN(unit=8,file=outnameall,status='unknown') !pdb1.aln + pdb2.aln
***   script:
         write(8,900)'load inline'
         write(8,900)'select atomno<2000'
         write(8,900)'wireframe .45'
         write(8,900)'select none'
         write(8,900)'select atomno>2000'
         write(8,900)'wireframe .20'
         write(8,900)'color white'
         do i=1,n8_al
            dis2=sqrt((xtm1(i)-xtm2(i))**2+
     &           (ytm1(i)-ytm2(i))**2+(ztm1(i)-ztm2(i))**2)
            if(dis2.le.5)then
               write(8,901)m1(i)
               write(8,900)'color red'
               write(8,901)2000+m2(i)
               write(8,900)'color red'
            endif
         enddo
         write(8,900)'select all'
         write(8,900)'exit'
         write(8,104)pdb(1),nseq1
         write(8,105)pdb(2),nseq2,int(anseq)
         write(8,106)n8_al,rmsd8_al,TM8,seq_id
***   chain1:
         do i=1,nseq1
            ax=t(1)+u(1,1)*xa(1,i,0)+u(1,2)*xa(2,i,0)+u(1,3)*xa(3,i,0)
            ay=t(2)+u(2,1)*xa(1,i,0)+u(2,2)*xa(2,i,0)+u(2,3)*xa(3,i,0)
            az=t(3)+u(3,1)*xa(1,i,0)+u(3,2)*xa(2,i,0)+u(3,3)*xa(3,i,0)
            write(8,1237)i,ss1(i),mm1(i),ax,ay,az
         enddo
         write(8,1238)          !TER
         do i=2,nseq1
            write(8,1239)i-1,i
         enddo
***   chain2:
         do i=1,nseq2
            write(8,1237)2000+i,ss2(i),mm2(i),
     $           xa(1,i,1),xa(2,i,1),xa(3,i,1)
         enddo
         write(8,1238)
         do i=2,nseq2
            write(8,1239)2000+i-1,2000+i
         enddo
         close(8)
      endif
*^^^^^^^^^^^^^^^^^^ output finished ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

************  output aligned sequences **************************
      ii=0
      i1_old=1
      i2_old=1
      do i=1,n8_al
         do j=i1_old,m1(i)-1
            ii=ii+1
            aseq1(ii)=seq1(j)
            aseq2(ii)='-'
            aseq3(ii)=' '
         enddo
         do j=i2_old,m2(i)-1
            ii=ii+1
            aseq1(ii)='-'
            aseq2(ii)=seq2(j)
            aseq3(ii)=' '
         enddo
         ii=ii+1
         aseq1(ii)=seq1(m1(i))
         aseq2(ii)=seq2(m2(i))
         dis2=sqrt((xtm1(i)-xtm2(i))**2+
     &     (ytm1(i)-ytm2(i))**2+(ztm1(i)-ztm2(i))**2)
         if(dis2.le.5)then
           aseq3(ii)=':'
         else
           aseq3(ii)='.'
         endif
         i1_old=m1(i)+1
         i2_old=m2(i)+1
      enddo
      do i=i1_old,nseq1
         ii=ii+1
         aseq1(ii)=seq1(i)
         aseq2(ii)='-'
         aseq3(ii)=' '
      enddo
      do i=i2_old,nseq2
         ii=ii+1
         aseq1(ii)='-'
         aseq2(ii)=seq2(i)
         aseq3(ii)=' '
      enddo
c      write(*,50)
c 50   format('(":" denotes the residue pairs of distance < 5.0 ',
c     &     'Angstrom)')
c      write(*,10)(aseq1(i),i=1,ii)
c      write(*,10)(aseq3(i),i=1,ii)
c      write(*,10)(aseq2(i),i=1,ii)
c 10   format(10000A1)
c      write(*,*)
 5555 continue
c      enddo
 1111 continue


c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 9999 END

***********************************************************************
*     Subroutine to read the MTX profile of the template              *
***********************************************************************
      subroutine read_mtx(im,mtx,fln)
      implicit real*8(a-h)
      parameter(nmax=5000)
      character filen*100,whole*280,fln*100,filen_tmp*200
      real*8 mtx(nmax,23),mtx0(23)
      real*8 logist
      integer bls(27)

      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
      filen_tmp=fln
      filen=''
      k=0
      do i=1,200
         if(filen_tmp(i:i).ne.' ')then
            k=k+1
            filen(k:k)=filen_tmp(i:i)
         endif
      enddo
     
       open(unit=20,file=filen,status='old')
       do i=1,14
          read(20,*)
       enddo
       IMAX=0
       IMIN=0
  130  read(20,'(a261)',end=132) whole
       if(whole(1:1).eq.'-') then        
          read(whole(1:200),*) (bls(j),j=1,26)        
          do I=1,26             
             IF((I.EQ.1).OR.(I.EQ.3).OR.(I.EQ.24).OR.(I.EQ.25))GOTO 131
             IF(bls(I).LE.IMIN)IMIN=bls(I)
             IF(bls(I).GE.IMAX)IMAX=bls(I)           
  131        CONTINUE
          enddo
       end if
       goto 130
  132  close(20)

       IDIFF=IMAX-IMIN
       num=0
       open(unit=20,file=filen,status='old')
       do i=1,14
          read(20,*)
       enddo
  133  read(20,'(a261)',end=135) whole
       if(whole(1:1).eq.'-') then
          num=num+1
          read(whole(1:200),*) (bls(j),j=1,26)
          K=0  
          do I=1,26             
             IF((I.EQ.1).OR.(I.EQ.3).OR.(I.EQ.24).OR.(I.EQ.25))GOTO 134
             K = K+1            
             tprf(num,K)= real((bls(I)-real(IMIN))/IDIFF)
c            tprf(num,K)= real(bls(I)+1000)/real(2000)
  134        CONTINUE
          enddo

       end if
       goto 133
  135  close(20)      
c

c       num=0
c       open(unit=20,file=filen,status='old')
c       do i=1,14
c          read(20,*)
c       enddo
c  130  read(20,'(a261)',end=133) whole 
c       if(whole(1:1).eq.'-') then
c         num=num+1
c         read(whole(1:200),*) (bls(j),j=1,26)
c         K=0
c         IMAX=0
c         IMIN=0
c         do I=1,26             
c            IF((I.EQ.1).OR.(I.EQ.3).OR.(I.EQ.24).OR.(I.EQ.25))GOTO 131
c            K = K+1            
c            IF(bls(I).LE.IMIN)IMIN=bls(I)
c            IF(bls(I).GE.IMAX)IMAX=bls(I)
c 131        CONTINUE
c          enddo
c         K=0
c         IDIFF=IMAX-IMIN
c         asum = 0
c         do I=1,26         
c            IF((I.EQ.1).OR.(I.EQ.3).OR.(I.EQ.24).OR.(I.EQ.25))GOTO 132
c            K = K + 1
c            asum= asum + real(bls(I)-real(IMIN))
c 132        CONTINUE
c         enddo
c         K=0
c         do I=1,26         
c            IF((I.EQ.1).OR.(I.EQ.3).OR.(I.EQ.24).OR.(I.EQ.25))GOTO 134
c            K = K + 1
c            tprf(num,K)= real((bls(I)-IMIN)/asum)
c 134        CONTINUE
c         enddo         
c        
c       endif      
c      goto 130
c 133  close(20)

      return
      end

***********************************************************************
***********************************************************************
*     Structure superposition
***********************************************************************
***********************************************************************
***********************************************************************
      SUBROUTINE super_align
      PARAMETER(nmax=5000)
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/length/nseq1,nseq2
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/alignrst/invmap0(nmax)
      common/zscore/zrms,n_al,rmsd_al
      common/TM/TM,TMmax
      common/init/invmap_i(nmax)
      common/init1/invmap_ii(nmax)
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
      dimension gapp(100)

      TMmax=0
      TMtemp=0
      n_gapp=2
      gapp(1)=-0.6
      gapp(2)=0

c      n_gapp=11
c      do i=1,n_gapp
c         gapp(i)=-(n_gapp-i)
c      enddo

*11111111111111111111111111111111111111111111111111111111
*     get initial alignment from gapless threading
**********************************************************
      call get_initial          !gapless threading
      do i=1,nseq2
         invmap(i)=invmap_i(i)  !with highest zcore
      enddo
      call get_score            !TM, matrix score(i,j)
     
      if(TM.gt.TMmax)then
         TMmax=TM
         do j=1,nseq2
            invmap0(j)=invmap(j)
         enddo
      endif

*****************************************************************
*       initerative alignment, for different gap_open:
*****************************************************************
      DO 111 i_gapp=1,n_gapp	!different gap panalties
         GAP_OPEN=gapp(i_gapp)  !gap panalty
         do 222 id=1,30         !maximum interation is 200
            call DP(NSEQ1,NSEQ2) !produce alignment invmap(j)
*     Input: score(i,j), and gap_open
*     Output: invmap(j)
             
            call get_score      !calculate TM-score, score(i,j)
            !print *,"In1a",TM,TMmax
c     record the best alignment in whole search ---------->
            if(TM.gt.TMmax)then
               TMmax=TM
               do j=1,nseq2
                  invmap0(j)=invmap(j)
               enddo
            endif
            if(id.gt.1)then
               diff=abs(TM-TM_old)
               if(diff.lt.0.000001)goto 33
            endif
            TM_old=TM
 222     continue
 33      continue
 111  continue

      do i=1,nseq2
         invmap(i)=invmap_ii(i)  !with highest zcore
      enddo
      call get_score            !TM, matrix score(i,j)
     
      if(TM.gt.TMmax)then
         TMmax=TM
         do j=1,nseq2
            invmap0(j)=invmap(j)
         enddo
      endif
      if(TM.gt.TMmax*0.2)then
*****************************************************************
*       initerative alignment, for different gap_open:
*****************************************************************
      DO 112 i_gapp=1,n_gapp	!different gap panalties
         GAP_OPEN=gapp(i_gapp)  !gap panalty
         do 223 id=1,2          !maximum interation is 200
            call DP(NSEQ1,NSEQ2) !produce alignment invmap(j)
*     Input: score(i,j), and gap_open
*     Output: invmap(j)
             
            call get_score      !calculate TM-score, score(i,j)
            !print *,"In1a",TM,TMmax
c     record the best alignment in whole search ---------->
            if(TM.gt.TMmax)then
               TMmax=TM
               do j=1,nseq2
                  invmap0(j)=invmap(j)
               enddo
            endif
            if(id.gt.1)then
               diff=abs(TM-TM_old)
               if(diff.lt.0.000001)goto 34
            endif
            TM_old=TM
 223     continue
 34      continue
 112  continue
      endif

*666666666666666666666666666666666666666666666666666666666666666666
*   Get initial from profile-profile alignment                    *
*666666666666666666666666666666666666666666666666666666666666666666

      call get_initial6         !DP for secondary structure                                                                                                
      do i=1,nseq2
         invmap(i)=invmap_i(i)  !with highest zcore 
      enddo
      call get_score            !TM, score(i,j)                                                                                                             
c                                                                                                                    
      if(TM.gt.TMmax)then
         TMmax=TM
         do j=1,nseq2
            invmap0(j)=invmap(j)
         enddo
      endif
c      if(TM.gt.TMmax*0.2)then
*****************************************************************                                                                                           
*     initerative alignment, for different gap_open:                                                                                                        
*****************************************************************                                                                                           
      DO 6667 i_gapp=1,n_gapp   !different gap panalties                                                                                                    
         GAP_OPEN=gapp(i_gapp)  !gap panalty                                                                                                                
         do 6666 id=1,30        !maximum interation is 200                                                                                                  
            call DP(NSEQ1,NSEQ2) !produce alignment invmap(j)                                                                                               
                                                                                                                                 

            call get_score      !calculate TM-score, score(i,j)                                                                                             
                                                                                            
            if(TM.gt.TMmax)then
               TMmax=TM
               do j=1,nseq2
                  invmap0(j)=invmap(j)
               enddo
            endif
            if(id.gt.1)then
               diff=abs(TM-TM_old)
               if(diff.lt.0.000001)goto 666
            endif
            TM_old=TM
 6666    continue
 666     continue
 6667 continue


c      endif
*222222222222222222222222222222222222222222222222222222222
*     get initial alignment from secondary structure alignment
**********************************************************
      call get_initial2         !DP for secondary structure
      do i=1,nseq2
         invmap(i)=invmap_i(i)  !with highest zcore
      enddo
      call get_score            !TM, score(i,j)
      !print *,"Ini2",TM,TMmax     
      if(TM.gt.TMmax)then
         TMmax=TM
         do j=1,nseq2
            invmap0(j)=invmap(j)
         enddo
      endif
      if(TM.gt.TMmax*0.2)then
*****************************************************************
*     initerative alignment, for different gap_open:
*****************************************************************
      DO 1111 i_gapp=1,n_gapp	!different gap panalties
         GAP_OPEN=gapp(i_gapp)  !gap panalty
         do 2222 id=1,30	!maximum interation is 200
            call DP(NSEQ1,NSEQ2) !produce alignment invmap(j)
*     Input: score(i,j), and gap_open
*     Output: invmap(j)

            call get_score      !calculate TM-score, score(i,j)
      !      print *,"Ini2a",TM,TMmax
c     write(*,21)gap_open,rmsd_al,n_al,TM
c     record the best alignment in whole search ---------->
            if(TM.gt.TMmax)then
               TMmax=TM
               do j=1,nseq2
                  invmap0(j)=invmap(j)
               enddo
            endif
            if(id.gt.1)then
               diff=abs(TM-TM_old)
               if(diff.lt.0.000001)goto 333
            endif
            TM_old=TM
 2222    continue
 333     continue
 1111 continue
      endif
*******************************************************************
*     get initial alignment of local structure superposition
*******************************************************************
      call get_initial5
      do i=1,nseq2
         invmap(i)=invmap_i(i)  !with highest zcore
      enddo
      call get_score            !TM, matrix score(i,j)
         
      if(TM.gt.TMmax)then
         TMmax=TM
         do j=1,nseq2
            invmap0(j)=invmap(j)
         enddo
      endif
      if(TM.gt.TMmax*0.2)then
*****************************************************************
*     initerative alignment, for different gap_open:
*****************************************************************
      DO 88 i_gapp=2,n_gapp	 !different gap panalties
         GAP_OPEN=gapp(i_gapp)   !gap panalty
         do 888 id=1,2           !maximum interation is 200
            call DP(NSEQ1,NSEQ2) !produce alignment invmap(j)
*     Input: score(i,j), and gap_open
*     Output: invmap(j)
            
            call get_score      !calculate TM-score, score(i,j)
c            print *,"Ini5a",TM,TMmax
c     record the best alignment in whole search ---------->
            if(TM.gt.TMmax)then
               TMmax=TM
               do j=1,nseq2
                  invmap0(j)=invmap(j)
               enddo
            endif
            if(id.gt.1)then
               diff=abs(TM-TM_old)
               if(diff.lt.0.000001)goto 880
            endif
            TM_old=TM
 888     continue
 880     continue
 88   continue
      endif
*333333333333333333333333333333333333333333333333333333333333
*     get initial alignment from invmap0+SS
*************************************************************
      call get_initial3         !invmap0+SS
      do i=1,nseq2
         invmap(i)=invmap_i(i)  !with highest zcore
      enddo
      call get_score            !TM, score(i,j)
      ! print *,"Ini3",TM,TMmax     
      if(TM.gt.TMmax)then
         TMmax=TM
         do j=1,nseq2
            invmap0(j)=invmap(j)
         enddo
      endif
      if(TM.gt.TMmax*0.2)then
*****************************************************************
*     initerative alignment, for different gap_open:
*****************************************************************
      DO 1110 i_gapp=1,n_gapp	!different gap panalties
         GAP_OPEN=gapp(i_gapp)  !gap panalty
         do 2220 id=1,30	!maximum interation is 200
            call DP(NSEQ1,NSEQ2) !produce alignment invmap(j)
*     Input: score(i,j), and gap_open
*     Output: invmap(j)

            call get_score      !calculate TM-score, score(i,j)
            !print *,"Ini3a",TM,TMmax
c     write(*,21)gap_open,rmsd_al,n_al,TM
c     record the best alignment in whole search ---------->
            if(TM.gt.TMmax)then
               TMmax=TM
               do j=1,nseq2
                  invmap0(j)=invmap(j)
               enddo
            endif
            if(id.gt.1)then
               diff=abs(TM-TM_old)
               if(diff.lt.0.000001)goto 330
            endif
            TM_old=TM
 2220    continue
 330     continue
 1110 continue
      endif
*444444444444444444444444444444444444444444444444444444444
*     get initial alignment of pieces from gapless threading
**********************************************************
      call get_initial4         !gapless threading
      do i=1,nseq2
         invmap(i)=invmap_i(i)  !with highest zcore
      enddo
      do i=1,nseq2
         do j=1,nseq1
            score(i,j)=0
         enddo
      enddo

      call get_score            !TM, matrix score(i,j)
       !print *,"Ini4",TM,TMmax     
      if(TM.gt.TMmax)then
         TMmax=TM
         do j=1,nseq2
            invmap0(j)=invmap(j)
         enddo
      endif
      if(TM.gt.TMmax*0.2)then
*****************************************************************
*     initerative alignment, for different gap_open:
*****************************************************************
      DO 44 i_gapp=2,n_gapp	!different gap panalties
         GAP_OPEN=gapp(i_gapp)  !gap panalty
         do 444 id=1,2          !maximum interation is 200
            call DP(NSEQ1,NSEQ2) !produce alignment invmap(j)
*     Input: score(i,j), and gap_open
*     Output: invmap(j)
            
            call get_score      !calculate TM-score, score(i,j)
           ! print *,"Ini4a",TM,TMmax
c     record the best alignment in whole search ---------->
            if(TM.gt.TMmax)then
               TMmax=TM
               do j=1,nseq2
                  invmap0(j)=invmap(j)
               enddo
            endif
 444     continue
 44   continue
      endif


c^^^^^^^^^^^^^^^ best alignment invmap0(j) found ^^^^^^^^^^^^^^^^^^
      RETURN
      END

**************************************************************
*     get initial alignment invmap0(i) from gapless threading
**************************************************************
      subroutine get_initial
      PARAMETER(nmax=5000)
      PARAMETER(NAA=22)
      
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/length/nseq1,nseq2
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/alignrst/invmap0(nmax)
      common/zscore/zrms,n_al,rmsd_al
      common/TM/TM,TMmax
      common/init/invmap_i(nmax)
      common/init1/invmap_ii(nmax)
      common/d0/d0,anseq
      common/d0min/d0_min
      common/speed/align_len1
      COMMON/SEQN/ISEQ1(NMAX),ISEQ2(NMAX)
      COMMON/MATRIX/B(NAA,NAA)
      COMMON/WEI/W1,W2
      real n_cut
      integer n_all
      double precision r_1(3,nmax),r_2(3,nmax),r_3(3,nmax),w(nmax)
      double precision u(3,3),t(3),rms,drms
      data w /nmax*1.0/
      dimension xtmm1(nmax),ytmm1(nmax),ztmm1(nmax)
      dimension xtmm2(nmax),ytmm2(nmax),ztmm2(nmax)
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
      character*1 slc(0:22)
      data slc/'-','A','B','C','D','E','F','G','H','I',
     &     'K','L','M','N','P','Q','R','S','T','V',
     &     'W','X','Y'/

      CALL BLOSSUM         
      !print *,d0,d0_min
      d01=d0+1.5
      if(d01.lt.d0_min)d01=d0_min
      d02=d01*d01
      n_jump=5
      n_cut=0.75
      aL=min(nseq1,nseq2)
      idel=aL/2.3              !minimum size of considered fragment
      if(idel.le.5)idel=5
      n1=-nseq2+idel
      n2=nseq1-idel
      GL_max=0
      GL_maxA=0
      GL_max_cut=0.95
       do i=1,nseq2
         do j=1,nseq1
            prfprf(i,j)=0
         end do
      end do
      do i=1,nseq2
         do j=1,nseq1
            do l=1,22
               prfprf(i,j) = prfprf(i,j) + W1*(qprf(i,l)*tprf(j,l)) 
            end do
            IF(ISEQ2(i).eq.ISEQ1(j))THEN
               prfprf(i,j) = prfprf(i,j) + W2
            END IF           
         end do
      end do
      do ishift=n1,n2,n_jump
         L=0
         do j=1,nseq2
            i=j+ishift
            if(i.ge.1.and.i.le.nseq1)then
               L=L+1
               invmap(j)=i
               xtmm1(L)=xa(1,i,0)
               ytmm1(L)=xa(1,i,0)
               ztmm1(L)=xa(1,i,0)
               xtmm2(L)=xa(1,j,1)
               ytmm2(L)=xa(1,j,1)
               ztmm2(L)=xa(1,j,1)
            else
               invmap(j)=-1
            endif
         enddo
         if(L.ge.idel)then
            call get_GL(GL)
            if(GL.gt.GL_max)then               
               GL_max=GL
               do i=1,nseq2
                  invmap_i(i)=invmap(i)
               enddo
            endif
            !print *,GL
            if(GL.gt.GL_max*GL_max_cut)then
               do ii=1,L
                  r_1(1,ii)=xtmm1(ii)
                  r_1(2,ii)=ytmm1(ii)
                  r_1(3,ii)=ztmm1(ii)
                  r_2(1,ii)=xtmm2(ii)
                  r_2(2,ii)=ytmm2(ii)
                  r_2(3,ii)=ztmm2(ii)
               enddo
               call u3b(w,r_1,r_2,L,1,rms,u,t,ier) !u rotate r_1 to r_2
             
               do i=1,nseq1
                  xx=t(1)+u(1,1)*xa(1,i,0)+u(1,2)*xa(2,i,0)+u(1,3)*
     &                 xa(3,i,0)
                  yy=t(2)+u(2,1)*xa(1,i,0)+u(2,2)*xa(2,i,0)+u(2,3)*
     &                 xa(3,i,0)
                  zz=t(3)+u(3,1)*xa(1,i,0)+u(3,2)*xa(2,i,0)+u(3,3)*
     &                 xa(3,i,0)
                  do j=1,nseq2
                     dd=(xx-xa(1,j,1))**2+(yy-xa(2,j,1))**2+(zz-xa
     &                    (3,j,1))**2
                     score(i,j)=(1/(1+dd/d02) +  prfprf(i,j))
c                      score(i,j)=1/(1+dd/d02)
                  enddo
               enddo
*********extract alignement with score(i,j) *****************
               align_len1=0
               call DP(NSEQ1,NSEQ2)
               !n_all=0
               !do j=1,nseq2
               !   if(invmap(j).gt.0)then
               !      n_all=n_all+1
               !   endif
               !enddo
               !print *,align_len1
               if(align_len1.gt.L*n_cut.and.align_len1.gt.idel)then
                  call get_GL(GL)
                  if(GL.gt.GL_max.and.GL.gt.GL_maxA)then
                     GL_maxA=GL
                     do i=1,nseq2
                        invmap_ii(i)=invmap(i)
                     enddo
                  endif
               endif
            endif
         endif
      enddo

      return
      end

**************************************************************
*     get initial alignment invmap0(i) from secondary structure
**************************************************************
      subroutine get_initial2
      PARAMETER(nmax=5000)
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/length/nseq1,nseq2
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/alignrst/invmap0(nmax)
      common/zscore/zrms,n_al,rmsd_al
      common/TM/TM,TMmax
      common/sec/isec(nmax),jsec(nmax)
      common/init/invmap_i(nmax)
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
********** assign secondary structures ***************
c     1->coil, 2->helix, 3->turn, 4->strand
      do i=1,nseq1
         isec(i)=1
         j1=i-2
         j2=i-1
         j3=i
         j4=i+1
         j5=i+2
         if(j1.ge.1.and.j5.le.nseq1)then
            dis13=diszy(0,j1,j3)
            dis14=diszy(0,j1,j4)
            dis15=diszy(0,j1,j5)
            dis24=diszy(0,j2,j4)
            dis25=diszy(0,j2,j5)
            dis35=diszy(0,j3,j5)
            isec(i)=make_sec(dis13,dis14,dis15,dis24,dis25,dis35)
         endif
      enddo
      do i=1,nseq2
         jsec(i)=1
         j1=i-2
         j2=i-1
         j3=i
         j4=i+1
         j5=i+2
         if(j1.ge.1.and.j5.le.nseq2)then
            dis13=diszy(1,j1,j3)
            dis14=diszy(1,j1,j4)
            dis15=diszy(1,j1,j5)
            dis24=diszy(1,j2,j4)
            dis25=diszy(1,j2,j5)
            dis35=diszy(1,j3,j5)
            jsec(i)=make_sec(dis13,dis14,dis15,dis24,dis25,dis35)
         endif
      enddo
      call smooth               !smooth the assignment

********** score matrix **************************
      do i=1,nseq1
         do j=1,nseq2
            if(isec(i).eq.jsec(j))then
               score(i,j)=1 + prfprf(i,j)
c               score(i,j)=1
            else
              score(i,j)=0 + prfprf(i,j)
c               score(i,j)=0 
            endif
         enddo
      enddo

********** find initial alignment: invmap(j) ************
      gap_open=-1.0             !should be -1
      call DP(NSEQ1,NSEQ2)      !produce alignment invmap(j)
      do i=1,nseq2
         invmap_i(i)=invmap(i)
      enddo

*^^^^^^^^^^^^ initial alignment done ^^^^^^^^^^^^^^^^^^^^^^
      return
      end

**************************************************************
*     get initial alignment invmap0(i) from secondary structure 
*     and previous alignments
**************************************************************
      subroutine get_initial3
      PARAMETER(nmax=5000)
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/length/nseq1,nseq2
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/alignrst/invmap0(nmax)
      common/zscore/zrms,n_al,rmsd_al
      common/TM/TM,TMmax
      common/sec/isec(nmax),jsec(nmax)
      common/init/invmap_i(nmax)
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
********** score matrix **************************
      do i=1,nseq2
         invmap(i)=invmap0(i)
      enddo
      call get_score1           !get score(i,j) using RMSD martix
      do i=1,nseq1
         do j=1,nseq2
            if(isec(i).eq.jsec(j))then
               score(i,j)=0.5+score(i,j)+  prfprf(i,j)
c                score(i,j)=0.5+score(i,j)

            else
               score(i,j) = score(i,j)+  prfprf(i,j)
c               score(i,j)=score(i,j)
            endif
         enddo
      enddo

********** find initial alignment: invmap(j) ************
      gap_open=-1.0             !should be -1
      call DP(NSEQ1,NSEQ2)      !produce alignment invmap(j)
      do i=1,nseq2
         invmap_i(i)=invmap(i)
      enddo

*^^^^^^^^^^^^ initial alignment done ^^^^^^^^^^^^^^^^^^^^^^
      return
      end

**************************************************************
*     get initial alignment invmap0(i) from fragment gapless threading
**************************************************************
      subroutine get_initial4
      PARAMETER(nmax=5000)
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/length/nseq1,nseq2
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/alignrst/invmap0(nmax)
      common/zscore/zrms,n_al,rmsd_al
      common/TM/TM,TMmax
      common/init/invmap_i(nmax)
      common/initial4/mm1(nmax),mm2(nmax)
      logical contin
      
      dimension ifr2(2,nmax,nmax),Lfr2(2,nmax),Lfr_max2(2),i_fr2(2)
      dimension ifr(nmax)
      dimension mm(2,nmax)
      
      fra_min=4                 !>=4,minimum fragment for search
      fra_min1=fra_min-1        !cutoff for shift, save time
      dcu0=3.85
c      dcu_min=3.65

ccc   Find the smallest continuous fragments -------->
      do i=1,nseq1
         mm(1,i)=mm1(i)
      enddo
      do i=1,nseq2
         mm(2,i)=mm2(i)
      enddo
      do k=1,2
         dcu=dcu0
         if(k.eq.1)then
            nseq0=nseq1
            r_min=nseq1/3.0     !minimum fragment, in case too small protein
         else
            nseq0=nseq2
            r_min=nseq2/3.0     !minimum fragment, in case too small protein
         endif
         if(r_min.gt.fra_min)r_min=fra_min
 20      nfr=1                  !number of fragments
         j=1                    !number of residue at nf-fragment
         ifr2(k,nfr,j)=1        !what residue
         Lfr2(k,nfr)=j          !length of the fragment
         do i=2,nseq0
            dis=diszy(k-1,i-1,i)
            contin=.false.
            if(dcu.gt.dcu0)then
               if(dis.lt.dcu)then
c                  if(dis.gt.dcu_min)then
                     contin=.true.
c                  endif
               endif
            elseif(mm(k,i).eq.(mm(k,i-1)+1))then
               if(dis.lt.dcu)then
c                  if(dis.gt.dcu_min)then
                     contin=.true.
c                  endif
               endif
            endif
            if(contin)then
               j=j+1
               ifr2(k,nfr,j)=i
               Lfr2(k,nfr)=j
            else
               nfr=nfr+1
               j=1
               ifr2(k,nfr,j)=i
               Lfr2(k,nfr)=j
            endif
         enddo
         Lfr_max=0
         i_fr2(k)=1             !ID of the maximum piece
         do i=1,nfr
            if(Lfr_max.lt.Lfr2(k,i))then
               Lfr_max=Lfr2(k,i)
               i_fr2(k)=i
            endif
         enddo
         if(Lfr_max.lt.r_min)then
            dcu=1.1*dcu
            goto 20
         endif
      enddo
c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      
ccc   select what piece will be used (this may araise ansysmetry, but
ccc   only when L1=L2 and Lfr1=Lfr2 and L1 ne Lfr1
ccc   if L1=Lfr1 and L2=Lfr2 (normal proteins), it will be the same as initial1
      mark=1
      if(Lfr2(1,i_fr2(1)).lt.Lfr2(2,i_fr2(2)))then
         mark=1
      elseif(Lfr2(1,i_fr2(1)).gt.Lfr2(2,i_fr2(2)))then
         mark=2
      else                      !Lfr1=Lfr2
         if(nseq1.le.nseq2)then
            mark=1
         else
            mark=2
         endif
      endif
ccc   
      L_fr=Lfr2(mark,i_fr2(mark))
      do i=1,L_fr
         ifr(i)=ifr2(mark,i_fr2(mark),i)
      enddo
ccc   
      if(mark.eq.1)then         !non-redundant to get_initial1
         nseq0=nseq1
      else
         nseq0=nseq2
      endif
      if(L_fr.eq.nseq0)then
         n1=int(nseq0*0.1)      !0
         n2=int(nseq0*0.89)     !2
         j=0
         do i=n1,n2
            j=j+1
            ifr(j)=ifr(n1+j)
         enddo
         L_fr=j
      endif
      
ccc   get initial ------------->
      if(mark.eq.1)then    !nseq1 as the smallest one
         nseq1_=L_fr
         aL=min(nseq1_,nseq2)
         idel=aL/2.5            !minimum size of considered fragment
         if(idel.le.fra_min1)idel=fra_min1
         n1=-nseq2+idel         !shift1
         n2=nseq1_-idel         !shift2
         GL_max=0
         do ishift=n1,n2
            L=0
            do j=1,nseq2
               i=j+ishift
               if(i.ge.1.and.i.le.nseq1_)then
                  L=L+1
                  invmap(j)=ifr(i)
               else
                  invmap(j)=-1
               endif
            enddo
            if(L.ge.idel)then
               call get_GL(GL)
               if(GL.gt.GL_max)then
                  GL_max=GL
                  do i=1,nseq2
                     invmap_i(i)=invmap(i)
                  enddo
               endif
            endif
         enddo
      else                      !@@@@@@@@@@@@@@@@@@@@
         nseq2_=L_fr
         aL=min(nseq1,nseq2_)
         idel=aL/2.5            !minimum size of considered fragment
         if(idel.le.fra_min1)idel=fra_min1
         n1=-nseq2_+idel
         n2=nseq1-idel
         GL_max=0
         do ishift=n1,n2
            L=0
            do j=1,nseq2
               invmap(j)=-1
            enddo
            do j=1,nseq2_
               i=j+ishift
               if(i.ge.1.and.i.le.nseq1)then
                  L=L+1
                  invmap(ifr(j))=i
               endif
            enddo
            if(L.ge.idel)then
               call get_GL(GL)
               if(GL.gt.GL_max)then
                  GL_max=GL
                  do i=1,nseq2
                     invmap_i(i)=invmap(i)
                  enddo
               endif
            endif
         enddo
      endif
      
      return
      end
**************************************************************
*    fifth initial alignement. Using local structure super   *
*    position.                                               *
**************************************************************
      subroutine get_initial5
      PARAMETER (nmax=5000)
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/length/nseq1,nseq2
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/alignrst/invmap0(nmax)
      common/zscore/zrms,n_al,rmsd_al
      common/TM/TM,TMmax
      common/d0/d0,anseq
      common/d0min/d0_min
      common/init/invmap_i(nmax)
      common/initial4/mm1(nmax),mm2(nmax)
      common/tinit/invmap_ii(nmax)
      common/local/lflag
      common/sec/isec(nmax),jsec(nmax)
      logical contin
      integer n_all,secmatch,coilcnt
      real n_max_cut,n_all_max,n_cutt
      double precision r_1(3,nmax),r_2(3,nmax),r_3(3,nmax),w(nmax)
      double precision u(3,3),t(3),rms,drms
      data w /nmax*1.0/
      common/inv/invmap_a(nmax)
      common/speed/align_len1
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
************* points needed to tuned ******************
c     1, reduce number of iteration in get_GL from 3 to 2 or 1?
c        this should reduce the time for get_initial1 as well.
c     2, put get_DP into get_initial1 as well? Then you need to 
c        reduced the number of gapless threading by jump.
c     3, in this subroutine, n_frag, n_jump, GLmaxA_cut, d02, n_frag2
c        need to be tuned
c     4, there are serveral bugs in your codes such as the edge-condition
c        Fixing these bugs will also improve the results.
c        Also, always put the common calculations outside of the circles
************************************************************

***** setting parameters ************************************
      n_frag=5
c      n_frag=15
      n_jump=n_frag
c      n_jump=n_frag/1.5
c      n_jump=1
      n_all=0
      n_all_max=0
      n_max_cut=0.7
      n_cutt=0
      d01=d0+1.5
      if(d01.lt.d0_min)d01=d0_min
      d02=d01*d01
      GLmaxB=0
      GLmaxA=0
      GLmaxA_cut=0.12
      n_frag1=n_frag-1
      n_frag2=n_frag/2
      m1=nseq1-n_frag+1
      m2=nseq2-n_frag+1
      do ii=1,m1,n_jump
         do jj=1,m2,n_jump
            secmatch=0
            coilcnt=0
            do k=1,n_frag
               iii=ii+k-1
               jjj=jj+k-1
               if(isec(iii).eq.jsec(jjj))then
                  secmatch=secmatch+1
               endif
               if(isec(iii).eq.1)then !.or.isec(iii).ne.4)then
                  coilcnt=coilcnt+1
               endif
            enddo
            if(secmatch.gt.n_frag2.and.coilcnt.lt.n_frag2)then
               do j=1,nseq2
                  invmap(j)=-1
               enddo
               do k=0,n_frag1
                  i=ii+k
                  j=jj+k
                  invmap(j)=i
               enddo

               call get_GL(GL)
               if(GL.gt.GLmaxA*GLmaxA_cut)then
                  !GLmaxB=GL
                  do k=1,n_frag
                     iii=ii+k-1
                     jjj=jj+k-1
                     r_1(1,k)=xa(1,iii,0)
                     r_1(2,k)=xa(2,iii,0)
                     r_1(3,k)=xa(3,iii,0)
                     r_2(1,k)=xa(1,jjj,1)
                     r_2(2,k)=xa(2,jjj,1)
                     r_2(3,k)=xa(3,jjj,1)
                  enddo
*********superpose the two structures and rotate it *****************
                  call u3b(w,r_1,r_2,n_frag,1,rms,u,t,ier) !u rotate r_1 to r_2
                  do i=1,nseq1
              xx=t(1)+u(1,1)*xa(1,i,0)+u(1,2)*xa(2,i,0)+u(1,3)*xa(3,i,0)
              yy=t(2)+u(2,1)*xa(1,i,0)+u(2,2)*xa(2,i,0)+u(2,3)*xa(3,i,0)
              zz=t(3)+u(3,1)*xa(1,i,0)+u(3,2)*xa(2,i,0)+u(3,3)*xa(3,i,0)
                     do j=1,nseq2
                dd=(xx-xa(1,j,1))**2+(yy-xa(2,j,1))**2+(zz-xa(3,j,1))**2
                        score(i,j)=1/(1+dd/d02) + prfprf(i,j)
c                        score(i,j)=1/(1+dd/d02) 

                     enddo
                  enddo
                  
*********extract alignement with score(i,j) *****************
                  align_len1=0
                  call DP(NSEQ1,NSEQ2)
                  !print *,align_len1
                  !n_all=0
                  !do j=1,nseq2
                  !   if(invmap(j).gt.0)then
                  !      n_all=n_all+1
                  !   endif
                  !enddo
                  n_cutt=n_all_max*n_max_cut
                  !print *,n_all,n_cutt,n_all_max,n_max_cut
                  if(align_len1.gt.n_cutt)then
                     if(align_len1.gt.n_all_max)then
                        n_all_max=align_len1
                     endif
                     call get_GL(GL)
                     
                     if(GL.gt.GLmaxA)then
                        GLmaxA=GL
                        do j=1,nseq2
                           invmap_i(j)=invmap(j)
                        enddo
                     endif
                  endif
               endif
            endif
         enddo
      enddo
      
      return
      end

**************************************************************                                                                                              
*    sixth initial alignement. Using profile-profile align   *                                                                                              
*    of query and template                                   *                                                                                             
**************************************************************
      subroutine get_initial6
      PARAMETER (nmax=5000)
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/length/nseq1,nseq2
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/alignrst/invmap0(nmax)
      common/zscore/zrms,n_al,rmsd_al
      common/TM/TM,TMmax
      common/d0/d0,anseq
      common/d0min/d0_min
      common/init/invmap_i(nmax)
      common/initial4/mm1(nmax),mm2(nmax)
      common/tinit/invmap_ii(nmax)
      common/local/lflag
      common/sec/isec(nmax),jsec(nmax)
      logical contin
      integer n_all,secmatch,coilcnt
      real n_max_cut,n_all_max,n_cutt,max_score,min_score
      double precision r_1(3,nmax),r_2(3,nmax),r_3(3,nmax),w(nmax)
      double precision u(3,3),t(3),rms,drms
      data w /nmax*1.0/
      common/inv/invmap_a(nmax)
      common/speed/align_len1
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)



      
      do i=1,nseq1
         do j=1,nseq2          
            do l=1,22
               score(i,j)=score(i,j)+tprf(i,l)*qprf(j,l)
            enddo
         enddo
      enddo
********** find initial alignment: invmap(j) ************                                                                                                   
      gap_open=-1.0             !should be -1         
      call DP(NSEQ1,NSEQ2)      !produce alignment invmap(j)                                                                                                
      do i=1,nseq2
         invmap_i(i)=invmap(i)
      enddo
*^^^^^^^^^^^^ initial alignment done ^^^^^^^^^^^^^^^^^^^^^^                                                                                 
      return
      end

**************************************************************
*     smooth the secondary structure assignment
**************************************************************
      subroutine smooth
      PARAMETER(nmax=5000)
      common/sec/isec(nmax),jsec(nmax)
      common/length/nseq1,nseq2

***   smooth single -------------->
***   --x-- => -----
      do i=1,nseq1
         if(isec(i).eq.2.or.isec(i).eq.4)then
            j=isec(i)
            if(isec(i-2).ne.j)then
               if(isec(i-1).ne.j)then
                  if(isec(i+1).ne.j)then
                     if(isec(i+1).ne.j)then
                        isec(i)=1
                     endif
                  endif
               endif
            endif
         endif
      enddo
      do i=1,nseq2
         if(jsec(i).eq.2.or.jsec(i).eq.4)then
            j=jsec(i)
            if(jsec(i-2).ne.j)then
               if(jsec(i-1).ne.j)then
                  if(jsec(i+1).ne.j)then
                     if(jsec(i+1).ne.j)then
                        jsec(i)=1
                     endif
                  endif
               endif
            endif
         endif
      enddo

***   smooth double -------------->
***   --xx-- => ------
      do i=1,nseq1
         if(isec(i).ne.2)then
         if(isec(i+1).ne.2)then
         if(isec(i+2).eq.2)then
         if(isec(i+3).eq.2)then
         if(isec(i+4).ne.2)then
         if(isec(i+5).ne.2)then
            isec(i+2)=1
            isec(i+3)=1
         endif
         endif
         endif
         endif
         endif
         endif

         if(isec(i).ne.4)then
         if(isec(i+1).ne.4)then
         if(isec(i+2).eq.4)then
         if(isec(i+3).eq.4)then
         if(isec(i+4).ne.4)then
         if(isec(i+5).ne.4)then
            isec(i+2)=1
            isec(i+3)=1
         endif
         endif
         endif
         endif
         endif
         endif
      enddo
      do i=1,nseq2
         if(jsec(i).ne.2)then
         if(jsec(i+1).ne.2)then
         if(jsec(i+2).eq.2)then
         if(jsec(i+3).eq.2)then
         if(jsec(i+4).ne.2)then
         if(jsec(i+5).ne.2)then
            jsec(i+2)=1
            jsec(i+3)=1
         endif
         endif
         endif
         endif
         endif
         endif

         if(jsec(i).ne.4)then
         if(jsec(i+1).ne.4)then
         if(jsec(i+2).eq.4)then
         if(jsec(i+3).eq.4)then
         if(jsec(i+4).ne.4)then
         if(jsec(i+5).ne.4)then
            jsec(i+2)=1
            jsec(i+3)=1
         endif
         endif
         endif
         endif
         endif
         endif
      enddo

***   connect -------------->
***   x-x => xxx
      do i=1,nseq1
         if(isec(i).eq.2)then
         if(isec(i+1).ne.2)then
         if(isec(i+2).eq.2)then
            isec(i+1)=2
         endif
         endif
         endif

         if(isec(i).eq.4)then
         if(isec(i+1).ne.4)then
         if(isec(i+2).eq.4)then
            isec(i+1)=4
         endif
         endif
         endif
      enddo
      do i=1,nseq2
         if(jsec(i).eq.2)then
         if(jsec(i+1).ne.2)then
         if(jsec(i+2).eq.2)then
            jsec(i+1)=2
         endif
         endif
         endif

         if(jsec(i).eq.4)then
         if(jsec(i+1).ne.4)then
         if(jsec(i+2).eq.4)then
            jsec(i+1)=4
         endif
         endif
         endif
      enddo

      return
      end

*************************************************************
*     assign secondary structure:
*************************************************************
      function diszy(i,i1,i2)
      PARAMETER(nmax=5000)
      COMMON/BACKBONE/XA(3,nmax,0:1)
      diszy=sqrt((xa(1,i1,i)-xa(1,i2,i))**2
     &     +(xa(2,i1,i)-xa(2,i2,i))**2
     &     +(xa(3,i1,i)-xa(3,i2,i))**2)
      return
      end

*************************************************************
*     assign secondary structure:
*************************************************************
      function make_sec(dis13,dis14,dis15,dis24,dis25,dis35)
      make_sec=1
      delta=2.1
      if(abs(dis15-6.37).lt.delta)then
         if(abs(dis14-5.18).lt.delta)then
            if(abs(dis25-5.18).lt.delta)then
               if(abs(dis13-5.45).lt.delta)then
                  if(abs(dis24-5.45).lt.delta)then
                     if(abs(dis35-5.45).lt.delta)then
                        make_sec=2 !helix
                        return
                     endif
                  endif
               endif
            endif
         endif
      endif
      delta=1.42
      if(abs(dis15-13).lt.delta)then
         if(abs(dis14-10.4).lt.delta)then
            if(abs(dis25-10.4).lt.delta)then
               if(abs(dis13-6.1).lt.delta)then
                  if(abs(dis24-6.1).lt.delta)then
                     if(abs(dis35-6.1).lt.delta)then
                        make_sec=4 !strand
                        return
                     endif
                  endif
               endif
            endif
         endif
      endif
      if(dis15.lt.8)then
         make_sec=3
      endif

      return
      end

****************************************************************
*     quickly calculate TM-score with given invmap(i) in 3 iterations
****************************************************************
      subroutine get_GL(GL)
      PARAMETER(nmax=5000)
      common/length/nseq1,nseq2
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/zscore/zrms,n_al,rmsd_al
      common/d0/d0,anseq
      dimension xtm1(nmax),ytm1(nmax),ztm1(nmax)
      dimension xtm2(nmax),ytm2(nmax),ztm2(nmax)
      common/TM/TM,TMmax
      common/n1n2/n1(nmax),n2(nmax)
      common/d00/d00,d002
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)

      dimension xo1(nmax),yo1(nmax),zo1(nmax)
      dimension xo2(nmax),yo2(nmax),zo2(nmax)
      dimension dis2(nmax)
      

ccc   RMSD:
      double precision r_1(3,nmax),r_2(3,nmax),r_3(3,nmax),w(nmax)
      double precision u(3,3),t(3),rms,drms !armsd is real
      data w /nmax*1.0/
ccc   
     
c     calculate RMSD between aligned structures and rotate the structures -->
      n_al=0
      ascore=0
      do j=1,NSEQ2
         i=invmap(j)            !j aligned to i
         if(i.gt.0)then
            n_al=n_al+1
            r_1(1,n_al)=xa(1,i,0)
            r_1(2,n_al)=xa(2,i,0)
            r_1(3,n_al)=xa(3,i,0)
            r_2(1,n_al)=xa(1,j,1)
            r_2(2,n_al)=xa(2,j,1)
            r_2(3,n_al)=xa(3,j,1)
            xo1(n_al)=xa(1,i,0)
            yo1(n_al)=xa(2,i,0)
            zo1(n_al)=xa(3,i,0)
            xo2(n_al)=xa(1,j,1)
            yo2(n_al)=xa(2,j,1)
            zo2(n_al)=xa(3,j,1)
            ascore = ascore + prfprf(i,j)
         endif
      enddo
      call u3b(w,r_1,r_2,n_al,1,rms,u,t,ier) !u rotate r_1 to r_2
      GL=0+ascore
      do i=1,n_al
         xx=t(1)+u(1,1)*xo1(i)+u(1,2)*yo1(i)+u(1,3)*zo1(i)
         yy=t(2)+u(2,1)*xo1(i)+u(2,2)*yo1(i)+u(2,3)*zo1(i)
         zz=t(3)+u(3,1)*xo1(i)+u(3,2)*yo1(i)+u(3,3)*zo1(i)
         dis2(i)=(xx-xo2(i))**2+(yy-yo2(i))**2+(zz-zo2(i))**2
         GL=GL+1/(1+dis2(i)/(d0**2))
      enddo
ccc   for next iteration------------->
      d002t=d002
 21   j=0
      do i=1,n_al
         if(dis2(i).le.d002t)then
            j=j+1
            r_1(1,j)=xo1(i)
            r_1(2,j)=yo1(i)
            r_1(3,j)=zo1(i)
            r_2(1,j)=xo2(i)
            r_2(2,j)=yo2(i)
            r_2(3,j)=zo2(i)
         endif
      enddo
      if(j.lt.3.and.n_al.gt.3)then
         d002t=d002t+.5
         goto 21
      endif
      L=j
      call u3b(w,r_1,r_2,L,1,rms,u,t,ier) !u rotate r_1 to r_2
      G2=0+ascore
      do i=1,n_al
         xx=t(1)+u(1,1)*xo1(i)+u(1,2)*yo1(i)+u(1,3)*zo1(i)
         yy=t(2)+u(2,1)*xo1(i)+u(2,2)*yo1(i)+u(2,3)*zo1(i)
         zz=t(3)+u(3,1)*xo1(i)+u(3,2)*yo1(i)+u(3,3)*zo1(i)
         dis2(i)=(xx-xo2(i))**2+(yy-yo2(i))**2+(zz-zo2(i))**2
         G2=G2+1/(1+dis2(i)/(d0**2))
      enddo
ccc   for next iteration------------->
      d002t=d002+1
 22   j=0
      do i=1,n_al
         if(dis2(i).le.d002t)then
            j=j+1
            r_1(1,j)=xo1(i)
            r_1(2,j)=yo1(i)
            r_1(3,j)=zo1(i)
            r_2(1,j)=xo2(i)
            r_2(2,j)=yo2(i)
            r_2(3,j)=zo2(i)
         endif
      enddo
      if(j.lt.3.and.n_al.gt.3)then
         d002t=d002t+.5
         goto 22
      endif
      L=j
      call u3b(w,r_1,r_2,L,1,rms,u,t,ier) !u rotate r_1 to r_2
      G3=0+ascore
      do i=1,n_al
         xx=t(1)+u(1,1)*xo1(i)+u(1,2)*yo1(i)+u(1,3)*zo1(i)
         yy=t(2)+u(2,1)*xo1(i)+u(2,2)*yo1(i)+u(2,3)*zo1(i)
         zz=t(3)+u(3,1)*xo1(i)+u(3,2)*yo1(i)+u(3,3)*zo1(i)
         dis2(i)=(xx-xo2(i))**2+(yy-yo2(i))**2+(zz-zo2(i))**2
         G3=G3+1/(1+dis2(i)/(d0**2))
      enddo
      if(G2.gt.GL)GL=G2
      if(G3.gt.GL)GL=G3

c^^^^^^^^^^^^^^^^ GL done ^^^^^^^^^^^^^^^^^^^^^^^^^^^
      return
      end

****************************************************************
*     quickly calculate TM-score with given invmap(i) in 3 iterations
****************************************************************
      subroutine get_GL1(GL)
      PARAMETER(nmax=5000)
      common/length/nseq1,nseq2
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/zscore/zrms,n_al,rmsd_al
      common/d0/d0,anseq
      dimension xtm1(nmax),ytm1(nmax),ztm1(nmax)
      dimension xtm2(nmax),ytm2(nmax),ztm2(nmax)
      common/TM/TM,TMmax
      common/n1n2/n1(nmax),n2(nmax)
      common/d00/d00,d002
      common/inv/invmap_a(nmax)

      dimension xo1(nmax),yo1(nmax),zo1(nmax)
      dimension xo2(nmax),yo2(nmax),zo2(nmax)
      dimension xn1(nmax),yn1(nmax),zn1(nmax)
      dimension dis2(nmax)

ccc   RMSD:
      double precision r_1(3,nmax),r_2(3,nmax),r_3(3,nmax),w(nmax)
      double precision u(3,3),t(3),rms,drms !armsd is real
      data w /nmax*1.0/
ccc   

c     calculate RMSD between aligned structures and rotate the structures -->
      n_al=0
      do j=1,NSEQ2
         i=invmap(j)            !j aligned to i
         if(i.gt.0)then
            n_al=n_al+1
            r_1(1,n_al)=xa(1,i,0)
            r_1(2,n_al)=xa(2,i,0)
            r_1(3,n_al)=xa(3,i,0)
            r_2(1,n_al)=xa(1,j,1)
            r_2(2,n_al)=xa(2,j,1)
            r_2(3,n_al)=xa(3,j,1)
            xo1(n_al)=xa(1,i,0)
            yo1(n_al)=xa(2,i,0)
            zo1(n_al)=xa(3,i,0)
            xo2(n_al)=xa(1,j,1)
            yo2(n_al)=xa(2,j,1)
            zo2(n_al)=xa(3,j,1)
         endif
      enddo
      call u3b(w,r_1,r_2,n_al,1,rms,u,t,ier) !u rotate r_1 to r_2
      GL=0
      do i=1,n_al
         xx=t(1)+u(1,1)*xo1(i)+u(1,2)*yo1(i)+u(1,3)*zo1(i)
         yy=t(2)+u(2,1)*xo1(i)+u(2,2)*yo1(i)+u(2,3)*zo1(i)
         zz=t(3)+u(3,1)*xo1(i)+u(3,2)*yo1(i)+u(3,3)*zo1(i)
         dis2(i)=(xx-xo2(i))**2+(yy-yo2(i))**2+(zz-zo2(i))**2
         GL=GL+1/(1+dis2(i)/(d0**2))
      enddo

cccccccccc add more alignments:
      do i=1,nseq1
         xn1(i)=t(1)+u(1,1)*xa(1,i,0)+u(1,2)*xa(2,i,0)+u(1,3)*xa(3,i,0)
         yn1(i)=t(2)+u(2,1)*xa(1,i,0)+u(2,2)*xa(2,i,0)+u(2,3)*xa(3,i,0)
         zn1(i)=t(3)+u(3,1)*xa(1,i,0)+u(3,2)*xa(2,i,0)+u(3,3)*xa(3,i,0)
      enddo
      do j=1,nseq2
         if(invmap(j).le.0)then
            if(invmap_a(j).gt.0)then
               i=invmap_a(j)
               di2=(xn1(i)-xa(1,j,1))**2+
     &              (yn1(i)-xa(2,j,1))**2+(zn1(i)-xa(3,j,1))**2
c               write(*,*)i,j,di2,d002
               if(di2.lt.d002)then
                  invmap(j)=invmap_a(j)
               endif
            endif
         endif
      enddo
      
ccc   for next iteration------------->
      d002t=d002
 21   j=0
      do i=1,n_al
         if(dis2(i).le.d002t)then
            j=j+1
            r_1(1,j)=xo1(i)
            r_1(2,j)=yo1(i)
            r_1(3,j)=zo1(i)
            r_2(1,j)=xo2(i)
            r_2(2,j)=yo2(i)
            r_2(3,j)=zo2(i)
         endif
      enddo
      if(j.lt.3.and.n_al.gt.3)then
         d002t=d002t+.5
         goto 21
      endif
      L=j
      call u3b(w,r_1,r_2,L,1,rms,u,t,ier) !u rotate r_1 to r_2
      G2=0
      do i=1,n_al
         xx=t(1)+u(1,1)*xo1(i)+u(1,2)*yo1(i)+u(1,3)*zo1(i)
         yy=t(2)+u(2,1)*xo1(i)+u(2,2)*yo1(i)+u(2,3)*zo1(i)
         zz=t(3)+u(3,1)*xo1(i)+u(3,2)*yo1(i)+u(3,3)*zo1(i)
         dis2(i)=(xx-xo2(i))**2+(yy-yo2(i))**2+(zz-zo2(i))**2
         G2=G2+1/(1+dis2(i)/(d0**2))
      enddo
ccc   for next iteration------------->
      d002t=d002+1
 22   j=0
      do i=1,n_al
         if(dis2(i).le.d002t)then
            j=j+1
            r_1(1,j)=xo1(i)
            r_1(2,j)=yo1(i)
            r_1(3,j)=zo1(i)
            r_2(1,j)=xo2(i)
            r_2(2,j)=yo2(i)
            r_2(3,j)=zo2(i)
         endif
      enddo
      if(j.lt.3.and.n_al.gt.3)then
         d002t=d002t+.5
         goto 22
      endif
      L=j
      call u3b(w,r_1,r_2,L,1,rms,u,t,ier) !u rotate r_1 to r_2
      G3=0
      do i=1,n_al
         xx=t(1)+u(1,1)*xo1(i)+u(1,2)*yo1(i)+u(1,3)*zo1(i)
         yy=t(2)+u(2,1)*xo1(i)+u(2,2)*yo1(i)+u(2,3)*zo1(i)
         zz=t(3)+u(3,1)*xo1(i)+u(3,2)*yo1(i)+u(3,3)*zo1(i)
         dis2(i)=(xx-xo2(i))**2+(yy-yo2(i))**2+(zz-zo2(i))**2
         G3=G3+1/(1+dis2(i)/(d0**2))
      enddo
      if(G2.gt.GL)GL=G2
      if(G3.gt.GL)GL=G3

c^^^^^^^^^^^^^^^^ GL done ^^^^^^^^^^^^^^^^^^^^^^^^^^^
      return
      end

****************************************************************
*     with invmap(i) calculate TM-score and martix score(i,j) for rotation 
****************************************************************
      subroutine get_score
      PARAMETER(nmax=5000)
      common/length/nseq1,nseq2
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/zscore/zrms,n_al,rmsd_al
      common/d0/d0,anseq
      dimension xtm1(nmax),ytm1(nmax),ztm1(nmax)
      dimension xtm2(nmax),ytm2(nmax),ztm2(nmax)
      common/TM/TM,TMmax
      common/n1n2/n1(nmax),n2(nmax)
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)

ccc   RMSD:
      double precision r_1(3,nmax),r_2(3,nmax),r_3(3,nmax),w(nmax)
      double precision u(3,3),t(3),rms,drms !armsd is real
      data w /nmax*1.0/
ccc   

c     calculate RMSD between aligned structures and rotate the structures -->
      n_al=0
      do j=1,NSEQ2
         i=invmap(j)            !j aligned to i
         if(i.gt.0)then
            n_al=n_al+1
ccc   for TM-score:
            xtm1(n_al)=xa(1,i,0) !for TM-score
            ytm1(n_al)=xa(2,i,0)
            ztm1(n_al)=xa(3,i,0)
            xtm2(n_al)=xa(1,j,1)
            ytm2(n_al)=xa(2,j,1)
            ztm2(n_al)=xa(3,j,1)
ccc   for rotation matrix:
            r_1(1,n_al)=xa(1,i,0)
            r_1(2,n_al)=xa(2,i,0)
            r_1(3,n_al)=xa(3,i,0)
         endif
      enddo
***   calculate TM-score for the given alignment----------->
      d0_input=d0
      call TMscore8_search(d0_input,n_al,xtm1,ytm1,ztm1,n1,
     &     n_al,xtm2,ytm2,ztm2,n2,TM,Rcomm,Lcomm) !simplified search engine
      TM=TM*n_al/anseq          !TM-score
***   calculate score matrix score(i,j)------------------>
      do i=1,n_al
         r_2(1,i)=xtm1(i)
         r_2(2,i)=ytm1(i)
         r_2(3,i)=ztm1(i)
      enddo
      call u3b(w,r_1,r_2,n_al,1,rms,u,t,ier) !u rotate r_1 to r_2
      do i=1,nseq1
         xx=t(1)+u(1,1)*xa(1,i,0)+u(1,2)*xa(2,i,0)+u(1,3)*xa(3,i,0)
         yy=t(2)+u(2,1)*xa(1,i,0)+u(2,2)*xa(2,i,0)+u(2,3)*xa(3,i,0)
         zz=t(3)+u(3,1)*xa(1,i,0)+u(3,2)*xa(2,i,0)+u(3,3)*xa(3,i,0)
         do j=1,nseq2
            dd=(xx-xa(1,j,1))**2+(yy-xa(2,j,1))**2+(zz-xa(3,j,1))**2
c            score(i,j)=1/(1+dd/d0**2)
            score(i,j)=1/(1+((dd/d0**2)+prfprf(i,j)))
         enddo
      enddo
      
c^^^^^^^^^^^^^^^^ score(i,j) done ^^^^^^^^^^^^^^^^^^^^^^^^^^^
      return
      end

****************************************************************
*     with invmap(i) calculate score(i,j) using RMSD rotation 
****************************************************************
      subroutine get_score1
      PARAMETER(nmax=5000)
      common/length/nseq1,nseq2
      COMMON/BACKBONE/XA(3,nmax,0:1)
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      common/zscore/zrms,n_al,rmsd_al
      common/d0/d0,anseq
      common/d0min/d0_min
      dimension xtm1(nmax),ytm1(nmax),ztm1(nmax)
      dimension xtm2(nmax),ytm2(nmax),ztm2(nmax)
      common/TM/TM,TMmax
      common/n1n2/n1(nmax),n2(nmax)
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
ccc   RMSD:
      double precision r_1(3,nmax),r_2(3,nmax),r_3(3,nmax),w(nmax)
      double precision u(3,3),t(3),rms,drms !armsd is real
      data w /nmax*1.0/
ccc   

c     calculate RMSD between aligned structures and rotate the structures -->
      n_al=0
      do j=1,NSEQ2
         i=invmap(j)            !j aligned to i
         if(i.gt.0)then
            n_al=n_al+1
ccc   for rotation matrix:
            r_1(1,n_al)=xa(1,i,0)
            r_1(2,n_al)=xa(2,i,0)
            r_1(3,n_al)=xa(3,i,0)
            r_2(1,n_al)=xa(1,j,1)
            r_2(2,n_al)=xa(2,j,1)
            r_2(3,n_al)=xa(3,j,1)
         endif
      enddo
***   calculate score matrix score(i,j)------------------>
      call u3b(w,r_1,r_2,n_al,1,rms,u,t,ier) !u rotate r_1 to r_2
      d01=d0+1.5
      if(d01.lt.d0_min)d01=d0_min
      d02=d01*d01
      do i=1,nseq1
         xx=t(1)+u(1,1)*xa(1,i,0)+u(1,2)*xa(2,i,0)+u(1,3)*xa(3,i,0)
         yy=t(2)+u(2,1)*xa(1,i,0)+u(2,2)*xa(2,i,0)+u(2,3)*xa(3,i,0)
         zz=t(3)+u(3,1)*xa(1,i,0)+u(3,2)*xa(2,i,0)+u(3,3)*xa(3,i,0)
         do j=1,nseq2
            dd=(xx-xa(1,j,1))**2+(yy-xa(2,j,1))**2+(zz-xa(3,j,1))**2
c            score(i,j)=1/(1+dd/d02)
            score(i,j)=1/(1+((dd/d02)+prfprf(i,j)))           
         enddo
      enddo

c^^^^^^^^^^^^^^^^ score(i,j) done ^^^^^^^^^^^^^^^^^^^^^^^^^^^
      return
      end


*************************************************************************
*************************************************************************
*     This is a subroutine to compare two structures and find the 
*     superposition that has the maximum TM-score.
*
*     L1--Length of the first structure
*     (x1(i),y1(i),z1(i))--coordinates of i'th residue at the first structure
*     n1(i)--Residue sequence number of i'th residue at the first structure
*     L2--Length of the second structure
*     (x2(i),y2(i),z2(i))--coordinates of i'th residue at the second structure
*     n2(i)--Residue sequence number of i'th residue at the second structure
*     TM--TM-score of the comparison
*     Rcomm--RMSD of two structures in the common aligned residues
*     Lcomm--Length of the common aligned regions
*
*     Note: 
*     1, Always put native as the second structure, by which TM-score
*        is normalized.
*     2, The returned (x1(i),y1(i),z1(i)) are the rotated structure after
*        TM-score superposition.
*************************************************************************
*************************************************************************
*** dis<8, simplified search engine
      subroutine TMscore8_search(dx,L1,x1,y1,z1,n1,L2,x2,y2,z2,n2,
     &     TM,Rcomm,Lcomm)
      PARAMETER(nmax=5000)
      common/stru/xt(nmax),yt(nmax),zt(nmax),xb(nmax),yb(nmax),zb(nmax)
      common/nres/nresA(nmax),nresB(nmax),nseqA,nseqB
      common/para/d,d0
      common/d0min/d0_min
      common/align/n_ali,iA(nmax),iB(nmax)
      common/nscore/i_ali(nmax),n_cut ![1,n_ali],align residues for the score
      dimension k_ali(nmax),k_ali0(nmax)
      dimension L_ini(100),iq(nmax)
      common/scores/score
      common/local/lflag
      double precision score,score_max
      dimension xa(nmax),ya(nmax),za(nmax)
      dimension iL0(nmax)

      dimension x1(nmax),y1(nmax),z1(nmax),n1(nmax)
      dimension x2(nmax),y2(nmax),z2(nmax),n2(nmax)
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
ccc   RMSD:
      double precision r_1(3,nmax),r_2(3,nmax),r_3(3,nmax),w(nmax)
      double precision u(3,3),t(3),rms,drms !armsd is real
      data w /nmax*1.0/
ccc   

********* convert input data ***************************
*     because L1=L2 in this special case---------->
      nseqA=L1
      nseqB=L2
      do i=1,nseqA
         xa(i)=x1(i)
         ya(i)=y1(i)
         za(i)=z1(i)
         nresA(i)=n1(i)
         xb(i)=x2(i)
         yb(i)=y2(i)
         zb(i)=z2(i)
         nresB(i)=n2(i)
         iA(i)=i
         iB(i)=i
      enddo
      n_ali=L1                  !number of aligned residues
      Lcomm=L1

************/////
*     parameters:
*****************
***   d0------------->
      d0=dx
      if(d0.lt.d0_min)d0=d0_min
***   d0_search ----->
      d0_search=d0
      if(d0_search.gt.8)d0_search=8
      if(d0_search.lt.4.5)d0_search=4.5
***   iterative parameters ----->
      
      n_it=20                   !maximum number of iterations
      d_output=5                !for output alignment
      n_init_max=6              !maximum number of L_init
      n_init=0
      L_ini_min=4
      
      if(n_ali.lt.4)L_ini_min=n_ali
      do i=1,n_init_max-1
         n_init=n_init+1
         L_ini(n_init)=n_ali/2**(n_init-1)
         if(L_ini(n_init).le.L_ini_min)then
            L_ini(n_init)=L_ini_min
            goto 402
         endif
      enddo
      n_init=n_init+1
      L_ini(n_init)=L_ini_min
 402  continue

******************************************************************
*     find the maximum score starting from local structures superposition
******************************************************************
      score_max=-1              !TM-score
      do 333 i_init=1,n_init
        L_init=L_ini(i_init)
        iL_max=n_ali-L_init+1
        k=0
        do i=1,iL_max,40        !this is the simplification!
          k=k+1
          iL0(k)=i
        enddo
        if(iL0(k).lt.iL_max)then
          k=k+1
          iL0(k)=iL_max
        endif
        n_shift=k
        do 300 i_shift=1,n_shift
           iL=iL0(i_shift)
           LL=0
           ka=0
           do i=1,L_init
              k=iL+i-1          ![1,n_ali] common aligned
              r_1(1,i)=xa(iA(k))
              r_1(2,i)=ya(iA(k))
              r_1(3,i)=za(iA(k))
              r_2(1,i)=xb(iB(k))
              r_2(2,i)=yb(iB(k))
              r_2(3,i)=zb(iB(k))
              LL=LL+1
              ka=ka+1
              k_ali(ka)=k
           enddo
           call u3b(w,r_1,r_2,LL,1,rms,u,t,ier) !u rotate r_1 to r_2
           if(i_init.eq.1)then  !global superposition
              armsd=dsqrt(rms/LL)
              Rcomm=armsd
           endif
           do j=1,nseqA
              xt(j)=t(1)+u(1,1)*xa(j)+u(1,2)*ya(j)+u(1,3)*za(j)
              yt(j)=t(2)+u(2,1)*xa(j)+u(2,2)*ya(j)+u(2,3)*za(j)
              zt(j)=t(3)+u(3,1)*xa(j)+u(3,2)*ya(j)+u(3,3)*za(j)
           enddo
           d=d0_search-1
           call score_fun8       !init, get scores, n_cut+i_ali(i) for iteration
           if(score_max.lt.score)then
              score_max=score
              ka0=ka
              do i=1,ka0
                 k_ali0(i)=k_ali(i)
              enddo
           endif
***   iteration for extending ---------------------------------->
           d=d0_search+1
           do 301 it=1,n_it
              LL=0
              ka=0
              do i=1,n_cut
                 m=i_ali(i)     ![1,n_ali]
                 r_1(1,i)=xa(iA(m))
                 r_1(2,i)=ya(iA(m))
                 r_1(3,i)=za(iA(m))
                 r_2(1,i)=xb(iB(m))
                 r_2(2,i)=yb(iB(m))
                 r_2(3,i)=zb(iB(m))
                 ka=ka+1
                 k_ali(ka)=m
                 LL=LL+1
              enddo
              call u3b(w,r_1,r_2,LL,1,rms,u,t,ier) !u rotate r_1 to r_2
              do j=1,nseqA
                 xt(j)=t(1)+u(1,1)*xa(j)+u(1,2)*ya(j)+u(1,3)*za(j)
                 yt(j)=t(2)+u(2,1)*xa(j)+u(2,2)*ya(j)+u(2,3)*za(j)
                 zt(j)=t(3)+u(3,1)*xa(j)+u(3,2)*ya(j)+u(3,3)*za(j)
              enddo
              call score_fun8    !get scores, n_cut+i_ali(i) for iteration
              if(score_max.lt.score)then
                 score_max=score
                 ka0=ka
                 do i=1,ka
                    k_ali0(i)=k_ali(i)
                 enddo
              endif
              if(it.eq.n_it)goto 302
              if(n_cut.eq.ka)then
                 neq=0
                 do i=1,n_cut
                    if(i_ali(i).eq.k_ali(i))neq=neq+1
                 enddo
                 if(n_cut.eq.neq)goto 302
              endif
 301       continue             !for iteration
 302       continue
 300    continue                !for shift
 333  continue                  !for initial length, L_ali/M

******** return the final rotation ****************
      LL=0
      do i=1,ka0
         m=k_ali0(i)            !record of the best alignment
         r_1(1,i)=xa(iA(m))
         r_1(2,i)=ya(iA(m))
         r_1(3,i)=za(iA(m))
         r_2(1,i)=xb(iB(m))
         r_2(2,i)=yb(iB(m))
         r_2(3,i)=zb(iB(m))
         LL=LL+1
      enddo
      call u3b(w,r_1,r_2,LL,1,rms,u,t,ier) !u rotate r_1 to r_2
      do j=1,nseqA
         x1(j)=t(1)+u(1,1)*xa(j)+u(1,2)*ya(j)+u(1,3)*za(j)
         y1(j)=t(2)+u(2,1)*xa(j)+u(2,2)*ya(j)+u(2,3)*za(j)
         z1(j)=t(3)+u(3,1)*xa(j)+u(3,2)*ya(j)+u(3,3)*za(j)
      enddo
      TM=score_max

c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      return
      END

*************************************************************************
*************************************************************************
*     This is a subroutine to compare two structures and find the 
*     superposition that has the maximum TM-score.
*
*     L1--Length of the first structure
*     (x1(i),y1(i),z1(i))--coordinates of i'th residue at the first structure
*     n1(i)--Residue sequence number of i'th residue at the first structure
*     L2--Length of the second structure
*     (x2(i),y2(i),z2(i))--coordinates of i'th residue at the second structure
*     n2(i)--Residue sequence number of i'th residue at the second structure
*     TM--TM-score of the comparison
*     Rcomm--RMSD of two structures in the common aligned residues
*     Lcomm--Length of the common aligned regions
*
*     Note: 
*     1, Always put native as the second structure, by which TM-score
*        is normalized.
*     2, The returned (x1(i),y1(i),z1(i)) are the rotated structure after
*        TM-score superposition.
*************************************************************************
*************************************************************************
***   dis<8, but same search engine
      subroutine TMscore8(dx,L1,x1,y1,z1,n1,L2,x2,y2,z2,n2,
     &     TM,Rcomm,Lcomm)
      PARAMETER(nmax=5000)
      common/stru/xt(nmax),yt(nmax),zt(nmax),xb(nmax),yb(nmax),zb(nmax)
      common/nres/nresA(nmax),nresB(nmax),nseqA,nseqB
      common/para/d,d0
      common/d0min/d0_min
      common/align/n_ali,iA(nmax),iB(nmax)
      common/nscore/i_ali(nmax),n_cut ![1,n_ali],align residues for the score
      dimension k_ali(nmax),k_ali0(nmax)
      dimension L_ini(100),iq(nmax)
      common/scores/score
      double precision score,score_max
      dimension xa(nmax),ya(nmax),za(nmax)

      dimension x1(nmax),y1(nmax),z1(nmax),n1(nmax)
      dimension x2(nmax),y2(nmax),z2(nmax),n2(nmax)
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
ccc   RMSD:
      double precision r_1(3,nmax),r_2(3,nmax),r_3(3,nmax),w(nmax)
      double precision u(3,3),t(3),rms,drms !armsd is real
      data w /nmax*1.0/
ccc   

********* convert input data ***************************
*     because L1=L2 in this special case---------->
      nseqA=L1
      nseqB=L2
      do i=1,nseqA
         xa(i)=x1(i)
         ya(i)=y1(i)
         za(i)=z1(i)
         nresA(i)=n1(i)
         xb(i)=x2(i)
         yb(i)=y2(i)
         zb(i)=z2(i)
         nresB(i)=n2(i)
         iA(i)=i
         iB(i)=i
      enddo
      n_ali=L1                  !number of aligned residues
      Lcomm=L1

************/////
*     parameters:
*****************
***   d0------------->
      d0=dx
      if(d0.lt.d0_min)d0=d0_min
***   d0_search ----->
      d0_search=d0
      if(d0_search.gt.8)d0_search=8
      if(d0_search.lt.4.5)d0_search=4.5
***   iterative parameters ----->
      n_it=20                   !maximum number of iterations
      d_output=5                !for output alignment
      n_init_max=6              !maximum number of L_init
      n_init=0
      L_ini_min=4
      if(n_ali.lt.4)L_ini_min=n_ali
      do i=1,n_init_max-1
         n_init=n_init+1
         L_ini(n_init)=n_ali/2**(n_init-1)
         if(L_ini(n_init).le.L_ini_min)then
            L_ini(n_init)=L_ini_min
            goto 402
         endif
      enddo
      n_init=n_init+1
      L_ini(n_init)=L_ini_min
 402  continue

******************************************************************
*     find the maximum score starting from local structures superposition
******************************************************************
      score_max=-1              !TM-score
      do 333 i_init=1,n_init
        L_init=L_ini(i_init)
        iL_max=n_ali-L_init+1
        do 300 iL=1,iL_max    !on aligned residues, [1,nseqA]
           LL=0
           ka=0
           do i=1,L_init
              k=iL+i-1          ![1,n_ali] common aligned
              r_1(1,i)=xa(iA(k))
              r_1(2,i)=ya(iA(k))
              r_1(3,i)=za(iA(k))
              r_2(1,i)=xb(iB(k))
              r_2(2,i)=yb(iB(k))
              r_2(3,i)=zb(iB(k))
              LL=LL+1
              ka=ka+1
              k_ali(ka)=k
           enddo
           call u3b(w,r_1,r_2,LL,1,rms,u,t,ier) !u rotate r_1 to r_2
           if(i_init.eq.1)then  !global superposition
              armsd=dsqrt(rms/LL)
              Rcomm=armsd
           endif
           do j=1,nseqA
              xt(j)=t(1)+u(1,1)*xa(j)+u(1,2)*ya(j)+u(1,3)*za(j)
              yt(j)=t(2)+u(2,1)*xa(j)+u(2,2)*ya(j)+u(2,3)*za(j)
              zt(j)=t(3)+u(3,1)*xa(j)+u(3,2)*ya(j)+u(3,3)*za(j)
           enddo
           d=d0_search-1
           call score_fun8       !init, get scores, n_cut+i_ali(i) for iteration
           if(score_max.lt.score)then
              score_max=score
              ka0=ka
              do i=1,ka0
                 k_ali0(i)=k_ali(i)
              enddo
           endif
***   iteration for extending ---------------------------------->
           d=d0_search+1
           do 301 it=1,n_it
              LL=0
              ka=0
              do i=1,n_cut
                 m=i_ali(i)     ![1,n_ali]
                 r_1(1,i)=xa(iA(m))
                 r_1(2,i)=ya(iA(m))
                 r_1(3,i)=za(iA(m))
                 r_2(1,i)=xb(iB(m))
                 r_2(2,i)=yb(iB(m))
                 r_2(3,i)=zb(iB(m))
                 ka=ka+1
                 k_ali(ka)=m
                 LL=LL+1
              enddo
              call u3b(w,r_1,r_2,LL,1,rms,u,t,ier) !u rotate r_1 to r_2
              do j=1,nseqA
                 xt(j)=t(1)+u(1,1)*xa(j)+u(1,2)*ya(j)+u(1,3)*za(j)
                 yt(j)=t(2)+u(2,1)*xa(j)+u(2,2)*ya(j)+u(2,3)*za(j)
                 zt(j)=t(3)+u(3,1)*xa(j)+u(3,2)*ya(j)+u(3,3)*za(j)
              enddo
              call score_fun8    !get scores, n_cut+i_ali(i) for iteration
              if(score_max.lt.score)then
                 score_max=score
                 ka0=ka
                 do i=1,ka
                    k_ali0(i)=k_ali(i)
                 enddo
              endif
              if(it.eq.n_it)goto 302
              if(n_cut.eq.ka)then
                 neq=0
                 do i=1,n_cut
                    if(i_ali(i).eq.k_ali(i))neq=neq+1
                 enddo
                 if(n_cut.eq.neq)goto 302
              endif
 301       continue             !for iteration
 302       continue
 300    continue                !for shift
 333  continue                  !for initial length, L_ali/M

******** return the final rotation ****************
      LL=0
      do i=1,ka0
         m=k_ali0(i)            !record of the best alignment
         r_1(1,i)=xa(iA(m))
         r_1(2,i)=ya(iA(m))
         r_1(3,i)=za(iA(m))
         r_2(1,i)=xb(iB(m))
         r_2(2,i)=yb(iB(m))
         r_2(3,i)=zb(iB(m))
         LL=LL+1
      enddo
      call u3b(w,r_1,r_2,LL,1,rms,u,t,ier) !u rotate r_1 to r_2
      do j=1,nseqA
         x1(j)=t(1)+u(1,1)*xa(j)+u(1,2)*ya(j)+u(1,3)*za(j)
         y1(j)=t(2)+u(2,1)*xa(j)+u(2,2)*ya(j)+u(2,3)*za(j)
         z1(j)=t(3)+u(3,1)*xa(j)+u(3,2)*ya(j)+u(3,3)*za(j)
      enddo
      TM=score_max

c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      return
      END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     1, collect those residues with dis<d;
c     2, calculate score_GDT, score_maxsub, score_TM
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine score_fun8
      PARAMETER(nmax=5000)

      common/stru/xa(nmax),ya(nmax),za(nmax),xb(nmax),yb(nmax),zb(nmax)
      common/nres/nresA(nmax),nresB(nmax),nseqA,nseqB
      common/para/d,d0
      common/align/n_ali,iA(nmax),iB(nmax)
      common/nscore/i_ali(nmax),n_cut ![1,n_ali],align residues for the score
      common/scores/score
      double precision score,score_max
      common/d8/d8
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
      d_tmp=d
 21   n_cut=0                   !number of residue-pairs dis<d, for iteration
      score_sum=0               !TMscore
      do k=1,n_ali
         i=iA(k)                ![1,nseqA] reoder number of structureA
         j=iB(k)                ![1,nseqB]
         dis=sqrt((xa(i)-xb(j))**2+(ya(i)-yb(j))**2+(za(i)-zb(j))**2)
         if(dis.lt.d_tmp)then
            n_cut=n_cut+1
            i_ali(n_cut)=k      ![1,n_ali], mark the residue-pairs in dis<d
         endif
         if(dis.le.d8)then
            score_sum=score_sum+1/(1+(dis/d0)**2)+prfprf(i,j)         
         endif
      enddo
      if(n_cut.lt.3.and.n_ali.gt.3)then
         d_tmp=d_tmp+.5
         goto 21
      endif
      score=score_sum/float(nseqB) !TM-score
 

      return
      end

*************************************************************************
*************************************************************************
*     This is a subroutine to compare two structures and find the 
*     superposition that has the maximum TM-score.
*
*     L1--Length of the first structure
*     (x1(i),y1(i),z1(i))--coordinates of i'th residue at the first structure
*     n1(i)--Residue sequence number of i'th residue at the first structure
*     L2--Length of the second structure
*     (x2(i),y2(i),z2(i))--coordinates of i'th residue at the second structure
*     n2(i)--Residue sequence number of i'th residue at the second structure
*     TM--TM-score of the comparison
*     Rcomm--RMSD of two structures in the common aligned residues
*     Lcomm--Length of the common aligned regions
*
*     Note: 
*     1, Always put native as the second structure, by which TM-score
*        is normalized.
*     2, The returned (x1(i),y1(i),z1(i)) are the rotated structure after
*        TM-score superposition.
*************************************************************************
*************************************************************************
***  normal TM-score:
      subroutine TMscore(dx,L1,x1,y1,z1,n1,L2,x2,y2,z2,n2,
     &     TM,Rcomm,Lcomm)
      PARAMETER(nmax=5000)
      common/stru/xt(nmax),yt(nmax),zt(nmax),xb(nmax),yb(nmax),zb(nmax)
      common/nres/nresA(nmax),nresB(nmax),nseqA,nseqB
      common/para/d,d0
      common/d0min/d0_min
      common/align/n_ali,iA(nmax),iB(nmax)
      common/nscore/i_ali(nmax),n_cut ![1,n_ali],align residues for the score
      dimension k_ali(nmax),k_ali0(nmax)
      dimension L_ini(100),iq(nmax)
      common/scores/score
      double precision score,score_max
      dimension xa(nmax),ya(nmax),za(nmax)

      dimension x1(nmax),y1(nmax),z1(nmax),n1(nmax)
      dimension x2(nmax),y2(nmax),z2(nmax),n2(nmax)

ccc   RMSD:
      double precision r_1(3,nmax),r_2(3,nmax),r_3(3,nmax),w(nmax)
      double precision u(3,3),t(3),rms,drms !armsd is real
      data w /nmax*1.0/
ccc   
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
********* convert input data ***************************
*     because L1=L2 in this special case---------->
      nseqA=L1
      nseqB=L2
      do i=1,nseqA
         xa(i)=x1(i)
         ya(i)=y1(i)
         za(i)=z1(i)
         nresA(i)=n1(i)
         xb(i)=x2(i)
         yb(i)=y2(i)
         zb(i)=z2(i)
         nresB(i)=n2(i)
         iA(i)=i
         iB(i)=i
      enddo
      n_ali=L1                  !number of aligned residues
      Lcomm=L1

************/////
*     parameters:
*****************
***   d0------------->
c      d0=1.24*(nseqB-15)**(1.0/3.0)-1.8
      d0=dx
      if(d0.lt.d0_min)d0=d0_min
***   d0_search ----->
      d0_search=d0
      if(d0_search.gt.8)d0_search=8
      if(d0_search.lt.4.5)d0_search=4.5
***   iterative parameters ----->
      n_it=20                   !maximum number of iterations
      d_output=5                !for output alignment
      n_init_max=6              !maximum number of L_init
      n_init=0
      L_ini_min=4
      if(n_ali.lt.4)L_ini_min=n_ali
      do i=1,n_init_max-1
         n_init=n_init+1
         L_ini(n_init)=n_ali/2**(n_init-1)
         if(L_ini(n_init).le.L_ini_min)then
            L_ini(n_init)=L_ini_min
            goto 402
         endif
      enddo
      n_init=n_init+1
      L_ini(n_init)=L_ini_min
 402  continue

******************************************************************
*     find the maximum score starting from local structures superposition
******************************************************************
      score_max=-1              !TM-score
      score_max2=0
      do 333 i_init=1,n_init
        L_init=L_ini(i_init)
        iL_max=n_ali-L_init+1
        do 300 iL=1,iL_max      !on aligned residues, [1,nseqA]
           LL=0
           ka=0
           do i=1,L_init
              k=iL+i-1          ![1,n_ali] common aligned
              r_1(1,i)=xa(iA(k))
              r_1(2,i)=ya(iA(k))
              r_1(3,i)=za(iA(k))
              r_2(1,i)=xb(iB(k))
              r_2(2,i)=yb(iB(k))
              r_2(3,i)=zb(iB(k))
              LL=LL+1
              ka=ka+1
              k_ali(ka)=k
           enddo
           call u3b(w,r_1,r_2,LL,1,rms,u,t,ier) !u rotate r_1 to r_2
           if(i_init.eq.1)then  !global superposition
              armsd=dsqrt(rms/LL)
              Rcomm=armsd
           endif
           do j=1,nseqA
              xt(j)=t(1)+u(1,1)*xa(j)+u(1,2)*ya(j)+u(1,3)*za(j)
              yt(j)=t(2)+u(2,1)*xa(j)+u(2,2)*ya(j)+u(2,3)*za(j)
              zt(j)=t(3)+u(3,1)*xa(j)+u(3,2)*ya(j)+u(3,3)*za(j)
           enddo
           d=d0_search-1
           call score_fun       !init, get scores, n_cut+i_ali(i) for iteration
           if(score_max.lt.score)then
              score_max=score
              ka0=ka
              do i=1,ka0
                 k_ali0(i)=k_ali(i)
              enddo
           endif
***   iteration for extending ---------------------------------->
           d=d0_search+1
           do 301 it=1,n_it
              LL=0
              ka=0
              do i=1,n_cut
                 m=i_ali(i)     ![1,n_ali]
                 r_1(1,i)=xa(iA(m))
                 r_1(2,i)=ya(iA(m))
                 r_1(3,i)=za(iA(m))
                 r_2(1,i)=xb(iB(m))
                 r_2(2,i)=yb(iB(m))
                 r_2(3,i)=zb(iB(m))
                 ka=ka+1
                 k_ali(ka)=m
                 LL=LL+1
              enddo
              call u3b(w,r_1,r_2,LL,1,rms,u,t,ier) !u rotate r_1 to r_2
              do j=1,nseqA
                 xt(j)=t(1)+u(1,1)*xa(j)+u(1,2)*ya(j)+u(1,3)*za(j)
                 yt(j)=t(2)+u(2,1)*xa(j)+u(2,2)*ya(j)+u(2,3)*za(j)
                 zt(j)=t(3)+u(3,1)*xa(j)+u(3,2)*ya(j)+u(3,3)*za(j)
              enddo
              call score_fun    !get scores, n_cut+i_ali(i) for iteration
              if(score_max.lt.score)then
                 score_max=score
                 ka0=ka
                 do i=1,ka
                    k_ali0(i)=k_ali(i)
                 enddo
              endif
              if(it.eq.n_it)goto 302
              if(n_cut.eq.ka)then
                 neq=0
                 do i=1,n_cut
                    if(i_ali(i).eq.k_ali(i))neq=neq+1
                 enddo
                 if(n_cut.eq.neq)goto 302
              endif
 301       continue             !for iteration
 302       continue
 300    continue                !for shift
 333  continue                  !for initial length, L_ali/M

******** return the final rotation ****************
      LL=0
      do i=1,ka0
         m=k_ali0(i)            !record of the best alignment
         r_1(1,i)=xa(iA(m))
         r_1(2,i)=ya(iA(m))
         r_1(3,i)=za(iA(m))
         r_2(1,i)=xb(iB(m))
         r_2(2,i)=yb(iB(m))
         r_2(3,i)=zb(iB(m))
         LL=LL+1
      enddo
      call u3b(w,r_1,r_2,LL,1,rms,u,t,ier) !u rotate r_1 to r_2
      do j=1,nseqA
         x1(j)=t(1)+u(1,1)*xa(j)+u(1,2)*ya(j)+u(1,3)*za(j)
         y1(j)=t(2)+u(2,1)*xa(j)+u(2,2)*ya(j)+u(2,3)*za(j)
         z1(j)=t(3)+u(3,1)*xa(j)+u(3,2)*ya(j)+u(3,3)*za(j)
      enddo
      TM=score_max

c^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      return
      END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     1, collect those residues with dis<d;
c     2, calculate score_GDT, score_maxsub, score_TM
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine score_fun
      PARAMETER(nmax=5000)

      common/stru/xa(nmax),ya(nmax),za(nmax),xb(nmax),yb(nmax),zb(nmax)
      common/nres/nresA(nmax),nresB(nmax),nseqA,nseqB
      common/para/d,d0
      common/align/n_ali,iA(nmax),iB(nmax)
      common/nscore/i_ali(nmax),n_cut ![1,n_ali],align residues for the score
      common/scores/score
      double precision score
      common/profiles/qprf(nmax,22),tprf(nmax,22),prfprf(nmax,nmax)
      d_tmp=d
 21   n_cut=0                   !number of residue-pairs dis<d, for iteration
      score_sum=0               !TMscore
      score_sum2=0              !PFalign
     
      do k=1,n_ali
         i=iA(k)                ![1,nseqA] reoder number of structureA
         j=iB(k)                ![1,nseqB]
         dis=sqrt((xa(i)-xb(j))**2+(ya(i)-yb(j))**2+(za(i)-zb(j))**2)

         if(dis.lt.d_tmp)then
            n_cut=n_cut+1
            i_ali(n_cut)=k      ![1,n_ali], mark the residue-pairs in dis<d
         endif    
         score_sum=score_sum + 1/(1+(dis/d0)**2)+prfprf(i,j)
      enddo
      if(n_cut.lt.3.and.n_ali.gt.3)then
         d_tmp=d_tmp+.5
         goto 21
      endif
      score=score_sum/float(nseqB) !TM-score
      return
      end

********************************************************************
*     Dynamic programming for alignment.
*     Input: score(i,j), and gap_open
*     Output: invmap(j)
*     
*     Please note this subroutine is not a correct implementation of 
*     the N-W dynamic programming because the score tracks back only 
*     one layer of the matrix. This code was exploited in TM-align 
*     because it is about 1.5 times faster than a complete N-W code
*     and does not influence much the final structure alignment result.
********************************************************************
      SUBROUTINE DP(NSEQ1,NSEQ2)
      PARAMETER(nmax=5000)
      LOGICAL*1 DIR
      common/dpc/score(nmax,nmax),gap_open,invmap(nmax)
      dimension DIR(0:nmax,0:nmax),VAL(0:nmax,0:nmax)
      common/speed/align_len1
      REAL H,V
      align_len1=0
***   initialize the matrix:
      val(0,0)=0
      do i=1,nseq1
        dir(i,0)=.false.
        val(i,0)=0
      enddo
      do j=1,nseq2
        dir(0,j)=.false.
        val(0,j)=0
        invmap(j)=-1
      enddo

***   decide matrix and path:
      DO j=1,NSEQ2
        DO i=1,NSEQ1
          D=VAL(i-1,j-1)+SCORE(i,j)
          H=VAL(i-1,j)
          if(DIR(i-1,j))H=H+GAP_OPEN
          V=VAL(i,j-1)
          if(DIR(i,j-1))V=V+GAP_OPEN
          
          IF((D.GE.H).AND.(D.GE.V)) THEN
            DIR(I,J)=.true.
            VAL(i,j)=D
          ELSE
            DIR(I,J)=.false.
            if(V.GE.H)then
              val(i,j)=v
            else
              val(i,j)=h
            end if
          ENDIF
        ENDDO
      ENDDO
      
***   extract the alignment:
      i=NSEQ1
      j=NSEQ2
      DO WHILE((i.GT.0).AND.(j.GT.0))
        IF(DIR(i,j))THEN
          invmap(j)=i
          align_len1=align_len1+1
          i=i-1
          j=j-1
        ELSE
          H=VAL(i-1,j)
          if(DIR(i-1,j))H=H+GAP_OPEN
          V=VAL(i,j-1)
          if(DIR(i,j-1))V=V+GAP_OPEN
          IF(V.GE.H) THEN
            j=j-1
          ELSE
            i=i-1
          ENDIF
        ENDIF
      ENDDO
     
c^^^^^^^^^^^^^^^Dynamical programming done ^^^^^^^^^^^^^^^^^^^
      return
      END

cccccccccccccccc Calculate sum of (r_d-r_m)^2 cccccccccccccccccccccccccc
c  w    - w(m) is weight for atom pair  c m           (given)
c  x    - x(i,m) are coordinates of atom c m in set x       (given)
c  y    - y(i,m) are coordinates of atom c m in set y       (given)
c  n    - n is number of atom pairs                         (given)
c  mode  - 0:calculate rms only                             (given)
c          1:calculate rms,u,t                              (takes longer)
c  rms   - sum of w*(ux+t-y)**2 over all atom pairs         (result)
c  u    - u(i,j) is   rotation  matrix for best superposition  (result)
c  t    - t(i)   is translation vector for best superposition  (result)
c  ier  - 0: a unique optimal superposition has been determined(result)
c       -1: superposition is not unique but optimal
c       -2: no result obtained because of negative weights w
c           or all weights equal to zero.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine u3b(w, x, y, n, mode, rms, u, t, ier)
      integer ip(9), ip2312(4), i, j, k, l, m1, m, ier, n, mode
      double precision w(1), x(3, 1), y(3, 1), u(3, 3), t(3), rms, sigma
      double precision r(3, 3), xc(3), yc(3), wc, a(3, 3), b(3, 3), e0, 
     &e(3), e1, e2, e3, d, spur, det, cof, h, g, cth, sth, sqrth, p, tol
     &, rr(6), rr1, rr2, rr3, rr4, rr5, rr6, ss(6), ss1, ss2, ss3, ss4, 
     &ss5, ss6, zero, one, two, three, sqrt3
      equivalence (rr(1), rr1), (rr(2), rr2), (rr(3), rr3), (rr(4), rr4)
     &, (rr(5), rr5), (rr(6), rr6), (ss(1), ss1), (ss(2), ss2), (ss(3), 
     &ss3), (ss(4), ss4), (ss(5), ss5), (ss(6), ss6), (e(1), e1), (e(2)
     &, e2), (e(3), e3)
      data sqrt3 / 1.73205080756888d+00 /
      data tol / 1.0d-2 /
      data zero / 0.0d+00 /
      data one / 1.0d+00 /
      data two / 2.0d+00 /
      data three / 3.0d+00 /
      data ip / 1, 2, 4, 2, 3, 5, 4, 5, 6 /
      data ip2312 / 2, 3, 1, 2 /
      

c 156 "rms.for"
      wc = zero
      rms = 0.0
      e0 = zero
      do 1 i = 1, 3
      xc(i) = zero
      yc(i) = zero
      t(i) = 0.0
      do 1 j = 1, 3
      d = zero
      if (i .eq. j) d = one
      u(i,j) = d
      a(i,j) = d
    1 r(i,j) = zero
      ier = -1
c**** DETERMINE CENTROIDS OF BOTH VECTOR SETS X AND Y
c 170 "rms.for"
      if (n .lt. 1) return 
c 172 "rms.for"
      ier = -2
      do 2 m = 1, n
      if (w(m) .lt. 0.0) return 
      wc = wc + w(m)
      do 2 i = 1, 3
      xc(i) = xc(i) + (w(m) * x(i,m))
    2 yc(i) = yc(i) + (w(m) * y(i,m))
      if (wc .le. zero) return 
      do 3 i = 1, 3
      xc(i) = xc(i) / wc
c**** DETERMINE CORRELATION MATRIX R BETWEEN VECTOR SETS Y AND X
c 182 "rms.for"
    3 yc(i) = yc(i) / wc
c 184 "rms.for"
      do 4 m = 1, n
      do 4 i = 1, 3
      e0 = e0 + (w(m) * (((x(i,m) - xc(i)) ** 2) + ((y(i,m) - yc(i)) ** 
     &2)))
c 187 "rms.for"
      d = w(m) * (y(i,m) - yc(i))
      do 4 j = 1, 3
c**** CALCULATE DETERMINANT OF R(I,J)
c 189 "rms.for"
    4 r(i,j) = r(i,j) + (d * (x(j,m) - xc(j)))
c 191 "rms.for"
      det = ((r(1,1) * ((r(2,2) * r(3,3)) - (r(2,3) * r(3,2)))) - (r(1,2
     &) * ((r(2,1) * r(3,3)) - (r(2,3) * r(3,1))))) + (r(1,3) * ((r(2,1)
     & * r(3,2)) - (r(2,2) * r(3,1))))
c**** FORM UPPER TRIANGLE OF TRANSPOSED(R)*R
c 194 "rms.for"
      sigma = det
c 196 "rms.for"
      m = 0
      do 5 j = 1, 3
      do 5 i = 1, j
      m = m + 1
c***************** EIGENVALUES *****************************************
c**** FORM CHARACTERISTIC CUBIC  X**3-3*SPUR*X**2+3*COF*X-DET=0
c 200 "rms.for"
    5 rr(m) = ((r(1,i) * r(1,j)) + (r(2,i) * r(2,j))) + (r(3,i) * r(3,j)
     &)
c 203 "rms.for"
      spur = ((rr1 + rr3) + rr6) / three
      cof = ((((((rr3 * rr6) - (rr5 * rr5)) + (rr1 * rr6)) - (rr4 * rr4)
     &) + (rr1 * rr3)) - (rr2 * rr2)) / three
c 205 "rms.for"
      det = det * det
      do 6 i = 1, 3
    6 e(i) = spur
c**** REDUCE CUBIC TO STANDARD FORM Y**3-3HY+2G=0 BY PUTTING X=Y+SPUR
c 208 "rms.for"
      if (spur .le. zero) goto 40
c 210 "rms.for"
      d = spur * spur
      h = d - cof
c**** SOLVE CUBIC. ROOTS ARE E1,E2,E3 IN DECREASING ORDER
c 212 "rms.for"
      g = (((spur * cof) - det) / two) - (spur * h)
c 214 "rms.for"
      if (h .le. zero) goto 8
      sqrth = dsqrt(h)
      d = ((h * h) * h) - (g * g)
      if (d .lt. zero) d = zero
      d = datan2(dsqrt(d),- g) / three
      cth = sqrth * dcos(d)
      sth = (sqrth * sqrt3) * dsin(d)
      e1 = (spur + cth) + cth
      e2 = (spur - cth) + sth
      e3 = (spur - cth) - sth
c.....HANDLE SPECIAL CASE OF 3 IDENTICAL ROOTS
c 224 "rms.for"
      if (mode) 10, 50, 10
c**************** EIGENVECTORS *****************************************
c 226 "rms.for"
    8 if (mode) 30, 50, 30
c 228 "rms.for"
   10 do 15 l = 1, 3, 2
      d = e(l)
      ss1 = ((d - rr3) * (d - rr6)) - (rr5 * rr5)
      ss2 = ((d - rr6) * rr2) + (rr4 * rr5)
      ss3 = ((d - rr1) * (d - rr6)) - (rr4 * rr4)
      ss4 = ((d - rr3) * rr4) + (rr2 * rr5)
      ss5 = ((d - rr1) * rr5) + (rr2 * rr4)
      ss6 = ((d - rr1) * (d - rr3)) - (rr2 * rr2)
      j = 1
      if (dabs(ss1) .ge. dabs(ss3)) goto 12
      j = 2
      if (dabs(ss3) .ge. dabs(ss6)) goto 13
   11 j = 3
      goto 13
   12 if (dabs(ss1) .lt. dabs(ss6)) goto 11
   13 d = zero
      j = 3 * (j - 1)
      do 14 i = 1, 3
      k = ip(i + j)
      a(i,l) = ss(k)
   14 d = d + (ss(k) * ss(k))
      if (d .gt. zero) d = one / dsqrt(d)
      do 15 i = 1, 3
   15 a(i,l) = a(i,l) * d
      d = ((a(1,1) * a(1,3)) + (a(2,1) * a(2,3))) + (a(3,1) * a(3,3))
      m1 = 3
      m = 1
      if ((e1 - e2) .gt. (e2 - e3)) goto 16
      m1 = 1
      m = 3
   16 p = zero
      do 17 i = 1, 3
      a(i,m1) = a(i,m1) - (d * a(i,m))
   17 p = p + (a(i,m1) ** 2)
      if (p .le. tol) goto 19
      p = one / dsqrt(p)
      do 18 i = 1, 3
   18 a(i,m1) = a(i,m1) * p
      goto 21
   19 p = one
      do 20 i = 1, 3
      if (p .lt. dabs(a(i,m))) goto 20
      p = dabs(a(i,m))
      j = i
   20 continue
      k = ip2312(j)
      l = ip2312(j + 1)
      p = dsqrt((a(k,m) ** 2) + (a(l,m) ** 2))
      if (p .le. tol) goto 40
      a(j,m1) = zero
      a(k,m1) = - (a(l,m) / p)
      a(l,m1) = a(k,m) / p
   21 a(1,2) = (a(2,3) * a(3,1)) - (a(2,1) * a(3,3))
      a(2,2) = (a(3,3) * a(1,1)) - (a(3,1) * a(1,3))
c****************** ROTATION MATRIX ************************************
c 282 "rms.for"
      a(3,2) = (a(1,3) * a(2,1)) - (a(1,1) * a(2,3))
c 284 "rms.for"
   30 do 32 l = 1, 2
      d = zero
      do 31 i = 1, 3
      b(i,l) = ((r(i,1) * a(1,l)) + (r(i,2) * a(2,l))) + (r(i,3) * a(3,l
     &))
c 288 "rms.for"
   31 d = d + (b(i,l) ** 2)
      if (d .gt. zero) d = one / dsqrt(d)
      do 32 i = 1, 3
   32 b(i,l) = b(i,l) * d
      d = ((b(1,1) * b(1,2)) + (b(2,1) * b(2,2))) + (b(3,1) * b(3,2))
      p = zero
      do 33 i = 1, 3
      b(i,2) = b(i,2) - (d * b(i,1))
   33 p = p + (b(i,2) ** 2)
      if (p .le. tol) goto 35
      p = one / dsqrt(p)
      do 34 i = 1, 3
   34 b(i,2) = b(i,2) * p
      goto 37
   35 p = one
      do 36 i = 1, 3
      if (p .lt. dabs(b(i,1))) goto 36
      p = dabs(b(i,1))
      j = i
   36 continue
      k = ip2312(j)
      l = ip2312(j + 1)
      p = dsqrt((b(k,1) ** 2) + (b(l,1) ** 2))
      if (p .le. tol) goto 40
      b(j,2) = zero
      b(k,2) = - (b(l,1) / p)
      b(l,2) = b(k,1) / p
   37 b(1,3) = (b(2,1) * b(3,2)) - (b(2,2) * b(3,1))
      b(2,3) = (b(3,1) * b(1,2)) - (b(3,2) * b(1,1))
      b(3,3) = (b(1,1) * b(2,2)) - (b(1,2) * b(2,1))
      do 39 i = 1, 3
      do 39 j = 1, 3
c****************** TRANSLATION VECTOR *********************************
c 320 "rms.for"
   39 u(i,j) = ((b(i,1) * a(j,1)) + (b(i,2) * a(j,2))) + (b(i,3) * a(j,3
     &))
   40 do 41 i = 1, 3
c********************** RMS ERROR **************************************
c 323 "rms.for"
   41 t(i) = ((yc(i) - (u(i,1) * xc(1))) - (u(i,2) * xc(2))) - (u(i,3)
     & * xc(3))
   50 do 51 i = 1, 3
      if (e(i) .lt. zero) e(i) = zero
   51 e(i) = dsqrt(e(i))
      ier = 0
      if (e2 .le. (e1 * 1.0d-05)) ier = -1
      d = e3
      if (sigma .ge. 0.0) goto 52
      d = - d
      if ((e2 - e3) .le. (e1 * 1.0d-05)) ier = -1
   52 d = (d + e2) + e1
      rms = (e0 - d) - d
      if (rms .lt. 0.0) rms = 0.0
      
      return 
c.....END U3B...........................................................
c----------------------------------------------------------
c                       THE END
c----------------------------------------------------------
c 338 "rms.for"
      end
      subroutine BLOSSUM
      PARAMETER(NAA=22)         !number of amino acid
      common/MATRIX/B(NAA,NAA)

      B(1 ,1 ) = 1.000   ! A A
      B(1 ,2 ) = 0.143   ! A B
      B(1 ,3 ) = 0.429   ! A C
      B(1 ,4 ) = 0.143   ! A D
      B(1 ,5 ) = 0.286   ! A E
      B(1 ,6 ) = 0.143   ! A F
      B(1 ,7 ) = 0.429   ! A G
      B(1 ,8 ) = 0.143   ! A H
      B(1 ,9 ) = 0.286   ! A I
      B(1 ,10) = 0.286   ! A K
      B(1 ,11) = 0.286   ! A L
      B(1 ,12) = 0.286   ! A M
      B(1 ,13) = 0.143   ! A N
      B(1 ,14) = 0.286   ! A P
      B(1 ,15) = 0.286   ! A Q
      B(1 ,16) = 0.286   ! A R
      B(1 ,17) = 0.571   ! A S
      B(1 ,18) = 0.429   ! A T
      B(1 ,19) = 0.429   ! A V
      B(1 ,20) = 0.000   ! A W
      B(1 ,21) = 0.429   ! A X
      B(1 ,22) = 0.143   ! A Y
      B(2 ,1 ) = 0.200   ! B A
      B(2 ,2 ) = 1.000   ! B B
      B(2 ,3 ) = 0.100   ! B C
      B(2 ,4 ) = 0.500   ! B D
      B(2 ,5 ) = 0.400   ! B E
      B(2 ,6 ) = 0.100   ! B F
      B(2 ,7 ) = 0.400   ! B G
      B(2 ,8 ) = 0.500   ! B H
      B(2 ,9 ) = 0.100   ! B I
      B(2 ,10) = 0.400   ! B K
      B(2 ,11) = 0.100   ! B L
      B(2 ,12) = 0.200   ! B M
      B(2 ,13) = 1.000   ! B N
      B(2 ,14) = 0.200   ! B P
      B(2 ,15) = 0.400   ! B Q
      B(2 ,16) = 0.400   ! B R
      B(2 ,17) = 0.500   ! B S
      B(2 ,18) = 0.400   ! B T
      B(2 ,19) = 0.100   ! B V
      B(2 ,20) = 0.000   ! B W
      B(2 ,21) = 0.300   ! B X
      B(2 ,22) = 0.200   ! B Y
      B(3 ,1 ) = 0.308   ! C A
      B(3 ,2 ) = 0.077   ! C B
      B(3 ,3 ) = 1.000   ! C C
      B(3 ,4 ) = 0.077   ! C D
      B(3 ,5 ) = 0.000   ! C E
      B(3 ,6 ) = 0.154   ! C F
      B(3 ,7 ) = 0.077   ! C G
      B(3 ,8 ) = 0.077   ! C H
      B(3 ,9 ) = 0.231   ! C I
      B(3 ,10) = 0.077   ! C K
      B(3 ,11) = 0.231   ! C L
      B(3 ,12) = 0.231   ! C M
      B(3 ,13) = 0.077   ! C N
      B(3 ,14) = 0.077   ! C P
      B(3 ,15) = 0.077   ! C Q
      B(3 ,16) = 0.077   ! C R
      B(3 ,17) = 0.231   ! C S
      B(3 ,18) = 0.231   ! C T
      B(3 ,19) = 0.231   ! C V
      B(3 ,20) = 0.154   ! C W
      B(3 ,21) = 0.154   ! C X
      B(3 ,22) = 0.154   ! C Y
      B(4 ,1 ) = 0.200   ! D A
      B(4 ,2 ) = 0.500   ! D B
      B(4 ,3 ) = 0.100   ! D C
      B(4 ,4 ) = 1.000   ! D D
      B(4 ,5 ) = 0.600   ! D E
      B(4 ,6 ) = 0.100   ! D F
      B(4 ,7 ) = 0.300   ! D G
      B(4 ,8 ) = 0.300   ! D H
      B(4 ,9 ) = 0.100   ! D I
      B(4 ,10) = 0.300   ! D K
      B(4 ,11) = 0.000   ! D L
      B(4 ,12) = 0.100   ! D M
      B(4 ,13) = 0.500   ! D N
      B(4 ,14) = 0.300   ! D P
      B(4 ,15) = 0.400   ! D Q
      B(4 ,16) = 0.200   ! D R
      B(4 ,17) = 0.400   ! D S
      B(4 ,18) = 0.300   ! D T
      B(4 ,19) = 0.100   ! D V
      B(4 ,20) = 0.000   ! D W
      B(4 ,21) = 0.300   ! D X
      B(4 ,22) = 0.100   ! D Y
      B(5 ,1 ) = 0.333   ! E A
      B(5 ,2 ) = 0.444   ! E B
      B(5 ,3 ) = 0.000   ! E C
      B(5 ,4 ) = 0.667   ! E D
      B(5 ,5 ) = 1.000   ! E E
      B(5 ,6 ) = 0.111   ! E F
      B(5 ,7 ) = 0.222   ! E G
      B(5 ,8 ) = 0.444   ! E H
      B(5 ,9 ) = 0.111   ! E I
      B(5 ,10) = 0.556   ! E K
      B(5 ,11) = 0.111   ! E L
      B(5 ,12) = 0.222   ! E M
      B(5 ,13) = 0.444   ! E N
      B(5 ,14) = 0.333   ! E P
      B(5 ,15) = 0.667   ! E Q
      B(5 ,16) = 0.444   ! E R
      B(5 ,17) = 0.444   ! E S
      B(5 ,18) = 0.333   ! E T
      B(5 ,19) = 0.222   ! E V
      B(5 ,20) = 0.111   ! E W
      B(5 ,21) = 0.333   ! E X
      B(5 ,22) = 0.222   ! E Y
      B(6 ,1 ) = 0.200   ! F A
      B(6 ,2 ) = 0.100   ! F B
      B(6 ,3 ) = 0.200   ! F C
      B(6 ,4 ) = 0.100   ! F D
      B(6 ,5 ) = 0.100   ! F E
      B(6 ,6 ) = 1.000   ! F F
      B(6 ,7 ) = 0.100   ! F G
      B(6 ,8 ) = 0.300   ! F H
      B(6 ,9 ) = 0.400   ! F I
      B(6 ,10) = 0.100   ! F K
      B(6 ,11) = 0.400   ! F L
      B(6 ,12) = 0.400   ! F M
      B(6 ,13) = 0.100   ! F N
      B(6 ,14) = 0.000   ! F P
      B(6 ,15) = 0.100   ! F Q
      B(6 ,16) = 0.100   ! F R
      B(6 ,17) = 0.200   ! F S
      B(6 ,18) = 0.200   ! F T
      B(6 ,19) = 0.300   ! F V
      B(6 ,20) = 0.500   ! F W
      B(6 ,21) = 0.300   ! F X
      B(6 ,22) = 0.700   ! F Y
      B(7 ,1 ) = 0.400   ! G A
      B(7 ,2 ) = 0.400   ! G B
      B(7 ,3 ) = 0.100   ! G C
      B(7 ,4 ) = 0.300   ! G D
      B(7 ,5 ) = 0.200   ! G E
      B(7 ,6 ) = 0.100   ! G F
      B(7 ,7 ) = 1.000   ! G G
      B(7 ,8 ) = 0.200   ! G H
      B(7 ,9 ) = 0.000   ! G I
      B(7 ,10) = 0.200   ! G K
      B(7 ,11) = 0.000   ! G L
      B(7 ,12) = 0.100   ! G M
      B(7 ,13) = 0.400   ! G N
      B(7 ,14) = 0.200   ! G P
      B(7 ,15) = 0.200   ! G Q
      B(7 ,16) = 0.200   ! G R
      B(7 ,17) = 0.400   ! G S
      B(7 ,18) = 0.200   ! G T
      B(7 ,19) = 0.100   ! G V
      B(7 ,20) = 0.200   ! G W
      B(7 ,21) = 0.300   ! G X
      B(7 ,22) = 0.100   ! G Y
      B(8 ,1 ) = 0.091   ! H A
      B(8 ,2 ) = 0.364   ! H B
      B(8 ,3 ) = 0.000   ! H C
      B(8 ,4 ) = 0.182   ! H D
      B(8 ,5 ) = 0.273   ! H E
      B(8 ,6 ) = 0.182   ! H F
      B(8 ,7 ) = 0.091   ! H G
      B(8 ,8 ) = 1.000   ! H H
      B(8 ,9 ) = 0.000   ! H I
      B(8 ,10) = 0.182   ! H K
      B(8 ,11) = 0.000   ! H L
      B(8 ,12) = 0.091   ! H M
      B(8 ,13) = 0.364   ! H N
      B(8 ,14) = 0.091   ! H P
      B(8 ,15) = 0.273   ! H Q
      B(8 ,16) = 0.273   ! H R
      B(8 ,17) = 0.182   ! H S
      B(8 ,18) = 0.091   ! H T
      B(8 ,19) = 0.000   ! H V
      B(8 ,20) = 0.091   ! H W
      B(8 ,21) = 0.182   ! H X
      B(8 ,22) = 0.455   ! H Y
      B(9 ,1 ) = 0.375   ! I A
      B(9 ,2 ) = 0.125   ! I B
      B(9 ,3 ) = 0.375   ! I C
      B(9 ,4 ) = 0.125   ! I D
      B(9 ,5 ) = 0.125   ! I E
      B(9 ,6 ) = 0.500   ! I F
      B(9 ,7 ) = 0.000   ! I G
      B(9 ,8 ) = 0.125   ! I H
      B(9 ,9 ) = 1.000   ! I I
      B(9 ,10) = 0.125   ! I K
      B(9 ,11) = 0.750   ! I L
      B(9 ,12) = 0.625   ! I M
      B(9 ,13) = 0.125   ! I N
      B(9 ,14) = 0.125   ! I P
      B(9 ,15) = 0.125   ! I Q
      B(9 ,16) = 0.125   ! I R
      B(9 ,17) = 0.250   ! I S
      B(9 ,18) = 0.375   ! I T
      B(9 ,19) = 0.875   ! I V
      B(9 ,20) = 0.125   ! I W
      B(9 ,21) = 0.375   ! I X
      B(9 ,22) = 0.375   ! I Y
      B(10,1 ) = 0.250   ! K A
      B(10,2 ) = 0.375   ! K B
      B(10,3 ) = 0.000   ! K C
      B(10,4 ) = 0.250   ! K D
      B(10,5 ) = 0.500   ! K E
      B(10,6 ) = 0.000   ! K F
      B(10,7 ) = 0.125   ! K G
      B(10,8 ) = 0.250   ! K H
      B(10,9 ) = 0.000   ! K I
      B(10,10) = 1.000   ! K K
      B(10,11) = 0.125   ! K L
      B(10,12) = 0.250   ! K M
      B(10,13) = 0.375   ! K N
      B(10,14) = 0.250   ! K P
      B(10,15) = 0.500   ! K Q
      B(10,16) = 0.625   ! K R
      B(10,17) = 0.375   ! K S
      B(10,18) = 0.250   ! K T
      B(10,19) = 0.125   ! K V
      B(10,20) = 0.000   ! K W
      B(10,21) = 0.250   ! K X
      B(10,22) = 0.125   ! K Y
      B(11,1 ) = 0.375   ! L A
      B(11,2 ) = 0.125   ! L B
      B(11,3 ) = 0.375   ! L C
      B(11,4 ) = 0.000   ! L D
      B(11,5 ) = 0.125   ! L E
      B(11,6 ) = 0.500   ! L F
      B(11,7 ) = 0.000   ! L G
      B(11,8 ) = 0.125   ! L H
      B(11,9 ) = 0.750   ! L I
      B(11,10) = 0.250   ! L K
      B(11,11) = 1.000   ! L L
      B(11,12) = 0.750   ! L M
      B(11,13) = 0.125   ! L N
      B(11,14) = 0.125   ! L P
      B(11,15) = 0.250   ! L Q
      B(11,16) = 0.250   ! L R
      B(11,17) = 0.250   ! L S
      B(11,18) = 0.375   ! L T
      B(11,19) = 0.625   ! L V
      B(11,20) = 0.250   ! L W
      B(11,21) = 0.375   ! L X
      B(11,22) = 0.375   ! L Y
      B(12,1 ) = 0.250   ! M A
      B(12,2 ) = 0.125   ! M B
      B(12,3 ) = 0.250   ! M C
      B(12,4 ) = 0.000   ! M D
      B(12,5 ) = 0.125   ! M E
      B(12,6 ) = 0.375   ! M F
      B(12,7 ) = 0.000   ! M G
      B(12,8 ) = 0.125   ! M H
      B(12,9 ) = 0.500   ! M I
      B(12,10) = 0.250   ! M K
      B(12,11) = 0.625   ! M L
      B(12,12) = 1.000   ! M M
      B(12,13) = 0.125   ! M N
      B(12,14) = 0.125   ! M P
      B(12,15) = 0.375   ! M Q
      B(12,16) = 0.250   ! M R
      B(12,17) = 0.250   ! M S
      B(12,18) = 0.250   ! M T
      B(12,19) = 0.500   ! M V
      B(12,20) = 0.250   ! M W
      B(12,21) = 0.250   ! M X
      B(12,22) = 0.250   ! M Y
      B(13,1 ) = 0.200   ! N A
      B(13,2 ) = 1.000   ! N B
      B(13,3 ) = 0.100   ! N C
      B(13,4 ) = 0.500   ! N D
      B(13,5 ) = 0.400   ! N E
      B(13,6 ) = 0.100   ! N F
      B(13,7 ) = 0.400   ! N G
      B(13,8 ) = 0.500   ! N H
      B(13,9 ) = 0.100   ! N I
      B(13,10) = 0.400   ! N K
      B(13,11) = 0.100   ! N L
      B(13,12) = 0.200   ! N M
      B(13,13) = 1.000   ! N N
      B(13,14) = 0.200   ! N P
      B(13,15) = 0.400   ! N Q
      B(13,16) = 0.400   ! N R
      B(13,17) = 0.500   ! N S
      B(13,18) = 0.400   ! N T
      B(13,19) = 0.100   ! N V
      B(13,20) = 0.000   ! N W
      B(13,21) = 0.300   ! N X
      B(13,22) = 0.200   ! N Y
      B(14,1 ) = 0.273   ! P A
      B(14,2 ) = 0.182   ! P B
      B(14,3 ) = 0.091   ! P C
      B(14,4 ) = 0.273   ! P D
      B(14,5 ) = 0.273   ! P E
      B(14,6 ) = 0.000   ! P F
      B(14,7 ) = 0.182   ! P G
      B(14,8 ) = 0.182   ! P H
      B(14,9 ) = 0.091   ! P I
      B(14,10) = 0.273   ! P K
      B(14,11) = 0.091   ! P L
      B(14,12) = 0.182   ! P M
      B(14,13) = 0.182   ! P N
      B(14,14) = 1.000   ! P P
      B(14,15) = 0.273   ! P Q
      B(14,16) = 0.182   ! P R
      B(14,17) = 0.273   ! P S
      B(14,18) = 0.273   ! P T
      B(14,19) = 0.182   ! P V
      B(14,20) = 0.000   ! P W
      B(14,21) = 0.182   ! P X
      B(14,22) = 0.091   ! P Y
      B(15,1 ) = 0.250   ! Q A
      B(15,2 ) = 0.375   ! Q B
      B(15,3 ) = 0.000   ! Q C
      B(15,4 ) = 0.375   ! Q D
      B(15,5 ) = 0.625   ! Q E
      B(15,6 ) = 0.000   ! Q F
      B(15,7 ) = 0.125   ! Q G
      B(15,8 ) = 0.375   ! Q H
      B(15,9 ) = 0.000   ! Q I
      B(15,10) = 0.500   ! Q K
      B(15,11) = 0.125   ! Q L
      B(15,12) = 0.375   ! Q M
      B(15,13) = 0.375   ! Q N
      B(15,14) = 0.250   ! Q P
      B(15,15) = 1.000   ! Q Q
      B(15,16) = 0.500   ! Q R
      B(15,17) = 0.375   ! Q S
      B(15,18) = 0.250   ! Q T
      B(15,19) = 0.125   ! Q V
      B(15,20) = 0.125   ! Q W
      B(15,21) = 0.250   ! Q X
      B(15,22) = 0.250   ! Q Y
      B(16,1 ) = 0.250   ! R A
      B(16,2 ) = 0.375   ! R B
      B(16,3 ) = 0.000   ! R C
      B(16,4 ) = 0.125   ! R D
      B(16,5 ) = 0.375   ! R E
      B(16,6 ) = 0.000   ! R F
      B(16,7 ) = 0.125   ! R G
      B(16,8 ) = 0.375   ! R H
      B(16,9 ) = 0.000   ! R I
      B(16,10) = 0.625   ! R K
      B(16,11) = 0.125   ! R L
      B(16,12) = 0.250   ! R M
      B(16,13) = 0.375   ! R N
      B(16,14) = 0.125   ! R P
      B(16,15) = 0.500   ! R Q
      B(16,16) = 1.000   ! R R
      B(16,17) = 0.250   ! R S
      B(16,18) = 0.250   ! R T
      B(16,19) = 0.000   ! R V
      B(16,20) = 0.000   ! R W
      B(16,21) = 0.250   ! R X
      B(16,22) = 0.125   ! R Y
      B(17,1 ) = 0.571   ! S A
      B(17,2 ) = 0.571   ! S B
      B(17,3 ) = 0.286   ! S C
      B(17,4 ) = 0.429   ! S D
      B(17,5 ) = 0.429   ! S E
      B(17,6 ) = 0.143   ! S F
      B(17,7 ) = 0.429   ! S G
      B(17,8 ) = 0.286   ! S H
      B(17,9 ) = 0.143   ! S I
      B(17,10) = 0.429   ! S K
      B(17,11) = 0.143   ! S L
      B(17,12) = 0.286   ! S M
      B(17,13) = 0.571   ! S N
      B(17,14) = 0.286   ! S P
      B(17,15) = 0.429   ! S Q
      B(17,16) = 0.286   ! S R
      B(17,17) = 1.000   ! S S
      B(17,18) = 0.571   ! S T
      B(17,19) = 0.143   ! S V
      B(17,20) = 0.000   ! S W
      B(17,21) = 0.429   ! S X
      B(17,22) = 0.143   ! S Y
      B(18,1 ) = 0.286   ! T A
      B(18,2 ) = 0.286   ! T B
      B(18,3 ) = 0.143   ! T C
      B(18,4 ) = 0.143   ! T D
      B(18,5 ) = 0.143   ! T E
      B(18,6 ) = 0.000   ! T F
      B(18,7 ) = 0.000   ! T G
      B(18,8 ) = 0.000   ! T H
      B(18,9 ) = 0.143   ! T I
      B(18,10) = 0.143   ! T K
      B(18,11) = 0.143   ! T L
      B(18,12) = 0.143   ! T M
      B(18,13) = 0.286   ! T N
      B(18,14) = 0.143   ! T P
      B(18,15) = 0.143   ! T Q
      B(18,16) = 0.143   ! T R
      B(18,17) = 0.429   ! T S
      B(18,18) = 1.000   ! T T
      B(18,19) = 0.286   ! T V
      B(18,20) = 0.000   ! T W
      B(18,21) = 0.286   ! T X
      B(18,22) = 0.000   ! T Y
      B(19,1 ) = 0.429   ! V A
      B(19,2 ) = 0.000   ! V B
      B(19,3 ) = 0.286   ! V C
      B(19,4 ) = 0.000   ! V D
      B(19,5 ) = 0.143   ! V E
      B(19,6 ) = 0.286   ! V F
      B(19,7 ) = 0.000   ! V G
      B(19,8 ) = 0.000   ! V H
      B(19,9 ) = 0.857   ! V I
      B(19,10) = 0.143   ! V K
      B(19,11) = 0.571   ! V L
      B(19,12) = 0.571   ! V M
      B(19,13) = 0.000   ! V N
      B(19,14) = 0.143   ! V P
      B(19,15) = 0.143   ! V Q
      B(19,16) = 0.000   ! V R
      B(19,17) = 0.143   ! V S
      B(19,18) = 0.429   ! V T
      B(19,19) = 1.000   ! V V
      B(19,20) = 0.000   ! V W
      B(19,21) = 0.286   ! V X
      B(19,22) = 0.286   ! V Y
      B(20,1 ) = 0.067   ! W A
      B(20,2 ) = 0.000   ! W B
      B(20,3 ) = 0.133   ! W C
      B(20,4 ) = 0.000   ! W D
      B(20,5 ) = 0.067   ! W E
      B(20,6 ) = 0.333   ! W F
      B(20,7 ) = 0.133   ! W G
      B(20,8 ) = 0.133   ! W H
      B(20,9 ) = 0.067   ! W I
      B(20,10) = 0.067   ! W K
      B(20,11) = 0.133   ! W L
      B(20,12) = 0.200   ! W M
      B(20,13) = 0.000   ! W N
      B(20,14) = 0.000   ! W P
      B(20,15) = 0.133   ! W Q
      B(20,16) = 0.067   ! W R
      B(20,17) = 0.067   ! W S
      B(20,18) = 0.133   ! W T
      B(20,19) = 0.067   ! W V
      B(20,20) = 1.000   ! W W
      B(20,21) = 0.133   ! W X
      B(20,22) = 0.400   ! W Y
      B(21,1 ) = 0.000   ! X A
      B(21,2 ) = 0.000   ! X B
      B(21,3 ) = 0.000   ! X C
      B(21,4 ) = 0.000   ! X D
      B(21,5 ) = 0.000   ! X E
      B(21,6 ) = 0.000   ! X F
      B(21,7 ) = 1.000   ! X G
      B(21,8 ) = 0.000   ! X H
      B(21,9 ) = 0.000   ! X I
      B(21,10) = 0.000   ! X K
      B(21,11) = 0.000   ! X L
      B(21,12) = 0.000   ! X M
      B(21,13) = 0.000   ! X N
      B(21,14) = 0.000   ! X P
      B(21,15) = 0.000   ! X Q
      B(21,16) = 0.500   ! X R
      B(21,17) = 0.000   ! X S
      B(21,18) = 0.000   ! X T
      B(21,19) = 0.000   ! X V
      B(21,20) = 0.000   ! X W
      B(21,21) = 1.000   ! X X
      B(21,22) = 0.000   ! X Y
      B(22,1 ) = 0.100   ! Y A
      B(22,2 ) = 0.100   ! Y B
      B(22,3 ) = 0.100   ! Y C
      B(22,4 ) = 0.000   ! Y D
      B(22,5 ) = 0.100   ! Y E
      B(22,6 ) = 0.600   ! Y F
      B(22,7 ) = 0.000   ! Y G
      B(22,8 ) = 0.500   ! Y H
      B(22,9 ) = 0.200   ! Y I
      B(22,10) = 0.100   ! Y K
      B(22,11) = 0.200   ! Y L
      B(22,12) = 0.200   ! Y M
      B(22,13) = 0.100   ! Y N
      B(22,14) = 0.000   ! Y P
      B(22,15) = 0.200   ! Y Q
      B(22,16) = 0.100   ! Y R
      B(22,17) = 0.100   ! Y S
      B(22,18) = 0.100   ! Y T
      B(22,19) = 0.200   ! Y V
      B(22,20) = 0.500   ! Y W
      B(22,21) = 0.200   ! Y X
      B(22,22) = 1.000   ! Y Y
      return
      end subroutine
