#!/usr/bin/perl
use strict;
use File::Basename;
use Cwd 'abs_path';

my $docstring=<<EOF
   change 'FilePath' in Scwrl4 configuration file ../bin/Scwrl4/Scwrl4.ini
EOF
;

my $scwrl_ini_file=abs_path(dirname(abs_path(__FILE__))."/../bin/Scwrl4/Scwrl4.ini");
my $bbDepRotLib_bin=abs_path(dirname(abs_path(__FILE__))."/../bin/Scwrl4/bbDepRotLib.bin");
die "FATAL ERROR! Cannot locate Scwrl4 configuration file $scwrl_ini_file\n" if (!-s "$scwrl_ini_file");
print "parsing path for $scwrl_ini_file\n";

my $txt='';
open(fp,"<$scwrl_ini_file");
while (my $line=<fp>){
    if ($line=~/FilePath/){
        $txt.="\tFilePath\t=\t$bbDepRotLib_bin\n"
    }
    else{
        $txt.="$line";
    }
}
close(fp);
open(fp,">$scwrl_ini_file");
print fp "$txt";
close(fp);
